2002-12-03  David Hyatt  <hyatt@apple.com>

	Fix for 3078227, hanging in table code.  Make sure <form>s
	don't get wrapped in anonymous rows and cells.
	
        Reviewed by: rjw

        * khtml/rendering/render_table.cpp:
        (RenderTable::addChild):
        (RenderTableSection::addChild):
        (RenderTableRow::addChild):

2002-12-03  David Hyatt  <hyatt@apple.com>

	Backing out a file that I did not intend to check in.

        * khtml/misc/loader.cpp:

2002-12-03  Richard Williamson   <rjw@apple.com>

        D'oh.  Fixed last minute change that broke the build.
        
        * kwq/KWQFont.mm:
        (QFont::getNSFont):

2002-12-03  David Hyatt  <hyatt@apple.com>

	Remove the moveWidgetsAside function.  This fixes all the
	form controls on livepage.apple.com that were getting hosed
	by the scrolling marquee.
	
        Reviewed by: darin

        * khtml/html/html_tableimpl.cpp:
        (HTMLTableRowElementImpl::addChild):
        * khtml/misc/loader.cpp:
        * khtml/rendering/render_root.cpp:
        (RenderRoot::layout):
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::KWQKHTMLPart):
        (KWQKHTMLPart::paint):

2002-12-03  Richard Williamson   <rjw@apple.com>

        Fixed 3019986.  Use an array of font families instead of a single
        font family to support CSS family lists.
        r=hyatt
                
        * kwq/KWQFont.h:
        * kwq/KWQFont.mm:
        (QFont::getNSFont):
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):
        (QFontMetrics::floatWidth):
        (QFontMetrics::floatCharacterWidths):
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        (QPainter::drawUnderlineForText):
        * kwq/WebCoreTextRenderer.h:
        * kwq/WebCoreTextRendererFactory.h:
        * kwq/WebCoreTextRendererFactory.m:
        (-[WebCoreTextRendererFactory rendererWithFamilies:traits:size:]):
        (-[WebCoreTextRendererFactory fontWithFamilies:traits:size:]):

2002-12-03  David Hyatt  <hyatt@apple.com>

	Fix for 3112599, aol.com shopping page doesn't work.  Apply
	the same form demotion trick to <tr> that I did already for
	<tbody> and <table>.

	r=gramps
	
        * khtml/html/dtd.cpp:
        (DOM::checkChild):
        * khtml/html/html_tableimpl.cpp:
        (HTMLTableRowElementImpl::addChild):
        * khtml/html/html_tableimpl.h:

2002-12-03  David Hyatt  <hyatt@apple.com>

	Fix link feedback regression on aintitcool.com.  Observe
	the wacky feedback we give now (yes, it matches MacIE and
	Gecko).  Gotta love this malformed page.

	<a><h4>...</h4></a>

	r=mjs
	
        * khtml/rendering/render_object.cpp:
        (RenderObject::nodeAtPoint):

2002-12-03  David Hyatt  <hyatt@apple.com>

	Eliminate the KONQBLOCK hack.  Fixes ipodhacks.com (a mislayout
	caused by malformed html... <table><br>...)

	r=mjs
	
        * khtml/css/html4.css:
        * khtml/html/dtd.cpp:
        (DOM::checkChild):
        * khtml/html/html_elementimpl.cpp:
        (HTMLElementImpl::isInline):
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::reset):
        (KHTMLParser::insertNode):
        * khtml/html/htmlparser.h:
        * khtml/misc/htmltags.c:
        (hash_tag):
        (findTag):
        * khtml/misc/htmltags.h:
        * khtml/misc/htmltags.in:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-12-02  David Hyatt  <hyatt@apple.com>

	Fix for 3032557, wsj.com DHTML elements in the wrong position.
	This patch adds support for img.x and img.y (a Mozilla extension
	from NS4 days), which is used by the site to position the menus.

	r=kocienda on the patch.
	
        * khtml/dom/html_image.cpp:
        (HTMLImageElement::x):
        (HTMLImageElement::y):
        * khtml/dom/html_image.h:
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLElement::getValueProperty):
        * khtml/ecma/kjs_html.h:
        * khtml/ecma/kjs_html.lut.h:

2002-12-02  David Hyatt  <hyatt@apple.com>

	Undo my changes to margin collapsing for blocks inside inlines.
	Although they may be correct in a strict mode, they don't
	work with the real-world Web.  For now, I'm just backing out
	the code.  The CSS WG hasn't decided how this should work yet
	anyway, so I'll just let the quirk behavior be our behavior
	in both modes.

	This fixes aintitcool.com.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-12-01  David Hyatt  <hyatt@apple.com>

	Convert the WebCore cache from LRU to size-adjusted and
	popularity-aware LRU (LRU-SP).  With the improved cache,
	the size restriction on images can be relaxed back to 40K
	(from 16K) while retaining the same score on cvs-base.
	This should result in better real-world performance.
	
        * khtml/misc/loader.cpp:
        (CachedObject::ref):
        (CachedObject::setSize):
        (m_tail):
        (LRUList::~LRUList):
        (Cache::flush):
        (FastLog2):
        (Cache::getLRUListFor):
        (Cache::removeFromLRUList):
        (Cache::insertInLRUList):
        (Cache::adjustSize):
        * khtml/misc/loader.h:

2002-11-29  Don Melton  <gramps@apple.com>

        * khtml/css/html4.css:

        Finally tweak headline font sizes and margins to match Gecko and CSS
        standard:
            - increase H1 font-size from 1.7em to 2em
            - increase H2 font-size from 1.4em to 1.5em
            - make H2 top and bottom margin match (bottom was strangely .87em)
            - increase H4 margin from 1.0em to 1.33em

2002-11-27  David Hyatt  <hyatt@apple.com>

	Fix DHTML on phoenix.com.  Add support for window.addEventListener
	and window.removeEventListener.
	
        * khtml/ecma/kjs_window.cpp:
        (Window::get):
        (WindowFunc::tryCall):
        * khtml/ecma/kjs_window.h:
        * khtml/ecma/kjs_window.lut.h:

2002-11-27  Maciej Stachowiak  <mjs@apple.com>

	- avoid doing any work when setting the document's link colors if
	there is no change. This avoids superfluous style updates and
	results in a 20% improvment on the JavaScript iBench.
	
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocument::putValue):

2002-11-27  David Hyatt  <hyatt@apple.com>

	Fix <br clear=""> and <br clear> to just behave like <br>
	rather than <br clear="all">.  Matches behavior in other
	browsers.
	
        * khtml/html/html_inlineimpl.cpp:
        (HTMLBRElementImpl::parseAttribute):

2002-11-27  David Hyatt  <hyatt@apple.com>

        Numerous overflow: hidden improvements to fix espn.com.

	First stop absolute positioned overflow hidden elements
	from growing to accommodate their overflow.  (Actually
	absolute positioned elements should never grow to do this,
	but fixing it for non-overflow hidden elements is hard,
	so later.)

	Second fix the render layer code to not allow background/borders
	of the object with overflow: hidden from being clipped.  This
	involves an extra paint step where the object paints its
	background and borders prior to establishing the clip rect
	for the children.  (This will also be necessary for overflow:auto
	and overflow:scroll).
	
        * ChangeLog:
        * khtml/rendering/render_box.cpp:
        (RenderBox::getClipRect):
        (RenderBox::calcAbsoluteVertical):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint):
        * khtml/rendering/render_object.h:

2002-11-27  David Hyatt  <hyatt@apple.com>

        * khtml/rendering/render_box.cpp:
        (RenderBox::getClipRect):
        (RenderBox::calcAbsoluteVertical):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint):

2002-11-27  David Hyatt  <hyatt@apple.com>

	Fix for 3105502.  drop-downs wrapping to next line.
	
        * khtml/css/html4.css:

2002-11-26  David Hyatt  <hyatt@apple.com>

	Smarter block inside inline handling.  Eliminate whitespace
	that is in between blocks inside inilnes.
	
        * khtml/xml/dom_textimpl.cpp:
        (TextImpl::attach):

2002-11-26  David Hyatt  <hyatt@apple.com>

	Don't let blocks inside inlines collapse with their surroundings
	ever.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-11-26  David Hyatt  <hyatt@apple.com>

	Fix a collapsing margin regression on aintitcool caused by
	my support of blocks inside inlines.  A block could be wrapped
	by an inline, e.g., <font><p>foo</p></font>, and in this case,
	you do not apply the collapsing margin quirk.  The margin stays.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-11-26  David Hyatt  <hyatt@apple.com>

	Fix the font family stuff to be refcounted, so copying
	fonts stays cheap.  Re-enabling it.

	Patch the render_arena code with some debugging info
	to help detect when memory gets trashed.

	Fix the background painting code to deal with negative
	x and y bakcground positions.  Fixes the brain on
	brainjar.com.
	
        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/render_arena.cpp:
        (RenderArena::free):
        * khtml/rendering/render_box.cpp:
        (RenderBox::paintBackground):
        * kwq/KWQFont.h:
        * kwq/KWQFont.mm:
        (QFontFamily::QFontFamily):
        (QFontFamily::operator=):

=== Alexander-34 ===

2002-11-26  David Hyatt  <hyatt@apple.com>

	Backing out support for multiple font families for now.
	The support is still there in QFont.  I've just stopped
	the style selector from walking the entire value list (it
	will only put the first family into the font).

	The original change  caused a 5% perf regression.  
	I'm going to see what kinds of tricks I can pull to get 
	some of this back before re-enabling the feature.
	
        * khtml/css/cssstyleselector.cpp:

2002-11-26  David Hyatt  <hyatt@apple.com>

	Fix render object removal to remerge adjacent anonymous inline boxes
	when an intervening block box gets removed.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::removeChild):
        * khtml/rendering/render_flow.h:

2002-11-25  Richard Williamson   <rjw@apple.com>

        Cleanup up leaking objects in page cache.
        
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURLFromPageCache):
        * kwq/WebCoreBridge.mm:
        (-[KWQPageState initWithDocument:DOM::URL:windowProperties:KJS::locationProperties:KJS::]):
        (-[KWQPageState dealloc]):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Added check for non-nil doc.
        
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::setView):

2002-11-25  David Hyatt  <hyatt@apple.com>

	Fix for the DHTML on hrweb.  With these changes it works
	except for some odd vertical spacing issues.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::addChildToFlow):
        (RenderFlow::makeChildrenNonInline):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Tweaked some debugging info.
        
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::~DocumentImpl):
        (DocumentImpl::detach):

2002-11-25  Chris Blumenberg  <cblu@apple.com>

	Use ^= to refer to OBJECTs with TYPEs that start with "image/". This is better than hard-coding image mime types.

        * khtml/css/html4.css:

2002-11-25  Chris Blumenberg  <cblu@apple.com>

	Fixed: 2987001 - spurious mime-type errors from <object> images

	KHTML didn't seem to have any clean support for OBJECT tags that are images. Added support for that.

        * khtml/css/html4.css: OBJECTs that are images should be rendered inline
        * khtml/html/html_objectimpl.cpp:
        (HTMLObjectElementImpl::attach): if the type is an image, create a render image
        * khtml/rendering/render_image.cpp:
        (RenderImage::updateFromElement): if the element is an object, use DATA for the URL
        * kwq/KWQDOMNode.cpp:
        (isImage): if it is an OBJECT element, check the type
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementAtPoint:]): if the element is an object, use DATA for the URL

2002-11-25  David Hyatt  <hyatt@apple.com>

	Fix this even further.  JUst drop support for arbitrary
	property lookup by name on the document.  Mac IE and
	Gecko only do this for img and form, and this makes things
	a lot faster.
	
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocument::hasProperty):
        (KJS::HTMLDocument::tryGet):

2002-11-25  David Hyatt  <hyatt@apple.com>

	Rewrite the img/form document property lookup strategy.  This
	should be faster and actually work (gasp!).  Fixes the dhtml
	on hrweb to at least show up.
	
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocument::tryGet):
        * khtml/html/html_miscimpl.cpp:
        (HTMLCollectionImpl::nextItem):

2002-11-25  David Hyatt  <hyatt@apple.com>

	Add support to QFont for multiple families.  NOw all that's left
	is getting the multiple families out of the font and down into
	WebKit.
	
        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/font.cpp:
        (Font::update):
        * khtml/rendering/font.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyle):
        * kwq/KWQFont.h:
        * kwq/KWQFont.mm:
        (QFontFamily::QFontFamily):
        (QFontFamily::operator=):
        (QFontFamily::family):
        (QFontFamily::setFamily):
        (QFontFamily::operator==):
        (QFont::QFont):
        (QFont::family):
        (QFont::setFamily):
        (QFont::getNSFontWithFamily):

2002-11-25  Richard Williamson   <rjw@apple.com>

        Changes for back/forward.  Currently disabled.

        * ForwardingHeaders/kjs/property_map.h: Added.
        * khtml/ecma/kjs_window.cpp:
        (Window::hasTimeouts):
        (WindowQObject::hasTimeouts):
        * khtml/ecma/kjs_window.h:
        * khtml/khtmlpart_p.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::DocumentImpl):
        (DocumentImpl::detach):
        (DocumentImpl::inPageCache):
        (DocumentImpl::setInPageCache):
        * khtml/xml/dom_docimpl.h:
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::setView):
        (KWQKHTMLPart::userAgent):
        (KWQKHTMLPart::nextKeyViewForWidget):
        (KWQKHTMLPart::canCachePage):
        (KWQKHTMLPart::saveWindowProperties):
        (KWQKHTMLPart::saveLocationProperties):
        (KWQKHTMLPart::restoreWindowProperties):
        (KWQKHTMLPart::restoreLocationProperties):
        (KWQKHTMLPart::openURLFromPageCache):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge openURL:reload:headers:lastModified:pageCache:]):
        (-[WebCoreBridge saveDocumentToPageCache]):
        (-[WebCoreBridge canCachePage]):
        (attributedString):
        (-[KWQPageState initWithDocument:DOM::URL:windowProperties:KJS::locationProperties:KJS::]):
        (-[KWQPageState dealloc]):
        (-[KWQPageState DOM::]):
        (-[KWQPageState URL]):
        (-[KWQPageState KJS::]):

2002-11-25  David Hyatt  <hyatt@apple.com>

	Fix for 3025963.  Ensure that KJS looks for the form on the
	element itself when pushing it onto the scope chain, since
	the <form> may not be an ancestor of the element.
	
        * khtml/ecma/kjs_html.cpp:
        (getForm):
        (KJS::HTMLElement::pushEventHandlerScope):
        * khtml/html/html_elementimpl.h:

2002-11-25  David Hyatt  <hyatt@apple.com>

	Fix for 3020493, another fun little margin collapsing quirk
	that I missed. (<td><div><p>).  The <div> has to pick up the quirk
	from the <p> so that the margins of the <p> still get collapsed
	away.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-11-25  David Hyatt  <hyatt@apple.com>

	Don't add in the halfleading for align=texttop. That's incorrect.
	
        * khtml/rendering/render_object.cpp:
        (RenderObject::getVerticalPosition):

2002-11-24  Maciej Stachowiak  <mjs@apple.com>

	Fixed support for onLoad handlers on images - this is in
	APPLE_CHANGES because khtml used a different mechanism. Also
	implemented onError on images. As a result:

	- fixed 3084916 - blank page at aol
	- fixed 3093162 - golfswitch doesn't work
	
        * khtml/html/html_imageimpl.cpp:
        (HTMLImageElementImpl::parseAttribute): Remove "implement this"
	comment from onError attribute.
        * khtml/misc/loader.h:
        * khtml/misc/loader.cpp:
        (CachedImage::CachedImage): Initialize m_loading to true.
	(CachedImage::ref): Send notifyFinished to the new client if the
	image is not loading.
        (CachedImage::data): If at eof, set m_loading to false and notify.
        (CachedImage::error): Set m_loading to false and notify.
	(CachedImage::checkNotify): New method to notify all clients of
	changes.
        * khtml/rendering/render_image.cpp:
        (RenderImage::notifyFinished): Deliver the appropriate choice of
	LOAD_EVENT or ERROR_EVENT.

2002-11-24  David Hyatt  <hyatt@apple.com>

	This landing adds support for blocks inside inlines.  It
	gets rid of the old broken way KHTML used to handle this
	and implements a brand new mechanism.

	With this change, I have decreased the tag priority of <font>
	and <a> to match other inlines (<i>, <span>, etc.), and I
	now allow all the inlines to contain blocks for relaxed parsing.

	Now if you open an <i> or a <b> and just leave it open across
	blocks, this will work.

	I also fixed a bad DHTML bug caused by the WebCoreBridge 
	forceLayout method.  The basic pattern is that someone does
	a tiny repaint of just a sliver of the window, then someone
	schedules a layout (which means they want a full repaint), but
	then drawRect comes along and calls forceLayout which unschedules
	the layout, thus preventing the full repaint from occurring.

	Any basic DHTML that used append/remove child was broken because
	of this pattern.  For now I have just removed the unscheduleLayout
	call at the end of forceLayout.
	
        * khtml/html/dtd.cpp:
        (DOM::checkChild):
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::popInlineBlocks):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::removeChild):
        (RenderContainer::removeLeftoverAnonymousBoxes):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::setStyle):
        (RenderFlow::layoutBlockChildren):
        (RenderFlow::continuationBefore):
        (cloneInline):
        (RenderFlow::splitInlines):
        (RenderFlow::splitFlow):
        (RenderFlow::addChildWithContinuation):
        (RenderFlow::addChild):
        (RenderFlow::addChildToFlow):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::mouseInside):
        * khtml/rendering/render_object.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::forceLayout):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge copyRenderNode:copier:]):

2002-11-24  Chris Blumenberg  <cblu@apple.com>

	Added element keys for the image ALT and link TITLE attributes. This will eventually be used to fix other bugs. Also made WebKit and WebCore use the same element keys to simplify the conversion of the element dictionary.

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementAtPoint:]):

2002-11-24  Darin Adler  <darin@apple.com>

        * force-js-clean-timestamp: Touch for ScopeChain change.

2002-11-24  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3067939 - no support for window.document.lastModified
	
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge openURL:reload:headers:lastModified:]): Set
	"modified" metadata based on passed in last mdified date.

2002-11-24  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3081946 - bookmarklet reports the wrong "windowfull" size

	This isn't really beta 1 material but the fix was so tirivial I
	couldn't resist.
	
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocument::tryGet): Use contentWidth and contentHeight
	for document.width and document.height instead of visibleWidth for
	both.

2002-11-22  Darin Adler  <darin@apple.com>

        * khtml/ecma/kjs_window.cpp: Remove _COLLECTOR hack.

        * kwq/WebCoreJavaScript.h:
        * kwq/WebCoreJavaScript.mm:
        (+[WebCoreJavaScript rootObjectClasses]):
	Update for name change -- root object classes, not all live object classes.

        * force-js-clean-timestamp: Make sure we don't have more build problems.

2002-11-22  David Hyatt  <hyatt@apple.com>

	Fix for 3107658, text doubling problem caused by layers being
	constructed for <td>s.  Just disallow positioning of <td>.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::setStyle):

2002-11-22  David Hyatt  <hyatt@apple.com>

	Oops. I meant to do that for <input type=button> and not
	<button>.  Just do it for <select>s for now.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcReplacedWidth):

2002-11-22  David Hyatt  <hyatt@apple.com>

	Make <select>s and <button>s ignore a CSS-specified width if that
	width is smaller than their intrinsic width.

	Fixes the <select> at the top of livepage.apple.com.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcReplacedWidth):

2002-11-22  Darin Adler  <darin@apple.com>

	- started checking in all our generated source files for the benefit of B&I

        * .cvsignore:
        * WebCore-combined.exp: Added.
        * khtml/css/.cvsignore:
        * khtml/css/cssproperties.c: Added.
        * khtml/css/cssproperties.h: Added.
        * khtml/css/cssvalues.c: Added.
        * khtml/css/cssvalues.h: Added.
        * khtml/ecma/.cvsignore:
        * khtml/ecma/kjs_css.lut.h: Added.
        * khtml/ecma/kjs_dom.lut.h: Added.
        * khtml/ecma/kjs_events.lut.h: Added.
        * khtml/ecma/kjs_html.lut.h: Added.
        * khtml/ecma/kjs_navigator.lut.h: Added.
        * khtml/ecma/kjs_range.lut.h: Added.
        * khtml/ecma/kjs_traversal.lut.h: Added.
        * khtml/ecma/kjs_views.lut.h: Added.
        * khtml/ecma/kjs_window.lut.h: Added.
        * khtml/html/.cvsignore:
        * khtml/html/kentities.c: Added.
        * khtml/misc/.cvsignore:
        * khtml/misc/htmlattrs.c: Added.
        * khtml/misc/htmlattrs.h: Added.
        * khtml/misc/htmltags.c: Added.
        * khtml/misc/htmltags.h: Added.
        * kwq/.cvsignore:
        * kwq/KWQCharsetData.c: Added.

2002-11-22  David Hyatt  <hyatt@apple.com>

	Fix for the table/form regressions.  Also landing beginnings
	of the block/inline work.
	
        * khtml/html/html_tableimpl.cpp:
        (HTMLTableSectionElementImpl::addChild):
        * khtml/html/html_tableimpl.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::RenderFlow):
        * khtml/rendering/render_flow.h:

2002-11-22  Darin Adler  <darin@apple.com>

        * khtml/ecma/kjs_dom.cpp: (DOMNode::pushEventHandlerScope): Change to push handlers
	on an existing scope chain rather than returning one. Name change too.
        * khtml/ecma/kjs_dom.h: More of the same.
        * khtml/ecma/kjs_html.cpp: (KJS::HTMLElement::pushEventHandlerScope): And here.
        * khtml/ecma/kjs_html.h: And here.

        * khtml/ecma/kjs_events.cpp: (JSEventListener::handleEvent): Use the pushEventHandlerScope
	function, and also don't worry about optimizing the "no change" case, because that already
	works pretty efficiently.

2002-11-22  David Hyatt  <hyatt@apple.com>

	Fix for the weather.com, slate and espn malformations that
	could occur.  Also reverting an earlier change for handling
	font tags like other inlines.  Both FONT and A need to be
	given special treatment until I can implement a strategy that
	will allow them to be handled just like the other inlines.
	
        * khtml/html/dtd.cpp:
        (DOM::checkChild):
        * khtml/html/html_elementimpl.cpp:
        (HTMLElementImpl::isInline):
        * khtml/html/html_elementimpl.h:
        * khtml/xml/dom_nodeimpl.h:

2002-11-21  Darin Adler  <darin@apple.com>

        * khtml/ecma/kjs_dom.cpp: (DOMNode::eventHandlerScope): List -> ScopeChain.
        * khtml/ecma/kjs_dom.h: List -> ScopeChain.
        * khtml/ecma/kjs_events.cpp: (JSEventListener::handleEvent): List -> ScopeChain.
        * khtml/ecma/kjs_html.cpp: (KJS::HTMLElement::eventHandlerScope): List -> ScopeChain.
        * khtml/ecma/kjs_html.h: List -> ScopeChain.

        * force-js-clean-timestamp: Not sure this is required, but better safe than sorry.

2002-11-21  Maciej Stachowiak  <mjs@apple.com>

        * force-js-clean-timestamp: Touch so other people's builds work.

2002-11-21  David Hyatt  <hyatt@apple.com>

	Nested <a>s are never allowed.  Make sure to always pop the
	<a> blocks.
	
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::getElement):

2002-11-21  David Hyatt  <hyatt@apple.com>

	Stop table cells from repainting the whole table when they
	get a repaint.  Gives another big boost to link rollover
	performance when links' containing blocks are table cells.
	
        * khtml/rendering/render_table.cpp:
        (RenderTableCell::repaint):

2002-11-21  David Hyatt  <hyatt@apple.com>

	Fix <font> so that behaves just like <i>, <b>, etc. Stop
	the (incorrect) allowance of blocks inside <font> tags.
	This fixes the mispositioning on avoyagetoarcturus.blogspot.com
	and fixes the vertical gaps on www.ve3d.com.
	
        * khtml/html/dtd.cpp:
        (DOM::checkChild):

2002-11-21  Maciej Stachowiak  <mjs@apple.com>

        * Makefile.am: Pass symroots for this tree to pbxbuild.

2002-11-21  David Hyatt  <hyatt@apple.com>

	Fixed for tables.  Make the percentage height calculation
	more robust.  Also add a hack for replaced elements to
	subtract out their margins when computing percentage widths.
	This keeps them from spilling out of table cells.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcReplacedWidth):
        (RenderBox::calcReplacedHeight):
        * khtml/rendering/render_table.cpp:
        (RenderTable::layoutRows):
        * khtml/xml/dom_nodeimpl.h:

=== Alexander-33 ===

2002-11-21  Richard Williamson   <rjw@apple.com>

        Fixed from SK's copy/paste whitespace issue.
        This fixes 3076236 and a regression due to additional whitespace
        in the DOM.
        
        * kwq/WebCoreBridge.mm:
        (attributedString):

2002-11-21  David Hyatt  <hyatt@apple.com>

	Fix mac.com regression (and weather.com regression).
	
        * khtml/rendering/bidi.cpp:
        (RenderFlow::findNextLineBreak):

2002-11-21  Richard Williamson   <rjw@apple.com>

        Fixed performance regression!  Argh.
        
        * khtml/rendering/font.cpp:
        (Font::width):

2002-11-21  Darin Adler  <darin@apple.com>

        * force-js-clean-timestamp: Trigger a rebuild because of the
	size change in ValueImp.

2002-11-21  Darin Adler  <darin@apple.com>

	- fixed 3107286 -- REGRESSION: unrepro assertion failure in KWQKHTMLPart.mm keyEvent

        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::keyEvent):
	Handle case of nil document as well as case of nil focus node.

        * kwq/WebCoreBridge.mm: Tweak whitespace.

2002-11-20  Darin Adler  <darin@apple.com>

	- fixed 3107383 -- clicking link on cnet.com leads to assertion failure

	When we removed a frame, we were leaving behind an empty WebView. Yuck.

        * kwq/KWQScrollView.mm:
        (QScrollView::addChild): Use the new getOuterView.
        (QScrollView::removeChild): Ditto. This was the bug fix.
        * kwq/KWQWidget.h: Add getOuterView.
        * kwq/KWQWidget.mm:
        (QWidget::frameGeometry): Use the new getOuterView.
        (QWidget::setFrameGeometry): Ditto.
        (QWidget::getOuterView): Added. Does the WebCoreFrameView magic to find
	the WebView instead of the WebHTMLView. Yuck.
        (QWidget::paint): Use the new getOuterView.

2002-11-20  Darin Adler  <darin@apple.com>

        * force-js-clean-timestamp: Again.

2002-11-20  David Hyatt  <hyatt@apple.com>

	Fix the mac.com line-breaking bug.  This was not a regression
	but was present in Konq.
	
        * khtml/rendering/bidi.cpp:
        (RenderFlow::findNextLineBreak):

2002-11-20  Maciej Stachowiak  <mjs@apple.com>

        * force-js-clean-timestamp: Work around PB lameness yet again.

2002-11-19  Darin Adler  <darin@apple.com>

        * force-js-clean-timestamp: Make other people's builds work.

2002-11-19  David Hyatt  <hyatt@apple.com>

	I screwed up the line breaking for inline replaced elements.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::calcInlineMinMaxWidth):

2002-11-19  Darin Adler  <darin@apple.com>

	- another atomic identifier scrub pass; make the conversion to Identifier explicit

        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLCollection::tryCall): Add explicit Identifier() conversion.
        (KJS::HTMLCollectionProtoFunc::tryCall): Ditto.
        * khtml/ecma/kjs_window.cpp: (WindowFunc::tryCall): And again.

2002-11-19  David Hyatt  <hyatt@apple.com>

	Fix for 3049663.  Table cells don't grow to accommodate block
	overflow.
	
        * khtml/rendering/bidi.cpp:
        (RenderFlow::layoutInlineChildren):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::RenderFlow):
        (RenderFlow::layout):
        (RenderFlow::layoutBlockChildren):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_object.h:

2002-11-19  Darin Adler  <darin@apple.com>

	- next step towards atomic identifiers; Identifier is no longer derived from UString

        * khtml/ecma/kjs_binding.cpp:
        (Identifier::string): Added.
        (Identifier::qstring): Added.

        * khtml/ecma/kjs_binding.h:
        * khtml/ecma/kjs_css.cpp:
        (jsNameToProp):
        (DOMCSSStyleDeclaration::tryPut):
        (DOMStyleSheet::tryPut):
        (DOMStyleSheetList::tryGet):
        (DOMMediaList::tryGet):
        (DOMCSSRuleList::tryGet):
        (DOMCSSValueList::tryGet):
        * khtml/ecma/kjs_dom.cpp:
        (DOMNodeList::hasProperty):
        (DOMNodeList::tryGet):
        (DOMNodeListFunc::DOMNodeListFunc):
        (DOMElement::tryGet):
        (DOMNamedNodeMap::hasProperty):
        (DOMNamedNodeMap::tryGet):
        (DOMNamedNodesCollection::tryGet):
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocument::tryGet):
        (HTMLElementFunction::HTMLElementFunction):
        (KJS::HTMLElement::putValue):
        (KJS::HTMLCollection::hasProperty):
        (KJS::HTMLCollection::tryGet):
        (KJS::HTMLSelectCollection::tryPut):
        (OptionConstructorImp::OptionConstructorImp):
        * khtml/ecma/kjs_navigator.cpp:
        (Plugins::get):
        (MimeTypes::get):
        (Plugin::get):
        * khtml/ecma/kjs_window.cpp:
        (WindowFunc::tryCall):
        (FrameArray::get):
	Use lengthPropertyName instead of "length" for better speed.

2002-11-19  David Hyatt  <hyatt@apple.com>

	Fix backgrounds not painting in deployment builds.
        * khtml/rendering/render_box.cpp:
        (RenderBox::paintBackground):

2002-11-19  Darin Adler  <darin@apple.com>

	- a first step towards atomic identifiers in JavaScript

	Most places that work with identifiers now use Identifier
	instead of UString.

        * khtml/ecma/kjs_binding.cpp:
        * khtml/ecma/kjs_binding.h:
        * khtml/ecma/kjs_css.cpp:
        * khtml/ecma/kjs_css.h:
        * khtml/ecma/kjs_dom.cpp:
        * khtml/ecma/kjs_dom.h:
        * khtml/ecma/kjs_events.cpp:
        * khtml/ecma/kjs_events.h:
        * khtml/ecma/kjs_html.cpp:
        * khtml/ecma/kjs_html.h:
        * khtml/ecma/kjs_navigator.cpp:
        * khtml/ecma/kjs_navigator.h:
        * khtml/ecma/kjs_range.cpp:
        * khtml/ecma/kjs_range.h:
        * khtml/ecma/kjs_traversal.cpp:
        * khtml/ecma/kjs_traversal.h:
        * khtml/ecma/kjs_views.cpp:
        * khtml/ecma/kjs_views.h:
        * khtml/ecma/kjs_window.cpp:
        * khtml/ecma/kjs_window.h:

2002-11-18  Darin Adler  <darin@apple.com>

        * force-js-clean-timestamp: Another Object change.

2002-11-18  David Hyatt  <hyatt@apple.com>

	Implement phased painting to correct the paint order of blocks,
	floats, and inlines.
	
        * khtml/rendering/render_body.cpp:
        (RenderBody::paintBoxDecorations):
        * khtml/rendering/render_body.h:
        * khtml/rendering/render_box.cpp:
        (RenderBox::paint):
        (RenderBox::paintBoxDecorations):
        (RenderBox::paintBackground):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_br.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::paint):
        (RenderFlow::paintObject):
        (RenderFlow::paintFloats):
        (RenderFlow::addChild):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_html.cpp:
        (RenderHtml::setStyle):
        (RenderHtml::paint):
        (RenderHtml::paintBoxDecorations):
        * khtml/rendering/render_html.h:
        * khtml/rendering/render_image.cpp:
        (RenderImage::setStyle):
        (RenderImage::paintObject):
        * khtml/rendering/render_image.h:
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint):
        (RenderLayer::nodeAtPoint):
        * khtml/rendering/render_list.cpp:
        (RenderListItem::paint):
        (RenderListItem::paintObject):
        (RenderListMarker::paint):
        (RenderListMarker::paintObject):
        * khtml/rendering/render_list.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::RenderObject):
        (RenderObject::paintBorder):
        (RenderObject::paintOutline):
        (RenderObject::paint):
        (RenderObject::dump):
        (RenderObject::setStyle):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::paint):
        (RenderWidget::setStyle):
        (RenderWidget::paintObject):
        * khtml/rendering/render_replaced.h:
        * khtml/rendering/render_root.cpp:
        (RenderRoot::paint):
        (RenderRoot::paintObject):
        * khtml/rendering/render_root.h:
        * khtml/rendering/render_table.cpp:
        (RenderTable::paint):
        (RenderTableCell::RenderTableCell):
        (RenderTableCell::setStyle):
        (RenderTableCell::paint):
        (RenderTableCell::paintBoxDecorations):
        * khtml/rendering/render_table.h:
        * khtml/rendering/render_text.cpp:
        (TextSlave::paintSelection):
        (TextSlave::paintDecoration):
        (TextSlave::paintBoxDecorations):
        (RenderText::paintObject):
        (RenderText::paint):
        (RenderText::paintTextOutline):
        * khtml/rendering/render_text.h:

2002-11-18  Darin Adler  <darin@apple.com>

        * force-js-clean-timestamp: I changed the size of ObjectImp.

2002-11-18  David Hyatt  <hyatt@apple.com>

	Fix crazyapplerumors.com.  I had the logic backwards. CSS
	padding beats cellpadding.
	
        * khtml/rendering/render_table.cpp:
        (RenderTableCell::paddingTop):
        (RenderTableCell::paddingBottom):
        (RenderTableCell::paddingLeft):
        (RenderTableCell::paddingRight):

2002-11-18  David Hyatt  <hyatt@apple.com>

	Fix crash on espn.com.
	
        * khtml/rendering/render_object.cpp:
        (RenderObject::setLayouted):

2002-11-18  David Hyatt  <hyatt@apple.com>

	Fix my <konqblock> regression on ign.com.
	
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::insertNode):

2002-11-18  Maciej Stachowiak  <mjs@apple.com>

        * force-js-clean-timestamp: Rebuild for JSC changes.

2002-11-18  Darin Adler  <darin@apple.com>

        * force-js-clean-timestamp: Touch files to make the build work.

2002-11-18  Richard Williamson   <rjw@apple.com>

        Fixed 3103004.  REGRESSION: word-spacing/letter-spacing applied when they shouldn't be
        This was actually NOT a regression.  khtml wasn't recognizing the 'normal' value for the
        word and letter spacing properties.  So it incorrectly substituted a -1 spacing.

        * khtml/css/cssstyleselector.cpp:

2002-11-18  David Hyatt  <hyatt@apple.com>

	Fix render_body's repaint method.
	
        * khtml/rendering/render_body.cpp:
        (RenderBody::repaint):
        * khtml/rendering/render_body.h:

2002-11-18  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3103711 - Alexander does not complete JavaScript iBench
	
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocument::putValue): Resolve URL for location property
	relative to the base URL of the frame where the JavaScript is
	executing, not the target frame.

2002-11-18  David Hyatt  <hyatt@apple.com>

	Yay! Found the main cause of :hover feedback being so
	slow on links.  The diff function for styles was
	considering a color change as a containing block layout
	instead of just a repaint.  With this fix, we will no
	longer lay out when you hover over a link whose color
	is different (remember that laying out causes the whole
	page to repaint).

	There's still some work to do to optimize this further,
	since we do repaint the containing block still, but this
	should be good enough for beta.
	
        * khtml/rendering/render_style.cpp:
        (RenderStyle::diff):

2002-11-17  David Hyatt  <hyatt@apple.com>

	Don't use the immediate painting code for now.  Revert
	to non-immediate code.  Using the non-immediate path I
	have managed to fix all the regressions except for 
	mrskin losing updates in its marquee (this works only with
	immediate painting) and the general scrollbar regression 
	(which I just don't understand).
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close):
        * khtml/rendering/render_object.cpp:
        (RenderObject::setLayouted):
        * khtml/rendering/render_root.cpp:
        (RenderRoot::repaintRectangle):
        (RenderRoot::repaint):

2002-11-17  David Hyatt  <hyatt@apple.com>

	More refinements to immediate painting code.  Still doesn't
	fix the scrollbar problem though. :(
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close):
        * khtml/khtmlview.cpp:
        (KHTMLView::init):
        (KHTMLView::timerEvent):

2002-11-17  David Hyatt  <hyatt@apple.com>

	Make immediate repainting of the root element more robust.
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close):
        * khtml/khtmlview.cpp:
        (KHTMLView::unscheduleRepaint):
        * khtml/khtmlview.h:
        * khtml/rendering/render_root.cpp:
        (RenderRoot::repaint):

2002-11-17  Darin Adler  <darin@apple.com>

	- moved all NSURL and CFURL use out of WebCore

        * kwq/KWQKURL.h: Remove getNSURL() and getNSURLFromString().
        * kwq/KWQKURL.mm: Ditto.

        * kwq/KWQKCookieJar.mm:
        (KWQKCookieJar::cookie): Pass an NSString instead of an NSURL.
        (KWQKCookieJar::setCookie): Ditto.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURL): Ditto.
        (KWQKHTMLPart::openURLRequest): Ditto.
        (KWQKHTMLPart::submitForm): Ditto.
        (KWQKHTMLPart::urlSelected): Ditto.
        (KWQKHTMLPart::createPart): Ditto.
        (KWQKHTMLPart::redirectionTimerStartedOrStopped): Ditto.
        (KWQKHTMLPart::userAgent): Ditto.
        (KWQKHTMLPart::requestedURLString): Receive an NSString instead of an NSURL.
        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow): Pass an NSString instead of an NSURL.
        (KHTMLPartBrowserExtension::setIconURL): Ditto.
        (KHTMLPartBrowserExtension::setTypedIconURL): Ditto.
        * kwq/KWQKJavaAppletWidget.h: Remove use of NSURL, just use QString instead.
        * kwq/KWQKJavaAppletWidget.mm:
        (KJavaAppletWidget::KJavaAppletWidget): No need to set the QString to nil.
        (KJavaAppletWidget::~KJavaAppletWidget): No need to release the QString.
        (KJavaAppletWidget::showApplet): Pass an NSString instead of an NSURL.
        * kwq/KWQLoader.mm:
        (KWQServeRequest): Pass an NSString instead of an NSURL.
        (KWQCheckCacheObjectStatus): Ditto.
        * kwq/WebCoreBridge.h: Change all methods to use NSString instead of NSURL.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge openURL:reload:headers:]): Receive an NSString instead of an NSURL.
        (-[WebCoreBridge completeURLForDOMString:]): Return an NSString instead of an NSURL.
        (-[WebCoreBridge elementAtPoint:]): WebCoreElementLinkURL and WebCoreElementImageURL
	are now strings.
        (-[WebCoreBridge URL]): Return an NSString instead of an NSURL.
        * kwq/WebCoreCookieAdapter.h: Change all methods to use NSString instead of NSURL.
        * kwq/WebCoreCookieAdapter.m:
        (-[WebCoreCookieAdapter cookiesForURL:]): Ditto.
        (-[WebCoreCookieAdapter setCookies:forURL:policyBaseURL:]): Ditto.

        * khtml/rendering/render_applet.cpp: (RenderApplet::processArguments):
	Tweaked this file a tiny bit, mainly because header dependencies weren't working
	and we need this file to be recompiled due to inline function changes.

2002-11-17  David Hyatt  <hyatt@apple.com>

	Add support for specifying whether repaint should be immediate or
	not.  Default to async for now to maintain current behavior.

	For clipped object repainting (e.g., livepage.apple.com and mrskin)
	switch to immediate repainting, since this makes the marquees
	faster, stops dropping updates, and keeps the hover effects and
	painting on the rest of the page fast (since the marquee rect doesn't
	get unioned with links or images that you roll over).
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::repaint):
        (RenderBox::repaintRectangle):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_html.cpp:
        (RenderHtml::repaint):
        * khtml/rendering/render_html.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::setLayouted):
        (RenderObject::repaintRectangle):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_root.cpp:
        (RenderRoot::repaintRectangle):
        (RenderRoot::repaint):
        * khtml/rendering/render_root.h:
        * khtml/rendering/render_table.cpp:
        (RenderTableRow::repaint):
        (RenderTableCell::repaintRectangle):
        (RenderTableCell::repaint):
        * khtml/rendering/render_table.h:
        * khtml/rendering/render_text.cpp:
        (RenderText::repaint):
        * khtml/rendering/render_text.h:

2002-11-17  Maciej Stachowiak  <mjs@apple.com>

	- fixed 2949193 - implement onKeyDown, onKeyPress, and onKeyUp event handlers
	
        * khtml/html/html_formimpl.cpp:
        (HTMLGenericFormElementImpl::defaultEventHandler):
        * kwq/KWQEvent.h:
        * kwq/KWQEvent.mm:
        (QKeyEvent::QKeyEvent): Implemented.
        (QKeyEvent::key): Likewise.
        (QKeyEvent::state): Likewise.
        (QKeyEvent::accept): Likewise.
        (QKeyEvent::ignore): Likewise.
        (QKeyEvent::isAutoRepeat): Likewise.
        (QKeyEvent::text): Likewise.
        (QKeyEvent::ascii): Likewise.
        (QKeyEvent::count): Likewise.
        (QKeyEvent::isAccepted): Likewise.
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::keyEvent): Translate the event to a QEvent and send
	it through the DOM event mechanism.
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge interceptKeyEvent:toView:]): Pass event to the
	KWQ part.
	* kwq/WebCoreBridgePrivate.h: Added.
        * WebCore.pbproj/project.pbxproj: Added new file.

2002-11-17  David Hyatt  <hyatt@apple.com>

	Don't discard linefeeds after elements with no close tag
	(e.g., <img> or <input>).
	
        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::parseTag):

2002-11-17  David Hyatt  <hyatt@apple.com>

	Fix for slashdot table mispositioning in the upper right.
	Now that we fixed <td> to set to -konq-center when align="center"
	is specified, the style rules are no longer necessary in
	html4.css (and are in fact harmful).
	
        * khtml/css/html4.css:

2002-11-17  David Hyatt  <hyatt@apple.com>

	Fix for 3038168.  Duh.  Remember to be case-insensitive when
	checking the type of the <style> attribute.
	
        * khtml/html/html_headimpl.cpp:
        (HTMLStyleElementImpl::parseAttribute):

2002-11-17  David Hyatt  <hyatt@apple.com>

	This is a fix for bug 3058470.  The bug was that replaced elements
	were computing their min and max widths wrong.  Specifically they
	were not adding in borders and padding!  This means that any image
	with a border around it would potentially break to another line
	too early.

	Once I fixed this for replaced elements I then went in and
	fixed form controls.  I added two APPLE_CHANGES features for
	our form controls.  First I overrode the border/padding functions
	to always return 0 for all form controls, since no Aqua control
	honors border/padding (nor should it).  This fixes the menulist
	at the top of wired.com.

	Second I made sure that certain controls will ignore CSS-specified
	heights and always use their intrinsic heights.  These include
	<select size=1> (combobox), single line text fields, and buttons.
	I allow listboxes and textareas to honor height.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::contentWidth):
        (RenderBox::contentHeight):
        (RenderBox::calcWidth):
        (RenderBox::calcHeight):
        * khtml/rendering/render_form.h:
        * khtml/rendering/render_image.h:
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::calcMinMaxWidth):

2002-11-16  David Hyatt  <hyatt@apple.com>

	Fix for 3078240, <pre> should not establish its own text-align,
	but should instead inherit from its parent.
	
        * khtml/css/html4.css:

2002-11-16  David Hyatt  <hyatt@apple.com>

	Rewrite the calculation of min and max width for <pre>s.  This
	is the second stage of the whitespace rewrite (third stage
	will be to stop morphing newlines).

	This should fix a bunch of bugs, e.g., especially if you ever
	did the following: 
	<td><pre><span>foo</span>
	   more text after the newline</pre></td>

	The new code now properly handles building up the correct min/max
	width for the <pre>.

	If anyone recalls seeing any bugs like this, let me know and
	I can close them.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::calcInlineMinMaxWidth):
        * khtml/rendering/render_text.cpp:
        (RenderText::trimmedMinMaxWidth):
        (RenderText::calcMinMaxWidth):

2002-11-16  David Hyatt  <hyatt@apple.com>

	Fix more edge cases with whitespace handling that caused some
	lines to be too long (and unselectable).
	
        * khtml/rendering/bidi.cpp:
        (appendRunsForObject):

2002-11-16  David Hyatt  <hyatt@apple.com>

	Make <caption> error-handling more robust.

	Specifically, handle <tr> and <td> misplaced inside
	<caption>s and still make them be part of the table.
	
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::insertNode):

2002-11-16  David Hyatt  <hyatt@apple.com>

	Implement the collapsing top margin quirk for <body> (the same
	quirk used for table cells) and make sure it works even when the
	<body> has margins of its own.

	Fixes www.eflightpacks.com (the top frame was shoved down because
	the <p> margin didn't collapse away).
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-11-16  David Hyatt  <hyatt@apple.com>

	Sigh. Amazingly enough, all other browsers seem to treat
	stray </p>s as <p></p> (Mac IE treats it as <br>, but
	I'm going with the WinIE/Gecko behavior of <p></p>).

	This fixes bug 3063699.
	
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::processCloseTag):
        (KHTMLParser::popBlock):

2002-11-15  David Hyatt  <hyatt@apple.com>

	Fix for livepage.apple.com slowness.  Ensure that 
	clipped regions only paint their own rectangles
	when they or any children inside of them need to
	be reflowed.

	This fix is intended as an interim band-aid for a much
	larger problem (that all of layout doesn't just auto-invalidate
	the regions it needs to, and that DHTML doesn't have
	specialized behavior to avoid async repainting or even
	relayout when only a repaint is required).
	
        * khtml/khtmlview.cpp:
        (KHTMLView::timerEvent):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::removeChildNode):
        (RenderContainer::appendChildNode):
        (RenderContainer::insertChildNode):
        (RenderContainer::layout):
        * khtml/rendering/render_object.cpp:
        (RenderObject::setLayouted):
        (RenderObject::scheduleRelayout):
        * khtml/rendering/render_root.cpp:
        (RenderRoot::repaintRectangle):

2002-11-15  David Hyatt  <hyatt@apple.com>

	Fix the problem where the last lines of paragrpahs were getting
	justified incorrectly.
	
        * khtml/rendering/bidi.cpp:
        (RenderFlow::findNextLineBreak):

2002-11-15  David Hyatt  <hyatt@apple.com>

	Fix bustage with <nobr> tags.  Inline nowrap elements were
	breaking on images when they shouldn't have.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::calcInlineMinMaxWidth):

2002-11-15  Ken Kocienda  <kocienda@apple.com>

	Fix for this bug:

	Radar 3102708 (REGRESSION: assertion failure backing up to page)

	KWQCheckCacheObjectStatus did not create an NSURL in a way that 
	dealt with the fact that we handle non-NSURL-compliant URL strings.
	I have fixed it so it does, and in the process, factored out
	the code to do it into a new KURL static function (KURL::getNSURLFromString).

        * kwq/KWQKURL.h:
        * kwq/KWQKURL.mm:
        (KURL::getNSURL): Now calls through to KURL::getNSURLFromString
        (KURL::encode_string)
        (KURL::getNSURLFromString): New function to handle NSURL creation
        * kwq/KWQLoader.mm:
        (KWQCheckCacheObjectStatus)

2002-11-15  David Hyatt  <hyatt@apple.com>

	Fix asserts in tables.
	
        * khtml/rendering/render_table.cpp:
        (RenderTableRow::layout):

2002-11-15  David Hyatt  <hyatt@apple.com>

	Fix for whitespace regressions that caused text overlapping
	and text spilling.
	
        * khtml/rendering/bidi.cpp:
        (appendRunsForObject):

2002-11-15  David Hyatt  <hyatt@apple.com>

	Fix newlines getting stripped out of textareas by not making
	rendertext objects for children of textareas.
	
        * khtml/rendering/render_form.h:
        * khtml/rendering/render_object.h:
        * khtml/xml/dom_textimpl.cpp:
        (TextImpl::attach):

2002-11-15  David Hyatt  <hyatt@apple.com>

	Make <form> inside <table> stay inside the <table> but demote
	itself to a leaf.  Then the children of the <form> are treated
	as though they occurred underneath the <table> itself.  Everything
	KHTML does with this is completely wrong but this band-aid should
	hopefully suffice until 1.0.

	Also allowing <input type="hidden"> to be constructed and attached
	under <table>s.  Since they have no render objects this is safe.
	Again, total hack, since CSS2 anonymous table construction should be
	implemented and that would have fixed all this.

	This collection of hacks makes travelocity render correctly on the
	PLT.
	
        * khtml/css/html4.css:
        * khtml/html/dtd.cpp:
        (DOM::checkChild):
        * khtml/html/html_tableimpl.cpp:
        (HTMLTableElementImpl::addChild):
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::parseToken):
        (KHTMLParser::insertNode):

2002-11-15  David Hyatt  <hyatt@apple.com>

	Fix Hixie's blog.  Background images can be transparent, so
	if the root's color isn't valid always do a fixup even if you
	have a valid background image.
	
        * khtml/rendering/render_html.cpp:
        (RenderHtml::printBoxDecorations):

2002-11-15  Darin Adler  <darin@apple.com>

        * kwq/KWQWindowWidget.mm: (KWQWindowWidget::setFrameGeometry):
	Oops. Make that display:YES.

2002-11-15  Darin Adler  <darin@apple.com>

	- fixed 3090219 -- Window jumps up and down when loading nikon page

        * kwq/KWQWindowWidget.mm: (KWQWindowWidget::setFrameGeometry):
	Don't pass display:NO when resizing the window.

2002-11-15  Ken Kocienda  <kocienda@apple.com>

	Remove characters RFC 2396 describes as "unwise" from the
	BadChar character class. This causes them to remain unescaped
	in KURL objects. As a result, some extra escaping needed to 
	be added into the getNSURL() function to enable NSURL 
	objects to be created using a KURL.

	This enables me to fix this bug:
	Radar 3050437 (Clicking link leads to page with garbled content)

	Note, however, that my fix for 3050437 relies on this bug remaining unfixed:

	Radar 3102332 (Square bracket characters "sneak through" CFURL illegal character checks)

        * kwq/KWQKURL.mm:
        (KURL::getNSURL)

2002-11-15  Darin Adler  <darin@apple.com>

	- fixed 3027460 -- text areas don't have focus rectangles
	- fixed 2937204 -- text areas have solid black borders

        * kwq/KWQSignal.mm: (KWQSignal::disconnect):
	Add a special case so we don't hear about finishedParsing all the time.

        * kwq/KWQTextArea.mm:
        (-[KWQTextArea initWithFrame:]): Use a bezel border, not a line border.
        (-[KWQTextArea getCursorPositionAsIndex:inParagraph:]): Fix bug where it would
	return a bogus value for an empty text area.
        (-[KWQTextArea setCursorPositionToIndex:inParagraph:]): Use setSelectedRange:
	ratherr than setMarkedText:selectedRange:.
        (-[KWQTextArea drawRect:]): Draw a focus ring if our text view is first responder.
        (-[KWQTextArea _KWQ_setKeyboardFocusRingNeedsDisplay]): Added.
        (-[KWQTextAreaTextView becomeFirstResponder]): Call _KWQ_setKeyboardFocusRingNeedsDisplay.
        (-[KWQTextAreaTextView resignFirstResponder]): Call _KWQ_setKeyboardFocusRingNeedsDisplay.
        (-[NSView _KWQ_setKeyboardFocusRingNeedsDisplay]): Calls the same thing on parent.

        * WebCore.pbproj/project.pbxproj: PB is a cruel master.

2002-11-15  Maciej Stachowiak  <mjs@apple.com>

        * khtml/html/html_formimpl.cpp:
        (HTMLInputElementImpl::attach): Removed a stray printf.

2002-11-14  Darin Adler  <darin@apple.com>

	- fixed most of the problems with OPTGROUP

        * khtml/html/htmlparser.cpp: (KHTMLParser::insertNode):
	Make OPTGROUPs pop out of other unclosed OPTGROUPs, not just out of options.

        * kwq/KWQListBox.h: Add private member function.
        * kwq/KWQListBox.mm:
        (QListBox::insertItem): Use shared insertItem function.
        (QListBox::insertGroupLabel): Create an attributed string for the group label,
	with bold font.
        (-[KWQListBoxTableViewDelegate tableView:shouldSelectRow:]): Return YES only
	for the plain strings, that way you can't select the group labels.

        * WebCore.pbproj/project.pbxproj: Let PB do its thing.

2002-11-14  David Hyatt  <hyatt@apple.com>

	Fix spinner.com mislayout on the PLT.  Make sure 
	<input type=image> honors the width attribute and
	make sure that its render object calls updateFromElement.
	
        * khtml/html/html_formimpl.cpp:
        (HTMLInputElementImpl::parseAttribute):
        (HTMLInputElementImpl::attach):

2002-11-14  David Hyatt  <hyatt@apple.com>

	Move text measurement and layout beyond onload.  This
	shoudl speed up i-bench substantially and morrison's
	PLT test slightly.

	Also allow <table>s as children of <p> and <h1>-<h6>.
	This fixes floats on slashdot.org (the left side) and
	the floating tables in articles on wired.com.
	
        * khtml/html/dtd.cpp:
        (DOM::checkChild):
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::HTMLDocumentImpl):
        (HTMLDocumentImpl::close):
        * khtml/html/html_documentimpl.h:
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::insertNode):

2002-11-14  Richard Williamson  <rjw@apple.com>

        Fixed 3099505.  With the recent white space changes, multiple slaves may
        be created for contiguous text on the same line.  The fix changes the
        iteration order of over the slave array.  Now, when searching for the end
        point of a line we'll always find the last slave on a line first.
        
        * khtml/khtml_part.cpp:
        (lastSlaveAt):

2002-11-14  Darin Adler  <darin@apple.com>

	- fixed 3095854 -- small select boxes get no scrollbar

        * kwq/KWQListBox.mm: (QListBox::sizeForNumberOfLines):
	Always use a minimum of 4 lines.

=== Alexander-32 ===

2002-11-14  Darin Adler  <darin@apple.com>

	- fixed 3099240 -- REGRESSION: repro assert d->m_doc->parsing

	Don't force all redirects to be reloads, because the ones from JavaScript must
	not be. Maybe a better solution post-Alex-32 will be to pass a flag that distinguishes
	redirects from other location changes.

        * khtml/khtml_part.cpp: (KHTMLPart::slotRedirect): Don't ignore the anchor when
	comparing URLs to see if they should be a reload. We'll still do a reload if the URLs
	are actually equal, but if they differ in anchor we will just go to the anchor.
	This is the bug fix.

        * kwq/WebCoreBridge.h: Add reload parameter.
        * kwq/WebCoreBridge.mm: (-[WebCoreBridge openURL:reload:headers:]): Stuff the reload
	parameter into the URLArgs.

2002-11-14  Darin Adler  <darin@apple.com>

	- fixed 3100235 -- nil-deference in khtml::RenderTable at money.cnn.com

        * kwq/WebCoreBridge.h: Add needsLayout.
        * kwq/WebCoreBridge.mm: (-[WebCoreBridge needsLayout]): Return true if the render
	tree root says "layouted" is false. It would be more elegant to use more of this
	WebCore layout logic and have less of our own on the WebKit side.

        * WebCore.pbproj/project.pbxproj: Oh, that Project Builder.

2002-11-13  Darin Adler  <darin@apple.com>

	- fixed 3100895 -- REGRESSION: Crash (was assertion) on http://www.w3.org/Style/CSS/

        * khtml/rendering/render_text.h: Add an optional arena parameter to deleteSlaves.
        * khtml/rendering/render_text.cpp:
        (RenderText::detach): Pass the render arena in to deleteSlaves.
        (RenderText::deleteSlaves): Use the passed-in arena.

2002-11-13  Darin Adler  <darin@apple.com>

	- fixed another crash on http://www.w3.org/Style/CSS/, but still not done

        * khtml/rendering/render_box.cpp: (RenderBox::setStyle): Call renderArena()
	from RenderObject rather than going at the document directly. Safer because
	it works even when we don't have a node yet.
        * khtml/rendering/render_flow.cpp: (RenderFlow::addChild): Ditto.
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint): Ditto.
        (RenderLayer::nodeAtPoint): Ditto.
        (RenderLayer::constructZTree): Ditto.
        * khtml/rendering/render_list.cpp:
        (RenderListItem::setStyle): Ditto.
        * khtml/rendering/render_text.cpp:
        (RenderText::deleteSlaves): Ditto.
        (RenderText::position): Ditto. This is the one that actually crashed.

        * khtml/misc/makeattrs: Fixed handling of failure case.
        * khtml/misc/maketags: Ditto.

        * WebCore.pbproj/project.pbxproj: Project Builder wanted to touch this.

2002-11-13  Darin Adler  <darin@apple.com>

	- fixed 3100895 -- REGRESSION: Assertion on http://www.w3.org/Style/CSS/

	A few arena-related fixes.

        * khtml/rendering/bidi.h: Don't define the operator new without the arena parameter.
	That way, we get a link failure if we use it by accident, rather than an assert at runtime.
	It would be even better to get a compile-time error, but I don't know how to make that happen.
        * khtml/rendering/render_layer.h: Ditto.
        * khtml/rendering/render_object.h: Ditto.
        * khtml/rendering/render_text.h: Ditto.

        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild): Create the RenderTable with the appropriate arena.
        (RenderContainer::insertPseudoChild): Create the RenderFlow objects with the appropriate arena.

        * khtml/rendering/render_text.cpp: (RenderText::deleteSlaves): Don't try to get the arena
	when there are no slaves. This can happen after the element is nil, and in that case we will
	do a nil-dereference.

2002-11-13  Darin Adler  <darin@apple.com>

        * kwq/KWQLineEdit.mm: (QLineEdit::sizeForCharacterWidth):
	Use the "0" instead of the "x" as the canonical character for width.
	This is slightly wider and is better for credit card numbers, for example.

        * WebCore.pbproj/project.pbxproj: Tweak.

2002-11-13  Darin Adler  <darin@apple.com>

	- fixed 3083982 -- Logging into AOL gives null view

	Turns out AOL was using a refresh header, which we were not supporting.

        * khtml/khtml_part.h: Declare receivedFirstData, a private member function.
        * khtml/khtml_part.cpp:
        (KHTMLPart::receivedFirstData): Separate out the part of slotData we
	want to share, which really seems kinda separate anyway.
        (KHTMLPart::slotData): More of the same.

        * kwq/KWQKHTMLPart.h: Declare addMetaData.
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::slotData): Call receivedFirstData instead of doing the same
	thing ourselves.
        (KWQKHTMLPart::addMetaData): Added. Puts metadata into the job.

        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow): Fix bug where this was calling
	openURL: but meant to call loadURL:.

        * kwq/WebCoreBridge.h: Add headers to openURL method. Remove setContentType.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge openURL:withHeaders:]): Handle Content-Type and Refresh.
	This method is big enough that I should probably move the guts to KWQKHTMLPart.

	- other things

        * kwq/KWQListImpl.mm: (KWQListImpl::~KWQListImpl): I overlooked something
	while doing my "bug fix" in here a while back. Change an assignment statement
	to an assert.

2002-11-13  David Hyatt  <hyatt@apple.com>

	Fix for floats. Force relayout if collapsing margins
	have to adjust the position of an object.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-11-13  David Hyatt  <hyatt@apple.com>

	Rewrite cellpadding to not use the style system at all and
	to make table cells just get the padding from the table
	itself (overriding style).
	
        * khtml/html/html_tableimpl.cpp:
        (HTMLTableElementImpl::HTMLTableElementImpl):
        (HTMLTableElementImpl::attach):
        (HTMLTableElementImpl::parseAttribute):
        (HTMLTableCellElementImpl::init):
        * khtml/html/html_tableimpl.h:
        * khtml/rendering/bidi.cpp:
        (RenderFlow::layoutInlineChildren):
        * khtml/rendering/render_box.cpp:
        (RenderBox::contentWidth):
        (RenderBox::contentHeight):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):
        (RenderFlow::leftOffset):
        (RenderFlow::rightOffset):
        (RenderFlow::calcMinMaxWidth):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_table.cpp:
        (RenderTable::RenderTable):
        (RenderTableCell::paddingTop):
        (RenderTableCell::paddingBottom):
        (RenderTableCell::paddingLeft):
        (RenderTableCell::paddingRight):
        * khtml/rendering/render_table.h:

2002-11-13  Ken Kocienda  <kocienda@apple.com>

	Bump WebCore cache to 4 MB (was 1 MB).

        * khtml/misc/loader.cpp

2002-11-13  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3050447 - Policy handlers have no way of telling client
	that the proposed navigation is a form post
	
        * khtml/khtml_part.cpp:
        (KHTMLPart::submitForm): Call kwq->submitForm
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURL): Adjusted for bridge API change.
        (KWQKHTMLPart::openURLRequest): Removed POST handling.
	(KWQKHTMLPart::submitForm): Added this back, because we need to
	know what URL navigations are caused by form submission, even if
	they are not POSTs.
        (KWQKHTMLPart::urlSelected): Adjusted for bridge API change.
        * kwq/WebCoreBridge.h: Add triggeringEvent: parameter to postURL:
	and isFormSubmission: parameter to loadURL:.

2002-11-12  David Hyatt  <hyatt@apple.com>

	Fix for 3032869, the background image for the body was being
	propagated up to the root properly but was not being tiled over
	the whole canvas.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::printBackground):
        * khtml/rendering/render_html.cpp:
        (RenderHtml::printBoxDecorations):

2002-11-12  David Hyatt  <hyatt@apple.com>

	Fix the top of moveabletype.org.  The maxwidth/minwidth
	calculation for blocks with inline content did not properly
	deal with margins and padding on inline elements like <a>.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::calcInlineMinMaxWidth):

2002-11-12  David Hyatt  <hyatt@apple.com>

	Fix for 2953367, padding is incorrectly inherited into table cells
	and also incorrectly overrides cellpadding on the table itself.
	Fixes dailyf1.com.
	
        * khtml/css/html4.css:
        * khtml/html/html_tableimpl.cpp:
        (HTMLTableElementImpl::parseAttribute):
        (HTMLTableCellElementImpl::init):
        * khtml/html/html_tableimpl.h:

2002-11-12  David Hyatt  <hyatt@apple.com>

	For now make text/xml files use HTML parsing/documents.
	This avoids the infinite loop we get into when loading
	text/xml.  If/when we finally support XML, we can undo
	this change.
	
        * khtml/khtml_part.cpp:
        (KHTMLPart::begin):

2002-11-12  David Hyatt  <hyatt@apple.com>

	Fix for 3086321, stylesheets not loading if titles are
	specified.  Note that 4 of the pages on the PLT were
	affected by this, so I fully expect a slight performance
	degradation (the boost from the regression was artificial).
	
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyleSelector):

2002-11-12  Richard Williamson  <rjw@apple.com>

        Oops, removed debugging.
        
        * khtml/rendering/font.cpp:
        (Font::drawText):

2002-11-12  Richard Williamson  <rjw@apple.com>

        Implemented letter-spacing and word-spacing CSS properties.
        
        * khtml/rendering/font.cpp:
        (Font::drawText):
        (Font::floatWidth):
        (Font::floatCharacterWidths):
        * kwq/KWQFontMetrics.h:
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):
        (QFontMetrics::floatWidth):
        (QFontMetrics::floatCharacterWidths):
        * kwq/KWQPainter.h:
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        * kwq/WebCoreTextRenderer.h:

2002-11-12  David Hyatt  <hyatt@apple.com>

	Revert floats so that they don't use layers any more.
	Floats have to be able to paint in between the background
	and foreground of inlines, so they can't have layers.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::printObject):
        (RenderFlow::paintFloats):
        (RenderFlow::addOverHangingFloats):
        (RenderFlow::nodeAtPoint):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):
        * khtml/rendering/render_list.cpp:
        (RenderListItem::printObject):

2002-11-12  Darin Adler  <darin@apple.com>

        * kwq/KWQCursor.mm: (QCursor::QCursor): Use nil instead of [NSCursor arrowCursor].
	This will probably fix the performance regression.

2002-11-12  Darin Adler  <darin@apple.com>

	- fixed 3080250 -- Hands-free crash at wired.com in
	KHTMLPart::slotChildStarted

        * kwq/KWQListImpl.mm:
        (KWQListImpl::~KWQListImpl): Set the node of each iterator to NULL too,
	not just the list. This is the bug fix for the bug above.
        (KWQListIteratorImpl::toFirst): Check for list of NULL.
        (KWQListIteratorImpl::toLast): ditto.

        * kwq/KWQSlot.mm: Tweaks.

2002-11-12  David Hyatt  <hyatt@apple.com>

	This patch lands a rewrite of whitespace-handling in the
	layout engine and adds support for the CSS2 white-space
	property.  

	It also includes a rewrite of inlines' min/max width 
	calculations (for both flow inlines and raw text).

	A problem with <form> margins has been fixed (this is a
	regression I caused with my collapsing margin checkin).

        * WebCore.pbproj/project.pbxproj:
        * khtml/css/html4.css:
        * khtml/html/dtd.cpp:
        (DOM::checkChild):
        * khtml/html/html_baseimpl.cpp:
        (HTMLBodyElementImpl::attach):
        (HTMLFrameElementImpl::attach):
        (HTMLFrameSetElementImpl::attach):
        (HTMLHtmlElementImpl::attach):
        (HTMLIFrameElementImpl::attach):
        * khtml/html/html_formimpl.cpp:
        (HTMLFormElementImpl::HTMLFormElementImpl):
        (HTMLInputElementImpl::attach):
        (HTMLSelectElementImpl::attach):
        (HTMLTextAreaElementImpl::attach):
        * khtml/html/html_formimpl.h:
        * khtml/html/html_imageimpl.cpp:
        (HTMLImageElementImpl::attach):
        * khtml/html/html_inlineimpl.cpp:
        (HTMLBRElementImpl::attach):
        * khtml/html/html_objectimpl.cpp:
        (HTMLAppletElementImpl::attach):
        (HTMLEmbedElementImpl::attach):
        (HTMLObjectElementImpl::attach):
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::reset):
        (KHTMLParser::parseToken):
        (KHTMLParser::insertNode):
        (KHTMLParser::popBlock):
        (KHTMLParser::popOneBlock):
        * khtml/html/htmlparser.h:
        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::addPending):
        (HTMLTokenizer::write):
        * khtml/misc/arena.cpp: Added.
        (CeilingLog2):
        (InitArenaPool):
        (ArenaAllocate):
        (ArenaGrow):
        (FreeArenaList):
        (ArenaRelease):
        (FreeArenaPool):
        (FinishArenaPool):
        (ArenaFinish):
        * khtml/misc/arena.h: Added.
        * khtml/rendering/bidi.cpp:
        (BidiIterator::detach):
        (throw):
        (BidiIterator::operator delete):
        (appendRunsForObject):
        (appendRun):
        (RenderFlow::bidiReorderLine):
        (deleteMidpoints):
        (RenderFlow::layoutInlineChildren):
        (RenderFlow::findNextLineBreak):
        * khtml/rendering/bidi.h:
        * khtml/rendering/render_arena.cpp: Added.
        (RenderArena::RenderArena):
        (RenderArena::~RenderArena):
        (RenderArena::allocate):
        (RenderArena::free):
        * khtml/rendering/render_arena.h: Added.
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::~RenderBox):
        (RenderBox::detach):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_br.cpp:
        (RenderBR::RenderBR):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::~RenderContainer):
        (RenderContainer::detach):
        * khtml/rendering/render_container.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::setStyle):
        (RenderFlow::layout):
        (RenderFlow::calcInlineMinMaxWidth):
        (RenderFlow::calcBlockMinMaxWidth):
        (RenderFlow::calcMinMaxWidth):
        (RenderFlow::addChild):
        (RenderFlow::makeChildrenNonInline):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_html.cpp:
        (RenderHtml::RenderHtml):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::~RenderLayer):
        (throw):
        (RenderLayer::operator delete):
        (RenderLayer::detach):
        (RenderLayer::paint):
        (RenderLayer::nodeAtPoint):
        (RenderLayer::constructZTree):
        (RenderLayer::RenderLayerElement::operator delete):
        (RenderLayer::RenderLayerElement::detach):
        (RenderLayer::RenderZTreeNode::operator delete):
        (RenderLayer::RenderZTreeNode::detach):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_list.cpp:
        (RenderListItem::setStyle):
        * khtml/rendering/render_object.cpp:
        (throw):
        (RenderObject::operator delete):
        (RenderObject::createObject):
        (RenderObject::renderArena):
        (RenderObject::detach):
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::detach):
        * khtml/rendering/render_replaced.h:
        * khtml/rendering/render_root.cpp:
        (RenderRoot::RenderRoot):
        * khtml/rendering/render_table.cpp:
        (RenderTable::addChild):
        (RenderTable::calcWidth):
        (RenderTable::setCellWidths):
        (RenderTableSection::addChild):
        (RenderTableRow::addChild):
        * khtml/rendering/render_text.cpp:
        (TextSlave::detach):
        (throw):
        (TextSlave::operator delete):
        (TextSlaveArray::TextSlaveArray):
        (RenderText::RenderText):
        (RenderText::~RenderText):
        (RenderText::detach):
        (RenderText::deleteSlaves):
        (RenderText::trimmedMinMaxWidth):
        (RenderText::calcMinMaxWidth):
        (RenderText::position):
        * khtml/rendering/render_text.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::DocumentImpl):
        (DocumentImpl::~DocumentImpl):
        (DocumentImpl::attach):
        (DocumentImpl::detach):
        * khtml/xml/dom_docimpl.h:
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::detach):
        (NodeImpl::isReadOnly):
        (NodeImpl::previousRenderer):
        * khtml/xml/dom_nodeimpl.h:
        * khtml/xml/dom_stringimpl.cpp:
        * khtml/xml/dom_stringimpl.h:
        * khtml/xml/dom_textimpl.cpp:
        (CharacterDataImpl::containsOnlyWhitespace):
        (TextImpl::attach):
        * khtml/xml/dom_textimpl.h:

2002-11-12  Darin Adler  <darin@apple.com>

	- fixed 3094819 -- Crash in -[KWQObjectTimerTarget timerFired]

        * kwq/KWQObject.mm: (QObject::~QObject): Call the _destroyed signal.
        (QObject::killTimers): Simplify the code a bit using makeObjectsPerformSelector:.

2002-11-12  Darin Adler  <darin@apple.com>

	- fixed 3079499 -- blank page at http://www.sonyericsson.com/T68i/

        * khtml/misc/loader.cpp:
        (CachedCSSStyleSheet::checkNotify): Copy the clients list before iterating
	over it, since clients can move around in the list or be removed.
        (CachedScript::checkNotify): Ditto.
        (CachedImage::do_notify): Ditto.
        (CachedImage::movieStatus): Ditto.

	- fixed double calls to openURL I noticed

        * khtml/khtml_part.cpp: (KHTMLPart::processObjectRequest):
	Don't call openURL here at all. That happens indirectly as a result
	of the load we kick off.

        * kwq/KWQKHTMLPart.mm: Tweaks.

2002-11-12  Darin Adler  <darin@apple.com>

	- fixed 3083043 -- Alex doesn't decode % sequences in javascript: URLs

	Some places here did KURL::decode_string, but others didn't.

        * khtml/khtml_part.cpp:
        (KHTMLPart::slotShowDocument): Added call to KURL::decode_string.
        (KHTMLPart::overURL): Ditto.
        (KHTMLPart::urlSelected): Ditto.
        (KHTMLPart::requestFrame): Ditto.
        (KHTMLPart::slotChildURLRequest): Ditto.

2002-11-11  Darin Adler  <darin@apple.com>

        * kwq/KWQWidget.mm: (QWidget::setCursor): Remove printf I left
	in by accident.

2002-11-11  Darin Adler  <darin@apple.com>

	- tighten up cursor handling a bit more

        * kwq/KWQWidget.mm:
        (QWidget::setCursor): Use setDocumentCursor: instead of our own protocol.
        (QWidget::cursor): Use documentCursor instead of storing our own cursor.

        * kwq/WebCoreFrameView.h: Remove setCursor: method.

2002-11-11  Darin Adler  <darin@apple.com>

	- fixed 3084704 -- crash in HTMLTokenizer on page with JavaScript
	HTMLDocument::Close inside a <script>

	I think it's going to work this time. The key was to hook up the
	KHTML submitFormAgain machinery.

        * khtml/khtml_part.cpp: (KHTMLPart::submitForm): Take out the APPLE_CHANGES
	ifdef that was disabling the submitFormAgain logic.
        * kwq/KWQKHTMLPart.h: Remove submitForm(), because openURLRequest() handles it fine.
        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::openURLRequest): Move the logic for handling
	POST here from submitForm() and remove submitForm().

        * kwq/KWQSlot.mm:
        (KWQSlot::KWQSlot): Add support for the submitFormAgain slot.
        (KWQSlot::call): Ditto.

2002-11-11  Darin Adler  <darin@apple.com>

	- fixed 3092421 -- javascript: URL that opens window crashes Alex if typed into empty window

        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::KWQKHTMLPart): Set _ownsView to false.
        (KWQKHTMLPart::~KWQKHTMLPart): Delete the view if we own it. Also release
	_currentEvent to fix a leak.
        (KWQKHTMLPart::setView): Delete the old view if we own it. Also, set the
	_ownsView flag.
        (KWQKHTMLPart::createDummyDocument): Create a dummy view too.

        * kwq/KWQDummyView.h: Added.
        * kwq/KWQDummyView.m: Added.
        * WebCore.pbproj/project.pbxproj: Added KWQDummyView.

        * kwq/WebCoreBridge.h: Remove bridgeOwnsKHTMLView and currentEvent.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge createKHTMLViewWithNSView:marginWidth:marginHeight:]):
	Pass true to setView instead of setting bridgeOwnsKHTMLView.
        (-[WebCoreBridge removeFromFrame]): Just call setView on the part. It
	knows how to handle ownership now.
        (-[WebCoreBridge installInFrame:]): Call setOwnsView instead of setting
	bridgeOwnsKHTMLView.

2002-11-11  Trey Matteson  <trey@apple.com>

        * khtml/khtml_part.cpp:
        (KHTMLPart::requestFrameName):  Call through bridge to get generated frame name.
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::generateFrameName):  New call that just forwards through the bridge.
        * kwq/WebCoreBridge.h:

2002-11-11  Darin Adler  <darin@apple.com>

	- fixed 3097253 -- text tagged <small> inside <h1> is too small

        * khtml/css/html4.css: Change BIG to use "font-size: larger" rather
	than "font-size: large" and SMALL to use "font-size: smaller" rather
	than "font-size: small".

2002-11-11  Darin Adler  <darin@apple.com>

        * kwq/WebCoreBridge.h: Remove unused modifierTrackingEnabled method.

2002-11-08  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3096451 - REGRESSION: clicking on link to open window only
	works when pop-up suppression is off
	
        * khtml/ecma/kjs_binding.cpp:
        (ScriptInterpreter::ScriptInterpreter): Initialize m_timerCallback
	to false.

b2002-11-08  Darin Adler  <darin@apple.com>

        * kwq/KWQComboBox.mm: Bump fudge factor up one pixel. You could see
	it was wrong with strings like "0".

2002-11-08  Darin Adler  <darin@apple.com>

	- fixed 3090452 -- REGRESSION: orbitz Box extends way over margins

        * kwq/KWQComboBox.h: Added _width and _widthGood.
        * kwq/KWQComboBox.mm:
        (QComboBox::QComboBox): Set _widthGood to false.
        (QComboBox::insertItem): Set _widthGood to false.
        (QComboBox::sizeHint): Compute the width by measuring the text ourselves.
	Turns out the cell isn't helpful for that.
        (QComboBox::clear): Set _widthGood to false.

2002-11-08  Richard Williamson   <rjw@apple.com>

        Cleanup of fix to 3083281.  Never call stopAnimating from
        QPixmap's destructor.  With the fix it wouldn't have been
        called anyway.
        
        * kwq/KWQPixmap.mm:
        (QPixmap::~QPixmap):

2002-11-08  Darin Adler  <darin@apple.com>

        * kwq/WebCoreBridge.mm: (attributedString): Remove some dead code.

2002-11-07  Darin Adler  <darin@apple.com>

        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::slotData):
	Add an assert in the hopes of catching bug 3084704 a little earlier.

2002-11-07  Richard Williamson  <rjw@apple.com>

        Don't stop animating unless we're the last referee. (3083281)
        
        * kwq/KWQPixmap.mm:
        (QPixmap::~QPixmap):

=== Alexander-31 ===

2002-11-06  Richard Williamson  <rjw@apple.com>

        Use our notion of unicode whitespace from lookup tables
        and isspace for latin1.  This is more correct than CF.
        Fixed issues Dave ran into with whitespace calculations.
        
        * kwq/KWQChar.mm:
        (QChar::isSpace):

2002-11-05  Darin Adler  <darin@apple.com>

	- fixed 3092722 -- assertion failed

        * kwq/KWQResourceLoader.mm: (-[KWQResourceLoader reportError]):
	Removed the assertion. It wasn't needed.

2002-11-05  Darin Adler  <darin@apple.com>

	- re-fixed 3070484 -- icon rollovers are very slow on Mac OS X website

	Had to roll back some of the files I changed yesterday. I had missed the
	one line of useful code among much stuff we don't need.

        * khtml/khtml_part.cpp:
        (KHTMLPart::init):
        (KHTMLPart::~KHTMLPart):
        (KHTMLPart::slotLoaderRequestStarted):
        (KHTMLPart::slotLoaderRequestDone):
        * kwq/KWQSignal.h:
        * kwq/KWQSignal.mm:
        (KWQSignal::call):
        * kwq/KWQSignalStubs.mm:
        (Loader::requestDone):
        (Loader::requestFailed):
        (Loader::requestStarted):
        * kwq/KWQSlot.h:
        * kwq/KWQSlot.mm:
        (KWQSlot::KWQSlot):
        (KWQSlot::call):
	Just roll back all the changes from my 3091714 check-in below, except
	for the bug fix itself in loader.cpp and KWQResourceLoader.mm.

2002-11-05  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3027404 - pop-up ads not always suppressed
	
        * khtml/ecma/kjs_binding.cpp:
        (ScriptInterpreter::isWindowOpenAllowed): Don't allow opening if
	we are in a timer callback - for reasons unexplained this will
	always show up as an inline script.
        * khtml/ecma/kjs_binding.h:
        * khtml/ecma/kjs_window.cpp:
        (ScheduledAction::execute): Note that we're in a timer callback.

2002-11-04  Richard Williamson  <rjw@apple.com>

        Changes to support cursive letter forms.
        
        * kwq/KWQChar.mm:
        * kwq/WebCoreUnicode.h:

2002-11-04  Darin Adler  <darin@apple.com>

	- fixed 3091714 -- reproducible assert cachedObject->response
	in KWQCheckCacheObjectStatus

        * khtml/misc/loader.cpp: (Loader::slotFinished):
	For APPLE_CHANGES, don't finish the load if it's an error.

        * kwq/KWQResourceLoader.mm:
        (-[KWQResourceLoader finishJobAndHandle]): Shared code for the
	three following methods.
        (-[KWQResourceLoader cancel]): Use setError(1) again instead of
	just keeping the load around forever.
        (-[KWQResourceLoader reportError]): Ditto.
        (-[KWQResourceLoader finish]): Use finishJobAndHandle to share
	code with the two above.

        * khtml/khtml_part.cpp:
        (KHTMLPart::init): Put the slotLoaderRequestStarted and
	slotLoaderRequestDone connect lines inside ifdefs.
        (KHTMLPart::~KHTMLPart): Same for disconnect.

        * kwq/KWQSignal.h: Remove code for the DocLoader signals.
        * kwq/KWQSignal.mm: (KWQSignal::call): Ditto.
        * kwq/KWQSignalStubs.mm:
        (Loader::requestDone): Ditto.
        (Loader::requestFailed): Ditto.
        (Loader::requestStarted): Ditto.
        * kwq/KWQSlot.h: Ditto.
        * kwq/KWQSlot.mm:
        (KWQSlot::KWQSlot): Ditto.
        (KWQSlot::call): Ditto.

2002-11-04  Maciej Stachowiak  <mjs@apple.com>

	Changes to send NSEvents all the way through WebCore and then pass
	them back out to WebKit, so that click policy can have a
	WebResourceRequest added.
	
        * kwq/KWQKHTMLPart.h:
        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::KWQKHTMLPart):
        (KWQKHTMLPart::openURL):
        (KWQKHTMLPart::openURLRequest):
        (KWQKHTMLPart::urlSelected):
        (KWQKHTMLPart::submitForm):
        (KWQKHTMLPart::createDummyDocument):
        (KWQKHTMLPart::setCurrentEvent):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge mouseUp:]):

2002-11-03  Darin Adler  <darin@apple.com>

	- fixed 3091300 -- "prelighting" on local page is still slow, despite recent bug fix

	Turns out all updating would be slow if any resources on the page failed to load.

        * kwq/WebCoreResourceLoader.h: Add reportError, distinct from
	cancel and finish.
        * kwq/KWQResourceLoader.mm: (-[KWQResourceLoader reportError]):
	Set the error boolean on the job and then call through to [finish].

2002-11-03  Darin Adler  <darin@apple.com>

	- fixed 3091275 -- can't type into Answer field in RealOne Player order form

        * khtml/rendering/render_form.cpp:
        (RenderLineEdit::updateFromElement): Treat 0 as max (1024) as other browsers do.
        (RenderFileButton::updateFromElement): Ditto, although this is in !APPLE_CHANGES code
	that we don't use in WebCore.

2002-11-01  Darin Adler  <darin@apple.com>

	- applied the same "subclass responsibility" pattern here as in
	some of the other WebCore classes

        * kwq/WebCoreImageRendererFactory.h: Move the subclass responsibility into a protocol.
        * kwq/WebCoreImageRendererFactory.m: Remove now-unneeded stubs.

2002-11-01  Richard Williamson   <rjw@apple.com>

        Removed old implementation.
        
        * kwq/KWQChar.mm:
        (QChar::direction):
        
        Renamed JoiningCenter -> JoiningCausing.
        
        * kwq/WebCoreUnicode.h:

2002-11-01  Darin Adler  <darin@apple.com>

	- fixed 3062598 -- meta refresh of 0.1s fails

	KHTML was using an integer for the delay.

        * khtml/khtml_part.h: Make scheduleRedirection take a double.
        * khtml/khtmlpart_p.h: Make m_delayRedirect be a double.
        * khtml/khtml_part.cpp:
        (KHTMLPart::slotData): Use a double when parsing meta refresh.
        (KHTMLPart::checkCompleted): Cast to int when passing to timer start.
        (KHTMLPart::scheduleRedirection): Cast to int when passing to timer
	start; also check for absurd values and do nothing.
        (KHTMLPart::slotParentCompleted): Cast to int when passing to timer start.

        * khtml/xml/dom_docimpl.cpp: (DocumentImpl::processHttpEquiv):
	Use a double when parsing meta refresh.

        * kwq/KWQKDebug.h: Add overloads for unsigned int and double to keep us
	compiling now that we use a double in one place.

2002-11-01  Darin Adler  <darin@apple.com>

	- fixed 3090249 -- random crash on page load
	- fixed 3090286 -- assert _job in KWQResourceLoader cancel

        * kwq/KWQResourceLoader.mm: (-[KWQResourceLoader cancel]):
	This function needs to handle the case where the load is already cancelled.
	I think this also caused Avie's crash.

2002-10-31  Darin Adler  <darin@apple.com>

	- fixed huge leak when doing page load test

        * khtml/ecma/kjs_binding.h:
        * khtml/ecma/kjs_binding.cpp: Remove ScriptInterpreter::mark().
	We don't want to mark the elements of m_domObjects, because we don't want
	to keep them around the entire lifetime of the interpreter. This is fine
	because we already have forgetDOMObject(), which takes care of when they
	are deallocated.

        * khtml/ecma/kjs_dom.cpp:
        * khtml/ecma/kjs_dom.h:
        * khtml/ecma/kjs_html.cpp:
        * khtml/ecma/kjs_html.h:
	Changed lots of parameters to pass by const reference for a bit of a code
	size and performance gain.

2002-10-31  Richard Williamson  <rjw@apple.com>

        Turned on use of lookup tables.
        
        * kwq/KWQChar.mm:
        (QChar::direction):
        (QChar::mirrored):
        (QChar::mirroredChar):

2002-10-31  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3075803 - yahoo customize layout - delete, ordering of items doesn't work
	
        * khtml/html/html_formimpl.h:
        * khtml/html/html_formimpl.cpp:
        (HTMLSelectElementImpl::recalcStyle): New method to insure the
	select element updates if the contents of the option subelements
	are changed.

=== Alexander-30 ===

2002-10-30  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3049853 - Javascript: setInterval incorrectly acts as single shot
	
        * kwq/KWQObject.mm:
        (QObject::startTimer): Set a recurring timer instead of
	single-shot, to match QObject semantics.

2002-10-30  Richard Williamson  <rjw@apple.com>

        More work on bidi and contextual forms.
        Table lookup code is up in WebKit. Function
        pointers are used to isolate WebCore from private
        implementation in WebKit.  Needs to be fast, so
        the usual ObjC abstraction won't work.
        
        * WebCore.exp:
        * WebCore.pbproj/project.pbxproj:
        * kwq/KWQChar.mm:
        (QChar::direction):
        * kwq/KWQString.h:
        * kwq/WebCoreUnicode.cpp: Added.
        * kwq/WebCoreUnicode.h: Added.

2002-10-30  Darin Adler  <darin@apple.com>

	- fixed crash when you open an empty window and just hit tab, tab, tab

        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::nextKeyViewInFrame): Check for nil.

2002-10-30  Darin Adler  <darin@apple.com>

	- fixed 3083982 -- Logging into AOL gives null view, crash

	I fixed the crash part. Not the "gives null view" part.
	The key was to disentangle the references and lifetimes of the transfer job class,
	and the resource loader object that KWQ uses to connect it with WebKit.

        * kwq/KWQKJobClasses.h: Change the job to keep a loader reference, not a
	handle reference. The job needs to inform the loader when it's being deallocated.
        * kwq/KWQKJobClasses.mm: Use jobWillBeDeallocated instead of cancel when the
	job is deallocated.

        * kwq/KWQLoader.mm: (KWQServeRequest): Use KWQResourceLoader, now with a home in
	a separate file.

        * kwq/KWQResourceLoader.h: Added.
        * kwq/KWQResourceLoader.mm: Added.
        * WebCore.pbproj/project.pbxproj: Added KWQResourceLoader files.

2002-10-30  Darin Adler  <darin@apple.com>

	- fixed 3086564 -- REGRESSION: meta-refresh to the same page doesn't refresh

	The key is to get args.reload passed through to the bridge.

        * kwq/WebCoreBridge.h: Add reload parameter to loadURL:.

        * kwq/KWQKHTMLPart.mm:
        (KWQKHTMLPart::openURL): Pass NO for reload.
        (KWQKHTMLPart::openURLRequest): Pass args.reload for reload.
        (KWQKHTMLPart::urlSelected): Pass args.reload for reload.
        (KWQKHTMLPart::submitForm): Pass args.reload for reload.
        
	- fixed a memory problem with the use of NSBrowser in KWQListBox
        - fixed 2863040 -- multiple default items in select list not selected

	Switched to use NSTableView instead of NSBrowser. This should also create
	a measurable speedup due to other changes to this class.

        * kwq/KWQListBox.h: Remove firstItem(), the insertItem() that takes a QListBoxItem
	parameter, and deleteItems(). Add _items, _width, and _widthGood. Removed _head.
	Removed the QListBoxItem and QListBoxText classes.
        * kwq/KWQListBox.mm:
        (QListBox::QListBox): Create a KWQListBoxScrollView and put an NSTableView
	inside it. Also create an NSMutableArray to hold the items.
        (QListBox::~QListBox): Disconnect the table view from the delegate before
	releasing it. Also release the items array.
        (QListBox::count): Return the array count.
        (QListBox::clear): Do a reloadData here instead of loadColumnZero.
        (QListBox::setSelectionMode): Update for table view.
        (QListBox::insertItem): Update for table view.
        (QListBox::insertGroupLabel): Just calls insertItem for now.
        (QListBox::endBatchInsert): Update for table view.
        (QListBox::setSelected): Update for table view, including support for multiple
	selection.
        (QListBox::isSelected): Update for table view.
        (QListBox::sizeForNumberOfLines): Use the table view cell for width, and
	cache it so we don't have to measure all the strings over and over again.
        (-[KWQListBoxScrollView setFrameSize:]): Resize the table view column whenever
	the entire scroll view is resized.
        (-[KWQListBoxTableViewDelegate initWithListBox:]): Store box pointer and
        pointer to items array.
        (-[KWQListBoxTableViewDelegate numberOfRowsInTableView:]): Return count.
        (-[KWQListBoxTableViewDelegate tableView:objectValueForTableColumn:row:]):
	Get the data from the items array.
        (-[KWQListBoxTableViewDelegate tableViewSelectionDidChange:]): Call both the
	selection-changed signal and the clicked signal.

        * khtml/rendering/render_form.cpp: (RenderSelect::updateFromElement):
	Get rid of the one place here that gets at a list box item by calling a KWQ
	function insertGroupLabel instead of making a QListBoxText. Also call
        beginBatchInsert() before clear() for a slight additional speed boost.

	- fixed 3067572 -- javascript: URLs typed into page address field or
	bookmarks don't work in empty window

	We needed a document for DOM, so we make a dummy one. This works for an empty
	window, and also for a window with non-HTML content.

        * kwq/KWQKHTMLPart.h: Added createDummyDocument().
        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::createDummyDocument): Create an empty
	DOM document if there isn't one already.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge stringByEvaluatingJavaScriptFromString:]): Call the new
	createDummyDocument() instead of checking and doing nothing if there is no
	document present when this is called.

	- other stuff

        * kwq/WebCoreBridge.mm: (-[WebCoreBridge DOMDocument]): Removed a stray printf.

        * kwq/KWQTextArea.mm: Tweaked code a little.

2002-10-28  Darin Adler  <darin@apple.com>

        * khtml/khtml_part.cpp: (KHTMLPart::checkCompleted):
	Update so it handles nil for the view.

2002-10-28  Darin Adler  <darin@apple.com>

	- fixed 3070484 -- icon rollovers are very slow on Mac OS X website

	The problem was simply that the part didn't know it was complete.
	To let it know, I hooked up some loader signals, and now it works.

        * khtml/khtml_part.cpp:
        (KHTMLPart::init): Create the KWQKHTMLPart a little earlier so we have
	a chance to initialize the cache before it's used.
        (KHTMLPart::slotLoaderRequestStarted): Take this out of ifdefs.
        (KHTMLPart::slotLoaderRequestDone): Ditto.

        * khtml/misc/loader.h: Add a KWQLoader pointer to the loader.
        * khtml/misc/loader.cpp:
        (Loader::Loader): Create a KWQLoader;
        (Loader::~Loader): Destroy the KWQLoader.
        (Loader::load): Take out ifdefs around code that emits requestStarted.

        * kwq/KWQKHTMLPart.mm: (KWQKHTMLPart::KWQKHTMLPart): Call Cache::init().

        * kwq/KWQLoader.h: Add a class KWQLoader, with three signals in it.
        * kwq/KWQLoader.mm: (KWQLoader::KWQLoader): Initialize the three signals.

        * kwq/KWQSignalStubs.mm:
        (Loader::requestDone): Emit the signal using KWQLoader.
        (Loader::requestFailed): Ditto.
        (Loader::requestStarted): Ditto.

        * kwq/KWQSlot.h: Add an overload for slots with loader and cached object
	parameters so we can handle the new slots.
        * kwq/KWQSlot.mm:
        (KWQSlot::KWQSlot): Added slotLoaderRequestDone and slotLoaderRequestStarted.
        (KWQSlot::call): Added the new overload to handle those two signals.

        * kwq/KWQSignal.h: Add an overload for signals with loader and cached object
	parameters so we can handle the new signals.
        * kwq/KWQSignal.mm: (KWQSignal::call): Ditto.

        * kwq/KWQObject.mm: (QObject::connect): Remove the special casing that
	prevents complaints about slotLoaderRequestDone and slotLoaderRequestStarted,
	since we support those now.

2002-10-28  Darin Adler  <darin@apple.com>

	- fixed storage leak of items in QListBox

        * kwq/KWQListBox.h: Added private deleteItems method.
        * kwq/KWQListBox.mm:
        (QListBox::~QListBox): Call deleteItems().
        (QListBox::deleteItems): Move the code to delete all the items
	here from clear(), since clear() is not called on destruction.
        (QListBox::clear): Call deleteItems().

2002-10-28  Chris Blumenberg  <cblu@apple.com>

	Lowercase the text encoding name.

        * kwq/KWQCharsets.mm:
        (KWQCFStringEncodingFromIANACharsetName):

2002-10-28  Richard Williamson   <rjw@apple.com>
    
        Fixed 3086188 - REGRESSION: Justified text is broken
        
        Bogus special case for DirW(hite)S(pace).  This
        should be correctly detected by CF, but is not.
        Revert to explicit checking for ' ' character.  This'll
        work most of the time.  All the more reason to do
        our own unicode attribute database.
        
        * kwq/KWQChar.mm:
        (QChar::direction):

2002-10-28  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3056726 - View Source window always displays the source in current system encoding
	Fixed: 3019352 - Text encoding is not handled when viewing plain text

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (+[WebCoreBridge stringWithData:textEncoding:]): added, creates a string with data using the WebCore's decoding logic.
        (+[WebCoreBridge stringWithData:textEncodingName:]): added, calls stringWithData:textEncoding: after getting the encoding for a text encoding name

2002-10-28  Don Melton  <gramps@apple.com>

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::insertNode):
        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::write):

	Backed our Dave's whitespace hack because it was adding newlines, i.e.
	vertical margins, to web pages all over.

2002-10-28  Darin Adler  <darin@apple.com>

	- fixed 3015800 -- bad URL error - unescaped # in URL

	Actually this has to be fixed both here and in NSURLExtras.

        * kwq/KWQKURL.mm: Set the "BadChar" flag for "#" so we escape any
	"#" characters we see after the first one.

2002-10-27  Darin Adler  <darin@apple.com>

	- fixed 3058845 -- <input type=file> uses hard-coded width of 200
	pixels for filename

        * khtml/rendering/render_form.cpp:
        (RenderLineEdit::calcMinMaxWidth): Use a default of 20 "x-widths" wide, to
	match Mozilla, rather than the 17 that is in KHTML by default.
        (RenderFileButton::calcMinMaxWidth): Pass in a character width here, using
	the same 20-character rule as above.
        * kwq/KWQFileButton.h: Replace sizeHint() with sizeForCharacterWidth(int).
        * kwq/KWQFileButton.mm:
        (KWQFileButton::sizeForCharacterWidth): Pass character count to the WebCoreFileButton.
        (KWQFileButton::baselinePosition): Fix baseline computation. It was computing some huge
	negative number before and was obviously broken.
        * kwq/KWQLineEdit.mm: (QLineEdit::sizeForCharacterWidth): Add an assertion.
        * kwq/WebCoreViewFactory.h: Replace bestVisualFrameSize with
	bestVisualFrameSizeForCharacterCount:.

2002-10-27  Don Melton  <gramps@apple.com>

        * khtml/ecma/kjs_navigator.cpp:
        (Navigator::getValueProperty):

	Tweaked AppName, Product, and Vendor logic.

2002-10-27  Darin Adler  <darin@apple.com>

        * kwq/KWQLoader.mm: (KWQServeRequest): Add a missing "delete job" for one
	particular failure case.

2002-10-26  Darin Adler  <darin@apple.com>

	- fixed a bug in the WebCore cache that caused it to not cache very much after
        a while, and also caused a crash I saw twice on my machine

	Adjust total size of items in the LRU list, when the size of one of the
	items that's in the list is changed.

        * khtml/misc/loader.h: Added a size parameter (default 0) to the CachedObject
	constructor. Added a protected CachedObject::setSize() and made m_size private.
	Added Cache::adjustSize() and Cache::checkLRUAndUncacheableListIntegrity().
        * khtml/misc/loader.cpp:
        (CachedObject::setSize): Added. This is now the only legal way to change
	the size of a cached object, and it calls Cache::adjustSize.
        (CachedCSSStyleSheet::CachedCSSStyleSheet): Pass the length into the base
	class's constructor instead of setting m_size.
        (CachedCSSStyleSheet::data): Call setSize() instead of setting m_size.
	Also get the size back with size() rather than m_size.
        (CachedScript::CachedScript): Pass the length into the base class's
	constructor instead of setting m_size.
        (CachedScript::data): Call setSize() instead of setting m_size. Also get
	the size back with size() rather than m_size.
        (CachedImage::CachedImage): Don't set m_size to 0, since the base class's
	constructor does that already.
        (CachedImage::clear): Use setSize() to set the size to 0 instead of setting
	m_size directly.
        (CachedImage::data): Use setSize() instead of setting m_size directly.
        (Cache::checkLRUAndUncacheableListIntegrity): Useful debugging function.
	Left in but ifdef'd out.
        (Cache::adjustSize): Added. Changes the "total LRU list size" by the
	passed-in delta, but only if the passed-in object is in the LRU list.

        * kwq/KWQLineEdit.mm:
        * kwq/KWQTextField.h:
        * kwq/KWQTextField.mm:
	Renamed the Objective C class KWQNSTextField to KWQTextField.

2002-10-26  Darin Adler  <darin@apple.com>

	- removed forwarding headers that are not actually needed

        * ForwardingHeaders/kcmdlineargs.h: Removed.
        * ForwardingHeaders/kinstance.h: Removed.
        * ForwardingHeaders/kio/kprinter.h: Removed.
        * ForwardingHeaders/kio/ktrader.h: Removed.
        * ForwardingHeaders/kio/scheduler.h: Removed.
        * ForwardingHeaders/kparts/factory.h: Removed.
        * ForwardingHeaders/kparts/historyprovider.h: Removed.
        * ForwardingHeaders/kstddirs.h: Removed.
        * ForwardingHeaders/qarray.h: Removed.
        * ForwardingHeaders/qbrush.h: Removed.
        * ForwardingHeaders/qbutton.h: Removed.
        * ForwardingHeaders/qcollection.h: Removed.
        * ForwardingHeaders/qcombobox.h: Removed.
        * ForwardingHeaders/qframe.h: Removed.
        * ForwardingHeaders/qglobal.h: Removed.
        * ForwardingHeaders/qiodevice.h: Removed.
        * ForwardingHeaders/qlineedit.h: Removed.
        * ForwardingHeaders/qnamespace.h: Removed.
        * ForwardingHeaders/qpen.h: Removed.
        * ForwardingHeaders/qprinter.h: Removed.
        * ForwardingHeaders/qsize.h: Removed.
        * ForwardingHeaders/qstack.h: Removed.

2002-10-26  Darin Adler  <darin@apple.com>

	- fixed a couple of files accidentally checked in with KWQQ names

        * ForwardingHeaders/qasyncio.h: Change names.
        * ForwardingHeaders/qstylesheet.h: Ditto.
        * WebCore.pbproj/project.pbxproj: Ditto.
        * kwq/KWQMovie.h: Ditto.

2002-10-26  Darin Adler  <darin@apple.com>

	- changed to use #if APPLE_CHANGES and #if !APPLE_CHANGES consistently

	We no longer do #ifdef APPLE_CHANGES or #ifndef APPLE_CHANGES.

        * lots of files

2002-10-26  Darin Adler  <darin@apple.com>

        - changed naming scheme in KWQ for files like qstring.h

        Now use names like KWQString.h and a forwarding header called qstring.h.
        
        * tons of files

2002-10-26  Darin Adler  <darin@apple.com>

	- fixed 3068404 -- eliminate all user-visible messages from WebCore

        * khtml/ecma/kjs_window.cpp: (WindowFunc::tryCall): Use runJavaScriptPrompt
	function instead of the more generic QInputDialog.

        * khtml/html/html_formimpl.cpp: (HTMLInputElementImpl::altText): Get
	submit alt text for input element from the view factory, rather than using
	i18n, since we don't support that.
        * khtml/html/htmlparser.cpp: (KHTMLParser::handleIsindex): Ditto, for the
	intro that says "This is a searchable index".
        * khtml/rendering/render_form.cpp:
        (RenderSubmitButton::defaultLabel): Ditto, for "Submit".
        (RenderResetButton::defaultLabel): Ditto, for "Reset".
        (RenderFileButton::slotClicked): Ifdef'd out this unused code that had i18n text in it.

        * khtml/xml/xml_tokenizer.cpp:
        (XMLHandler::errorString): Put in an ifdef and a FIXME to avoid i18n.
        (XMLHandler::fatalError): Ditto.
        (XMLTokenizer::finish): Ditto.

        * khtml/misc/decoder.cpp: (Decoder::decode): Ifdef'd the check for the first
	language being "ja", since that's not how we're going to trigger Japanese
	auto-detect.

        * khtml/rendering/render_applet.cpp: (RenderEmptyApplet::RenderEmptyApplet):
	Turned off the code that does the empty applet label. I don't think it worked,
	and it used i18n. We'll have to tackle this eventually.

        * kwq/KWQKHTMLPartImpl.h: Added runJavaScriptPrompt.
        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::runJavaScriptPrompt): Moved the code
	here that used to be in KWQInputDialog.

        * kwq/kdecore/klocale.h: Remove i18n() and KLocale::languageList(), added the functions
	that are listed below.
        * kwq/KWQKLocale.mm:
        (inputElementAltText): Added specific function for getting one of the very few
	translated strings that we need in WebCore.
        (resetButtonDefaultLabel): Ditto.
        (searchableIndexIntroduction): Ditto.
        (submitButtonDefaultLabel): Ditto.
        (KLocale::language): Use the view factory to ask for the language code, since there's no
	public API to get it that WebCore can use.

        * kwq/WebCoreViewFactory.h: Add new API for above.

        * ForwardingHeaders/qinputdialog.h: Added empty file.

        * kwq/qt/qinputdialog.h: Removed.
        * kwq/KWQInputDialog.mm: Removed.
        * WebCore.pbproj/project.pbxproj: Removed QInputDialog files.

2002-10-25  Darin Adler  <darin@apple.com>

	Remove some user-visible strings. We can't have any strings that need
	localization in WebCore, given our translation strategy.

        * khtml/html/html_formimpl.cpp: (HTMLInputElementImpl::encoding):
	Put APPLE_CHANGES around some i18n dialog code.
        * khtml/khtml_part.cpp: (KHTMLPart::submitForm): Ditto.
        * khtml/rendering/render_frames.cpp:
        (RenderPartObject::slotPartLoadingErrorNotify): Ditto.
        * khtml/ecma/kjs_window.cpp:
        (Window::get): Ditto.
        (Window::scheduleClose): Ditto.
        (WindowFunc::tryCall): Put APPLE_CHANGES in to use JavaScript-specific methods
        in the part of calling the generic ones from KMessageBox.

        * ForwardingHeaders/kmessagebox.h: Added (empty file).

        * kwq/KWQKHTMLPartImpl.h: Added new runJavaScript functions.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::runJavaScriptAlert): Added.
        (KWQKHTMLPartImpl::runJavaScriptConfirm): Added.

        * kwq/WebCoreViewFactory.h: Added runJavaScriptAlertPanelWithMessage and
	runJavaScriptConfirmPanelWithMessage.

        * kwq/kdeui/kmessagebox.h: Removed.
        * kwq/KWQKMessageBox.mm: Removed.
        * WebCore.pbproj/project.pbxproj: Removed the KMessageBox files.

2002-10-25  Richard Williamson   <rjw@apple.com>

        Removed debug logging.
        
        * khtml/rendering/font.cpp:
        (Font::drawText):

2002-10-25  Richard Williamson   <rjw@apple.com>

        Implemented support for bidi text layout.  WebCore
        temporarily depends on SPI to get unicode character
        attribute from CF.  This will change shortly.
        
        * khtml/rendering/font.cpp:
        (Font::drawText):
        * kwq/KWQChar.mm:
        (QChar::direction):
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        * kwq/WebCoreTextRenderer.h:
        * kwq/qt/qpainter.h:

2002-10-25  Chris Blumenberg  <cblu@apple.com>

	Cleaned up the frame searching shenanigans. Things are much cleaner and clearer now.

        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow): call findFrameNamed
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::bridgeForFrameName): call findOrCreateFramedNamed
        * kwq/WebCoreBridge.h:

2002-10-25  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3065638 - "undefined" output to screen on empty document.write()
	
        * khtml/ecma/kjs_html.cpp:
        (KJS::HTMLDocFunction::tryCall): Don;t assume there is at least
	one argument.

2002-10-25  Maciej Stachowiak  <mjs@apple.com>

	- fixed 3048031 - innerHTML is incorrectly null
	
        * kwq/KWQString.mm:
        (QString::isNull): Check for NULL by comparing to
	shared_null_handle instead of checking for 0 length, so
	garden-variety empty strings don't show as NULL.
        (QString::QString): Make sure that string created with a NULL char
	* uses the shared null handle, so it's properly NULL.

2002-10-24  Richard Williamson   <rjw@apple.com>

        Updated to reflect new calling parameter semantic of floatCharacterWidths(),
        which now returns the entire array of widths up the last character requested.
        
        * khtml/rendering/render_text.cpp:
        (TextSlave::checkSelectionPoint):

2002-10-24  David Hyatt  <hyatt@apple.com>

	<pre>, <xmp> and <plaintext> should all have a top margin of 1em.
	Fixes a bunch of sites that use <pre>.
	
        * khtml/css/html4.css:

2002-10-24  Chris Blumenberg  <cblu@apple.com>

	Removed didAddSubview calls because that can easily be done in WebKit. Duh!

        * khtml/rendering/render_frames.cpp:
        (RenderPart::setWidget):
        * kwq/KWQKHTMLPartImpl.h:
        * kwq/KWQKHTMLPartImpl.mm:
        * kwq/KWQKJavaAppletWidget.mm:
        (KJavaAppletWidget::showApplet):
        * kwq/WebCoreBridge.h:

2002-10-24  Darin Adler  <darin@apple.com>

	A step in the direction of making KWQ headers much nicer.
	Move all empty headers out of kwq, and into ForwardingHeaders.

        * ForwardingHeaders/kcmdlineargs.h: Added.
        * ForwardingHeaders/kdatastream.h: Added.
        * ForwardingHeaders/khtml_iface.h: Added.
        * ForwardingHeaders/khtml_printsettings.h: Added.
        * ForwardingHeaders/khtml_run.h: Added.
        * ForwardingHeaders/kio/kprinter.h: Added.
        * ForwardingHeaders/kio/kprotocolmanager.h:
        * ForwardingHeaders/kio/ktrader.h: Added.
        * ForwardingHeaders/kio/scheduler.h: Added.
        * ForwardingHeaders/kmultipledrag.h: Added.
        * ForwardingHeaders/kprinter.h: Added.
        * ForwardingHeaders/kprotocolmanager.h: Added.
        * ForwardingHeaders/ksslcertchain.h: Added.
        * ForwardingHeaders/ksslinfodlg.h: Added.
        * ForwardingHeaders/kstdaction.h: Added.
        * ForwardingHeaders/ktempfile.h: Added.
        * ForwardingHeaders/ktrader.h: Added.
        * ForwardingHeaders/kurldrag.h: Added.
        * ForwardingHeaders/kxmlguifactory.h: Added.
        * ForwardingHeaders/qasyncimageio.h: Added.
        * ForwardingHeaders/qbitmap.h: Added.
        * ForwardingHeaders/qclipboard.h: Added.
        * ForwardingHeaders/qfontdatabase.h: Added.
        * ForwardingHeaders/qglobal.h: Added.
        * ForwardingHeaders/qhbox.h: Added.
        * ForwardingHeaders/qintcache.h: Added.
        * ForwardingHeaders/qintdict.h: Added.
        * ForwardingHeaders/qmetaobject.h: Added.
        * ForwardingHeaders/qobjectlist.h: Added.
        * ForwardingHeaders/scheduler.h: Added.

        * kwq/dcop/kdatastream.h: Removed.
        * kwq/kdecore/kcmdlineargs.h: Removed.
        * kwq/kdecore/kmultipledrag.h: Removed.
        * kwq/kdecore/ktempfile.h: Removed.
        * kwq/kdecore/kurldrag.h: Removed.
        * kwq/kdeui/kstdaction.h: Removed.
        * kwq/kdeui/kxmlguifactory.h: Removed.
        * kwq/khtml/khtml_iface.h: Removed.
        * kwq/khtml/khtml_printsettings.h: Removed.
        * kwq/khtml/khtml_run.h: Removed.
        * kwq/kio/kprinter.h: Removed.
        * kwq/kio/kprotocolmanager.h: Removed.
        * kwq/kio/kssl/ksslcertchain.h: Removed.
        * kwq/kio/kssl/ksslinfodlg.h: Removed.
        * kwq/kio/ktrader.h: Removed.
        * kwq/kio/scheduler.h: Removed.
        * kwq/qt/qasyncimageio.h: Removed.
        * kwq/qt/qbitmap.h: Removed.
        * kwq/qt/qclipboard.h: Removed.
        * kwq/qt/qfontdatabase.h: Removed.
        * kwq/qt/qglobal.h: Removed.
        * kwq/qt/qhbox.h: Removed.
        * kwq/qt/qintcache.h: Removed.
        * kwq/qt/qintdict.h: Removed.
        * kwq/qt/qmetaobject.h: Removed.
        * kwq/qt/qobjectlist.h: Removed.

        * WebCore.pbproj/project.pbxproj: Removed all the above headers from
	the project.

2002-10-24  Darin Adler  <darin@apple.com>

        * ForwardingHeaders/private/qucomextra_p.h: Emptied this out.
        * kwq/qt/private/qucomextra_p.h: Removed.

2002-10-24  David Hyatt  <hyatt@apple.com>

	Make sure that KHTML's initial layout happens after KHTML
	fires the onload.  This means that in the case where we
	beat the timer, we will now fire the onload before both
	the initial layout and the initial paint.
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::close):

=== Alexander-29 ===

2002-10-24  Chris Blumenberg  <cblu@apple.com>

	Use "MIMEType" instead of "serviceType".

        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::createPart):
        * kwq/WebCoreBridge.h:

2002-10-24  Darin Adler  <darin@apple.com>

        * kwq/KWQKLocale.mm: (i18n): Make it obvious when non-localized
	strings from WebCore show up in the UI, but putting the string
	"not localized: " in front.

        * kwq/KWQKMessageBox.mm:
        (KMessageBox::error): Fix use of NSRunAlertPanel so that we won't
	accidentally try to interpret % sequences in the messages we are displaying.
        (KMessageBox::warningYesNo): Ditto.
        (KMessageBox::questionYesNo): Ditto.
        (KMessageBox::sorry): Ditto.
        (KMessageBox::information): Ditto.

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	WebKit now gets called when render_frame subviews are added.

        * khtml/rendering/render_frames.cpp:
        (RenderPart::setWidget): call didAddWidget on the part
        * kwq/KWQKHTMLPartImpl.h:
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::didAddWidget): added, calls didAddSubview on the bridge

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	Change for plug-in package API changes.

        * kwq/KWQKConfigBase.mm:
        (KConfig::readEntry):
        * kwq/WebCoreBridge.h: added didAddSubview, called when a render_frame's view is added as a subview of the main view.
        * kwq/WebCoreViewFactory.h: added didAddSubview

2002-10-23  Darin Adler  <darin@apple.com>

	- finished up the job of moving the file button to WebKit

	I did this mainly for localization reasons.

        * kwq/KWQFileButton.h: Remove filename(), add filenameChanged(),
	make KWQFileButton be a QWidget subclass, not a QPushButton one.
	Remove clicked() and paint() virtual functions, _filename, _icon,
	and _label data members.
        * kwq/KWQFileButton.mm:
        (KWQFileButton::KWQFileButton): Just make a WebCoreFileButton.
        (KWQFileButton::~KWQFileButton): Less to do here now.
        (KWQFileButton::setFilename): Call the button to do the work.
        (KWQFileButton::sizeHint): Ditto.
        (KWQFileButton::frameGeometry): Ditto.
        (KWQFileButton::setFrameGeometry): Ditto.
        (KWQFileButton::baselinePosition): Ditto.
        (KWQFileButton::filenameChanged): Added. Sends message.
        (-[KWQFileButtonAdapter initWithKWQFileButton:]): Observe the "filename
	changed notification".
        (-[KWQFileButtonAdapter dealloc]): Stop observing.
        (-[KWQFileButtonAdapter filenameChanged:]): Send a signal when the notification
	comes in, so KHTML finds out.

        * kwq/KWQSlot.mm:
        (KWQSlot::KWQSlot): Remove handling for RenderFileButton slotReturnPressed.
        (KWQSlot::call): Ditto.

        * kwq/WebCoreViewFactory.h: Remove bestSize. Add setVisualFrame, visualFrame, and
	bestVisualFrameSize.

        * kwq/KWQInputDialog.mm: Tweaked includes. Long-term we want to use "", not <>.
        * kwq/KWQKConfigBase.mm: Ditto.
        * kwq/KWQKHTMLPartImpl.mm: Ditto.

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	Call the arguments for plug-ins "attributes" everywhere.

        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::createPart):
        * kwq/KWQKJavaAppletWidget.mm:
        (KJavaAppletWidget::showApplet):
        * kwq/WebCoreBridge.h:

2002-10-23  Chris Blumenberg  <cblu@apple.com>

	For the new plug-in API, we need to pass a WebPluginContainer to the plug-in view upon creation. The is owned by the WebFrame. To make this all work, I had to move the WebCore plug-in and java view constructors to WebBridge from WebViewFactory since WebBridge has the frame. 

        * khtml/khtml_part.cpp:
        (KHTMLPart::createJavaContext): New APPLE_CHANGES around the java context constructor so we pass the part.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::createPart): call the bridge to create the view
        * kwq/KWQKJavaAppletWidget.mm:
        (KJavaAppletWidget::KJavaAppletWidget): save the context
        (KJavaAppletWidget::showApplet): call the bridge to create the view
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreViewFactory.h:
        * kwq/khtml/java/kjavaappletcontext.h: made constructor take the part
        * kwq/khtml/java/kjavaappletwidget.h: ivar for the context

2002-10-23  Darin Adler  <darin@apple.com>

	- fixed 3080478 -- reproducible incomplete load on apple.com

        * kwq/KWQLoaderImpl.mm:
        (-[WebCoreResourceLoader receivedResponse:]): Add an assert.
        (-[WebCoreResourceLoader cancel]): Don't finish here, just disconnect the handle
	from the job, and disconnect the job from the WebCoreResourceLoader, and let the
	KHTML code finish the cleanup later. This is the bug fix.
        (KWQCheckCacheObjectStatus): Add an assertion.

        * kwq/KWQKjobclasses.mm:
	(TransferJob::~TransferJob): Don't call kill(); do the work here instead.
	(TransferJob::kill): Self-destruct. Need this to avoid a storage leak.

        * khtml/misc/loader.cpp:
        (CachedObject::~CachedObject): Put some Apple-specific code inside APPLE_CHANGES.
        (CachedObject::setResponse): Streamlined this function.
        (Loader::receivedResponse): Added assertions.

        * kwq/qt/qxml.h: Add more stubs.
        * kwq/KWQxml.mm: Ditto.

        * kwq/WebCoreViewFactory.h: Add [WebCoreViewFactory fileButton], the
	WebCoreFileButton protocol, and WebCoreFileButtonFilenameChanged.
        * kwq/WebCoreViewFactory.m: Add WebCoreFileButtonFilenameChanged.
        * WebCore.exp: Export _WebCoreFileButtonFilenameChanged.

2002-10-22  Maciej Stachowiak  <mjs@apple.com>

	Forgot to check this in earlier:

	- fixed 3077084 - debugging output when suppressing or allowing
	pop-ups
	
        * khtml/ecma/kjs_window.cpp:
        (WindowFunc::tryCall):
        * kwq/KWQLogging.h:
        * kwq/KWQLogging.m:

2002-10-22  David Hyatt  <hyatt@apple.com>

	Get XML files closer.  An XML doc is at least made.  No
	parsing works yet though.
	
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::setPolicyBaseURL):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge setContentType:]):

2002-10-22  Chris Blumenberg  <cblu@apple.com>

	Fixed: 3023814 - contexual menus and dragging doesn't work for some images

	Added a innerNonSharedNode to NodeInfo that points to the node which is not shared by another node. In this case, the innerNonSharedNode is the image node not the area node.

        * khtml/rendering/render_frames.cpp:
        (RenderFrameSet::nodeAtPoint): call setInnerNonSharedNode
        * khtml/rendering/render_image.cpp:
        (RenderImage::nodeAtPoint): call setInnerNonSharedNode
        * khtml/rendering/render_object.cpp:
        (RenderObject::nodeAtPoint): call setInnerNonSharedNode
        * khtml/rendering/render_object.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementAtPoint:]): use the innerNonSharedNode

2002-10-22  David Hyatt  <hyatt@apple.com>

	Fix slashdot.  Make sure the KONQBLOCK hack just throws away
	margins at the tops and bottoms of kids.
	
        * khtml/css/html4.css:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-10-22  David Hyatt  <hyatt@apple.com>

	Fix for left-hand-side of wired.com.  A disturbingly basic
	bug.  I was applying a parent's margins to its children
	when collapsing, even if the parent had a border/padding set
	that should have separated it from its kids.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-10-22  David Hyatt  <hyatt@apple.com>

	Optimize my inline margin discarding to be smart about the
	case when the inline has a block and its beginning or
	end.  Fixes aintitcool.com.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-10-22  David Hyatt  <hyatt@apple.com>

	Removing konq's flow-around-floats hack for <blockquote> and
	<dl>.  These objects are allowed to flow under floats.  Fixes
	www.webreference.com's front page.

	Also fixing a bug in my <td> margin collapsing quirk that
	prevented lists (ol,ul,dl,menu,dir) from collapsing their
	top margins into the td.
	
        * khtml/css/html4.css:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):
        (RenderFlow::addChild):

2002-10-22  David Hyatt  <hyatt@apple.com>

	Fix a typo in my change to the h1 rule.
	
        * khtml/css/html4.css:

2002-10-22  David Hyatt  <hyatt@apple.com>

	Ok, this patch does a lot of stuff.  It contains a complete
	rewrite of the WinIE quirk for handling collapsing margins
	at the tops and bottoms of table cells.  We match WinIE's
	behavior for all HTML4 block-level elements.

	This patch also applies a bottom margin to <form> elements,
	which is what was causing the missing space on livepage.apple.com
	underneath the textfield on the right.  WinIE and Gecko both
	put a bottom margin on all forms.

	This patch also updates the collapsing margin code to detect
	inlines that have been morphed into blocks by KHTML (this is 
	so wrong, don't even get me started, you can't treat an inline
	as a block, this code is lame, etc. etc.) and to properly ignore
	their margins completely.  Fixing the code to not morph inlines
	is another architectural problem that will have to be dealt
	with (sigh).
	
        * khtml/css/css_valueimpl.h:
        * khtml/css/cssparser.cpp:
        (StyleBaseImpl::parseValue):
        (StyleBaseImpl::parseUnit):
        * khtml/css/cssparser.h:
        * khtml/css/cssstyleselector.cpp:
        * khtml/css/html4.css:
        * khtml/misc/khtmllayout.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::RenderFlow):
        (RenderFlow::layout):
        (RenderFlow::layoutBlockChildren):
        (RenderFlow::addChild):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_object.h:

2002-10-21  Darin Adler  <darin@apple.com>

        * kwq/KWQInputDialog.mm: (QInputDialog::getText): Call the view factory to do the
	heavy lifting.

        * kwq/WebCoreViewFactory.h: Add runJavaScriptTextInputPanelWithPrompt:defaultText:returningText:.
	Use a protocol for the subclass responsibility.
        * kwq/WebCoreViewFactory.m: Remove stub methods not needed because of the subclass responsibility
	technique we are using.

        * kwq/qt/qstylesheet.h: Made this inline, since it does nothing.
        * kwq/KWQStyleSheet.mm: Removed.
        * WebCore.pbproj/project.pbxproj: Removed KWQStyleSheet.mm.

2002-10-21  David Hyatt  <hyatt@apple.com>

	Implement support for a new @-rule called @konq-quirks.  This
	will allow us to put style rules into html4.css that only
	apply for pages in quirks mode.
	
        * khtml/css/css_ruleimpl.cpp:
        (CSSQuirksRuleImpl::CSSQuirksRuleImpl):
        (CSSQuirksRuleImpl::~CSSQuirksRuleImpl):
        (CSSQuirksRuleImpl::cssRules):
        (CSSQuirksRuleImpl::appendRule):
        (CSSQuirksRuleImpl::insertRule):
        (CSSQuirksRuleImpl::deleteRule):
        * khtml/css/css_ruleimpl.h:
        * khtml/css/cssparser.cpp:
        (StyleBaseImpl::parseAtRule):
        * khtml/css/cssparser.h:
        * khtml/css/cssstyleselector.cpp:
        * khtml/css/cssstyleselector.h:
        * khtml/dom/css_rule.h:

2002-10-21  Darin Adler  <darin@apple.com>

	Remove closeEntireTree now that deferred close takes care of that case.

        * khtml/html/htmlparser.cpp: (KHTMLParser::startBody):
        * khtml/rendering/render_object.h:

2002-10-21  Darin Adler  <darin@apple.com>

	- fixed 3075041 -- text larger/smaller increment too large when font-size specified as %

        * khtml/css/cssstyleselector.cpp: Don't apply the zoom factor to a font size that
	already has the zoom factor applied.

2002-10-21  Darin Adler  <darin@apple.com>

        * khtml/khtmlview.cpp: (KHTMLView::clear): Default to fast scrolling.
	I'm pretty sure this was just backwards here.

2002-10-21  David Hyatt  <hyatt@apple.com>

	DLs are supposed to have margins.
	
        * khtml/css/html4.css:

2002-10-21  David Hyatt  <hyatt@apple.com>

	Fix for margin problems on aintitcool.com.  There was a subtlety
	to WinIE's quirk.  For <h1>-<h6> only, they don't collapse the
	bottom margin for table cells (they still collapse the top
	margin).  I just love emulating the odd behavior of WinIE.
	Wheee.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-10-20  Darin Adler  <darin@apple.com>

	Redid my fix. It was just an ordering thing. The image had to already be
	installed as the current image before calling ref(), because in the cached
	case, you get the loading complete callback right then.

        * khtml/rendering/render_image.cpp: (RenderImage::updateFromElement):
	Call deref on the old image later. Basically, instead of moving the ref
	of the new image up, I moved the deref of the old image down.

2002-10-20  Darin Adler  <darin@apple.com>

	Roll out my render_image.cpp change. It was causing a big problem
	getting images from the cache. I need to study further to figure out why.

        * khtml/rendering/render_image.cpp: (RenderImage::updateFromElement):
	Roll back the change.

2002-10-20  David Hyatt  <hyatt@apple.com>

	Rewrite the clearing code for floats.  Rewrote the
	collapsing margin code to really work with floating and
	clearing.  This fixes the right hand side of wired.com.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):
        (RenderFlow::checkClear):
        (RenderFlow::addChild):

2002-10-20  Darin Adler  <darin@apple.com>

	- fixed 3007961 -- Crash in DOM::HTMLImageElementImpl::parseAttribute

        * khtml/rendering/render_image.cpp: (RenderImage::updateFromElement):
	Be sure to call ref on the new image before calling deref on the old
	image. That's because deref on the old image causes a cache flush,
	which might cause the image to go away in certain cases.

2002-10-20  Chris Blumenberg  <cblu@apple.com>

	Fixed possible build failure.

        * kwq/KWQDOMNode.cpp:
        (isImage): remove unused variable.

2002-10-20  Chris Blumenberg  <cblu@apple.com>

	Partial fix for:
	3023814 - contexual menus and dragging doesn't work for some images

	The image map case is still broken because I need to find a way to get the RenderImage for an AREA node. Anyone know how?

        * kwq/KWQDOMNode.cpp:
        (isImage): Also return true if the node is an INPUT tag with TYPE set to "image"

2002-10-20  Darin Adler  <darin@apple.com>

	- fixed 3076390 -- crash in DOM::DocumentImpl::setParsing loading thread detail page
	at groups.apple.com

        * khtml/khtml_part.cpp: (KHTMLPart::openURL): Don't do any redirect special case
	if the document is nil. Just do a normal load in that case.

2002-10-20  Darin Adler  <darin@apple.com>

	- fixed 3079864 -- REGRESSION: assertion failure on any page with a form element

        * khtml/html/html_formimpl.cpp: (HTMLGenericFormElementImpl::attach):
	Roll back the parent call to use NodeBaseImpl::attach. Not sure why I changed that
	at the last minute before my last checkin, but it was *bad*.

	- fixed a crash I observed when clicking on an about:blank page

        * kwq/WebCoreBridge.mm: (-[WebCoreBridge elementAtPoint:]): Check for nil renderer.

2002-10-19  Darin Adler  <darin@apple.com>

	- fixed 3075032 -- textarea contents sometimes aren't shown

	The root of the problem is that we weren't delivering close calls to
	the render objects in the case where we created them late due to our FOUC
	fix. I taught the DOM implementation to remember that a close call is
	due, and deliver it when the render object is created. We can probably
	replace the closeEntireTree hack with this too. I'll talk to Dave about
	that on Monday.

        * khtml/xml/dom_nodeimpl.h: Add m_rendererNeedsClose and closeRenderer.
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::NodeImpl): Initialize m_rendererNeedsClose to false.
        (NodeImpl::closeRenderer): Call close on the renderer if it's created, otherwise
	set m_rendererNeedsClose.
        (NodeImpl::attach): If the renderer is created and m_rendererNeedsClose is true
	call close on the renderer and set it to false.

        * khtml/html/html_formimpl.cpp: (HTMLGenericFormElementImpl::attach):
	Rearrange this so that the base class attach is called before updateFromElement
	is called. This allows the base attach to do a close for us before we update.

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::insertNode): Call closeRenderer on the DOM node rather than
	calling close on the render node.
        (KHTMLParser::popOneBlock): Ditto.
        * khtml/xml/xml_tokenizer.cpp:
        (XMLHandler::endElement): Ditto.
        (XMLTokenizer::finish): Ditto.

2002-10-19  David Hyatt  <hyatt@apple.com>

	A couple of whitespace fixes.  What's really odd about these
	fixes is that they *work* but only if you load the page by
	hitting "Back".  I suspect that I've now fixed the bugs on
	KHTML's end, and we have some sort of whitepsace dropping
	problem on our end.

        * khtml/html/htmlparser.cpp:
        (KHTMLParser::insertNode):
        * khtml/html/htmltokenizer.cpp:
        (HTMLTokenizer::write):

2002-10-18  Richard Williamson   <rjw@apple.com>

        Fixed khtml to ignore <title> tags after the first tag.
        
        Fixed setting document.title from JavaScript.
        
        * khtml/dom/html_document.cpp:
        (HTMLDocument::setTitle):
        * khtml/html/html_headimpl.cpp:
        (HTMLTitleElementImpl::insertedIntoDocument):
        (HTMLTitleElementImpl::childrenChanged):

2002-10-18  Darin Adler  <darin@apple.com>

	- fixed 3078293 -- Implement evaluateJavaScript on WebController

        * kwq/KWQVariant.mm: (QVariant::asString): Made this return reasonable
	values for types other than string. Still may be loose ends left, but
	this takes care of most of it.

2002-10-18  Darin Adler  <darin@apple.com>

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge stringByEvaluatingJavaScriptFromString:]):
	Changed to return a string and changed name.

2002-10-18  David Hyatt  <hyatt@apple.com>

	The collapsing margin rewrite. Also fixes a bug where
	we stay in quirks mode for strict HTML4 dtds when we
	shouldn't.
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::determineParseMode):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layout):
        (RenderFlow::layoutBlockChildren):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_object.h:

2002-10-18  Darin Adler  <darin@apple.com>

        * Makefile.am: Move dependency so clean happens before build.

2002-10-17  Richard Williamson  <rjw@apple.com>

        Support for drawing frame borders and frame resizing. (fixes 2982466).

        * khtml/rendering/render_frames.cpp:
        (RenderFrameSet::userResize):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge frameBorderStyle]):
        * kwq/qt/qframe.h:

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 2807340 -- Alex is case sensitive for anchors, but
	should not be in quirks mode (other browsers aren't)

        * khtml/dom/html_misc.cpp: Touched this file to prevent us from requiring a
	full build. Damned header dependencies still don't work right.

        * khtml/html/html_miscimpl.h: Add caseSensitive parameters.
        * khtml/html/html_miscimpl.cpp:
        (HTMLCollectionImpl::getNamedItem): Add caseSensitive parameter, and compare
	by converting both to lower case if it's false and pass it on when recursing.
        (HTMLCollectionImpl::namedItem): Pass along a caseSensitive parameter.
        (HTMLFormCollectionImpl::getNamedItem): Pass along a caseSensitive parameter.
        (HTMLFormCollectionImpl::getNamedFormItem): Pass along, and handle, it.
        (HTMLFormCollectionImpl::getNamedImgItem): Ditto.
        (HTMLFormCollectionImpl::nextNamedItemInternal): Pass true for caseSensitive.

        * khtml/khtml_part.cpp: (KHTMLPart::gotoAnchor):
	Pass false for the new caseSensitive parameter to namedItem when the document
	mode is not strict.

        * kwq/KWQListBox.mm: (QListBox::sizeForNumberOfLines): Removed a stray NSLog
	that I left in by accident.

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 3052547 -- <select> doesn't size properly (size > 1)

        * khtml/rendering/render_form.cpp:
        (RenderLineEdit::slotReturnPressed): #if !APPLE_CHANGES around some unused
	code in here.
        (RenderSelect::updateFromElement): Fix bug where it was using Multi here, but
	Extended elsewhere for the selection mode.
        (RenderSelect::layout): Change code so that QListBox handles the sizing.

        * kwq/KWQListBox.h: Removed a lot of unused stuff, made other things use inlines.
        * kwq/KWQListBox.mm: Rewrote most of the file contents. Made a new
	QListBox::sizeForNumberOfLines method. We will have to port this to NSTableView
	rather than NSBrowser.

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 3078245 -- REGRESSION: lightgrey displays as black, used
	to display as white, should display light gray

        * kwq/KWQColor.mm: (getNamedColors): For every color with the name
	"gray" in it, also include the version spelled "grey" as other
	browsers seem to.

2002-10-17  David Hyatt  <hyatt@apple.com>

	Make navigator.product dynamic based off user agent (i.e.,
	make it participate in spoofing too).
	
        * khtml/ecma/kjs_navigator.cpp:
        (Navigator::getValueProperty):

=== Alexander-28 ===

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 3077856 -- REGRESSION: scroll to fragment doesn't work
	(except when Alex started from command line)

        * kwq/kparts/browserextension.h: Initialize reload to false. It was
	uninitialized, and when true was preventing anchor navigation from working.

2002-10-17  Darin Adler  <darin@apple.com>

	- fixed 3075992 -- Hang in khtml::RenderFlow::lowestPosition() trying to
	render http://avoyagetoarcturus.blogspot.com/

        * khtml/rendering/render_flow.cpp:
        (RenderFlow::lowestPosition): Don't recurse on the same child twice.
        (RenderFlow::rightmostPosition): Ditto.

2002-10-17  David Hyatt  <hyatt@apple.com>

	Fix bayarea.com.  My implementation of offsetParent was
	flawed.  And to think I was blaming Gecko... ;)
	
        * khtml/rendering/render_object.cpp:
        (RenderObject::offsetParent):

2002-10-16  Darin Adler  <darin@apple.com>

	- fixed 3061103 -- Line-breaks lost when submitting after pasting text from
	MSIE into Alexander textarea

        * kwq/KWQLineEdit.mm: (QLineEdit::text):
        * kwq/KWQTextEdit.mm: (QTextEdit::text):
	Turn \r\n sequences and standalone \r characters into \n characters on the way
	out of AppKit land and into KHTML land. I didn't try to make this efficient
	for the common case because these are not time-critical functions.

2002-10-16  Richard Williamson  <rjw@apple.com>

        Fixed a few regressions in drawing of frame resize handle
        in preparation for drawing frame borders and completing
        2982466.
        
        * khtml/rendering/render_frames.cpp:
        (RenderFrameSet::userResize):
        * kwq/KWQPainter.mm:
        (QPainter::drawRect):
        * kwq/qt/qscrollview.h:
        * kwq/KWQScrollView.mm:
        (QScrollView::updateContents):
        * kwq/KWQWidget.mm:
        (QWidget::enableFlushDrawing):
        
        Use static_cast everywhere DOM::NodeImpl is cast to
        subclass.
        
        * kwq/WebCoreDOMNode.mm:
        (-[WebCoreDOMNode DOM::]):
        (-[WebCoreDOMNodeList DOM::]):
        (-[WebCoreDOMNamedNodeMap DOM::]):
        (-[WebCoreDOMAttr DOM::]):

2002-10-16  David Hyatt  <hyatt@apple.com>

	Fix crash on pages with bulleted lists.  Making sure the list
	item marker doesn't get a layer (which means it has to be
	painted by hand now by the list item object).
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        * khtml/rendering/render_list.cpp:
        (RenderListItem::printObject):
        * khtml/rendering/render_list.h:
        * khtml/rendering/render_object.h:

2002-10-16  Darin Adler  <darin@apple.com>

	- fixed 3072542 -- double "&" in submit button

        * khtml/rendering/render_form.cpp: (RenderSubmitButton::rawText):
	Don't double the "&" character, not needed for KWQ.

2002-10-16  David Hyatt  <hyatt@apple.com>

	When render objects were being dynamically wrapped in anonymous
	blocks, the layer parenting connection was being broken without
	being reconnected when the wrapping finished.  This patch
	shifts the layer connection into the functions that are also
	called in the dynamic case.

	With this fix, all objects on mrskin finally show up.  Yeehah.
	brainjar.com's brain is back too.

	This patch also stops treating images as inline if they are
	using abs/fixed positioning, since according to the CSS spec,
	abs/fixed positioned elements should be treated as block-level
	content.
	
        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild):
        (RenderContainer::appendChildNode):
        (RenderContainer::insertChildNode):
        * khtml/rendering/render_image.cpp:
        (RenderImage::setStyle):

2002-10-16  Darin Adler  <darin@apple.com>

	- fixed 3045570 -- can't select a printer at inkfinder.com

        * khtml/khtml_part.cpp: (KHTMLPart::processObjectRequest):
	Call the new openURL for the case where we are reusing a part.
	We do this backwards from how KHTML does, so it's twisted.

        * kwq/KWQKHTMLPartImpl.h: Add openURL.
        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::openURL):
	Tell the bridge to load the URL.

        * kwq/mac-encodings.txt: Tweak Korean encoding names.

2002-10-16  David Hyatt  <hyatt@apple.com>

	A very substantial change.  Absolute/fixed positioned elements that
	are NOT renderflows were not getting layers constructed for them.
	They do now.

	Also, floats now have layers constructed for them.  This allows
	printSpecialObjects to be completely eliminated, enables smarter
	damge rect intersection testing for faster painting, and fixes
	regressions on sites like www.demian5.com.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::printObject):
        (RenderFlow::addOverHangingFloats):
        (RenderFlow::printTree):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):
        * khtml/rendering/render_root.cpp:
        (RenderRoot::printObject):
        * khtml/rendering/render_table.cpp:
        (RenderTable::print):

2002-10-16  Richard Williamson  <rjw@apple.com>

        Removed bogus code.
        
        * kwq/KWQKHistoryProvider.mm:

2002-10-15  Richard Williamson  <rjw@apple.com>

        * kwq/WebCoreBridge.mm:
        (attributedString):
        Don't convert element unless it has a renderer.

        * kwq/WebCoreDOMNode.mm:
        (-[WebCoreDOMAttr DOM::]):
        (-[WebCoreDOMAttr name]):
        (-[WebCoreDOMAttr specified]):
        (-[WebCoreDOMAttr value]):
        (-[WebCoreDOMAttr ownerElement]):
        (-[WebCoreDOMElement tagName]):
        (-[WebCoreDOMElement setAttribute::]):
        (-[WebCoreDOMElement removeAttribute:]):
        (-[WebCoreDOMElement getAttributeNode:]):
        (-[WebCoreDOMElement removeAttributeNode:]):
        (-[WebCoreDOMElement getElementsByTagName:]):
        (-[WebCoreDOMElement getAttributeNS::]):
        (-[WebCoreDOMElement setAttributeNS:::]):
        (-[WebCoreDOMCharacterData data]):
        (-[WebCoreDOMCharacterData setData:]):
        (-[WebCoreDOMCharacterData length]):
        (-[WebCoreDOMCharacterData substringData::]):
        (-[WebCoreDOMCharacterData appendData:]):
        (-[WebCoreDOMCharacterData insertData::]):
        (-[WebCoreDOMCharacterData deleteData::]):
        (-[WebCoreDOMText splitText:]):
        (-[WebCoreDOMProcessingInstruction data]):
        (-[WebCoreDOMProcessingInstruction setData:]):
        * kwq/WebCoreDOMPrivate.h:
        API cleanup.

2002-10-15  David Hyatt  <hyatt@apple.com>

	More work on making blocks correctly compute their maximal
	positive and negative margins.  Adding code to ensure
	that floats and absolute/fixed positioned elements know
	not to collapse with children or with themselves.  Also adding
	code to teach empty blocks that they can collapse their own
	margins together.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layout):
        (RenderFlow::layoutBlockChildren):

2002-10-15  Darin Adler  <darin@apple.com>

	WebCore support for using referrer even in loads that are not initiated
	by WebCore itself.

        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow): Don't pass a referrer.
	We get the referrer from the part.

        * kwq/KWQKHTMLPartImpl.h: Add a new referrer method that works on the
	part, and remove the old one that got it from the URL arguments.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::bridgeForFrameName): Don't pass a referrer when
	creating a new window.
        (KWQKHTMLPartImpl::openURLRequest): Don't pass a referrer when doing a load.
        (KWQKHTMLPartImpl::urlSelected): Don't pass a referrer when doing a load.
        (KWQKHTMLPartImpl::createPart): Don't pass a referrer when creating a child
	frame for this window.
        (KWQKHTMLPartImpl::submitForm): Don't pass a referrer when doing a load.
        (KWQKHTMLPartImpl::referrer): Added.

        * kwq/KWQLoaderImpl.mm: (KWQServeRequest): Don't pass a referrer when starting
	a load.
        * kwq/WebCoreBridge.h: Add referrer method. Remove referrer parameter from
	many other methods.
        * kwq/WebCoreBridge.mm: (-[WebCoreBridge referrer]): Added.

2002-10-15  Darin Adler  <darin@apple.com>

	- fixed 3021713 -- text selection background obliterates descenders
	(in www.theregister.co.uk articles)
	- fixed 3038207 -- Selected link text doesn't draw its link underline

        * khtml/rendering/render_text.cpp:
        (TextSlave::printSelection): Don't draw text at all, just draw a selection background.
        (RenderText::printObject): Draw in two passes. Draw the selection background in the
	first pass, and the text in the second pass. That way pieces of the background won't
	cover any other text or adornments, like underlines.

2002-10-15  Darin Adler  <darin@apple.com>

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::urlSelected):
	Move the special case of a different anchor within the same
	page into WebKit from here.

        * kwq/kdecore/kurl.h: Mark urlcmp as a friend.
        * kwq/KWQKURL.mm: (urlcmp): Implement the ignoreRef feature, which
	is needed to make the KHTMLPart::openURL function work right.

        * kwq/WebCoreBridge.h: Removed addBackForwardItemWithURL:anchor:
	and added URL method.
        * kwq/WebCoreBridge.mm: (-[WebCoreBridge URL]): Added.

2002-10-15  Darin Adler  <darin@apple.com>

	- fixed 3074558 -- frames multiply at: http://www.iarsn.com/

	The key was to make the name attribute work properly.

        * khtml/ecma/kjs_window.cpp:
        (Window::get): Enable the "name" attribute.
        (Window::put): Enable the "name" attribute, but don't do the
	conversion to an 8-bit string -- leave it as a QString.
        * kwq/WebCoreBridge.h: Add setName/name methods.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge setName:]): Added. Calls part->setName().
        (-[WebCoreBridge name]): Added. Calls part->name().
        * kwq/kparts/part.h: Added setName/name to ReadOnlyPart.

        * kwq/KWQKHTMLPartImpl.mm: Remove old bogusish comment.

2002-10-15  Richard Williamson  <rjw@apple.com>

        Added text color to attributed string conversion.
        
        * kwq/WebCoreBridge.mm:
        (attributedString):

2002-10-15  Richard Williamson  <rjw@apple.com>

        Added API to get attributed string from bridge.
        Added API to get selection in terms of the DOM API
        from the bridge.
        
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (attributedString):
        (-[WebCoreBridge selectionStart]):
        (-[WebCoreBridge selectionStartOffset]):
        (-[WebCoreBridge selectionEnd]):
        (-[WebCoreBridge selectionEndOffset]):

2002-10-15  Darin Adler  <darin@apple.com>

	- fixed 3054791 -- crash in WebCoreSettings _updateAllViews changing font

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::~KWQKHTMLPartImpl):
	Pass in the "this" pointer so that the right instance is removed from the
	instances list. Before, we would always remove the first instance from the
	list, leaving the list broken.

2002-10-15  Ken Kocienda  <kocienda@apple.com>

	Fixed an "unused variable" build breaker. Note that I just 
	commented out the code and put a FIXME, as I know this is code
	that David has been banging on a lot. This should be either
	used for real or removed eventually, but I'll leave that for 
	Hyatt.

        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layoutBlockChildren):

2002-10-14  David Hyatt  <hyatt@apple.com>

	More collapsing margin surgery.  Working on setting up blocks 
	to properly compute their collapsed margins (without actually changing
	the obsolete collapsing behavior yet).
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::RenderFlow):
        (RenderFlow::layout):
        (RenderFlow::layoutBlockChildren):
        * khtml/rendering/render_flow.h:

2002-10-14  David Hyatt  <hyatt@apple.com>

	Adding helper functions for handling of collapsing margins.
	Not used yet.
	
        * khtml/rendering/render_object.h:

2002-10-14  Darin Adler  <darin@apple.com>

	Fixed problems with named colors.

        * kwq/KWQColor.mm: (QColor::setNamedColor): Check named colors before
	hex codes for colors because our hex code parsing is now lenient enough
	that many names qualify.

2002-10-14  David Hyatt  <hyatt@apple.com>

	Really fixing zeldman.com this time.  This disabling stuff
	is complicated! :)
	
        * khtml/html/html_headimpl.cpp:
        (HTMLLinkElementImpl::parseAttribute):
        (HTMLLinkElementImpl::setStyleSheet):
        (HTMLLinkElementImpl::sheetLoaded):

2002-10-14  David Hyatt  <hyatt@apple.com>

	Stop the insanity.  Make sure that a sheet that is disabled
	while it is still loading is removed from the doc's list
	of pending sheets (for FOUC checks).

	Fixes zeldman.com.
	
        * khtml/html/html_headimpl.cpp:
        (HTMLLinkElementImpl::parseAttribute):

2002-10-14  David Hyatt  <hyatt@apple.com>

	Implementing the ability to individually enable/disable
	both preferred and alternate stylesheets.  Enabling/disabling
	sheets via the disabled property of the <link> element overrides
	whether or not a sheet happens to be alternate or preferred.

	This new implementation of sheet disabling/enabling was a missing
	piece of our HTML4 compliance, and was used by the Wired 
	site to implement its text sizing mechanism.
	
        * khtml/html/html_headimpl.cpp:
        (HTMLLinkElementImpl::HTMLLinkElementImpl):
        (HTMLLinkElementImpl::parseAttribute):
        (HTMLLinkElementImpl::process):
        * khtml/html/html_headimpl.h:
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyleSelector):

2002-10-11  Richard Williamson   <rjw@apple.com>

        Remove debugging.
        
        * kwq/WebCoreDOMDocument.mm:
        (+[WebCoreDOMDocument documentWithImpl:DOM::]):
        * kwq/WebCoreDOMNode.mm:
        (-[WebCoreDOMNode lastChild]):

2002-10-11  Richard Williamson   <rjw@apple.com>

        More DOM/attributed string work.  Still need to fix more
        inappropriate casting problems.
        
        * khtml/dom/dom_node.cpp:
        (Node::lastChild):
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::lastChild):
        (NodeBaseImpl::lastChild):
        * khtml/xml/dom_nodeimpl.h:
        * kwq/KWQKHTMLPartImpl.cpp:
        (KWQKHTMLPartImpl::selectionStartOffset):
        (KWQKHTMLPartImpl::selectionEndOffset):
        (KWQKHTMLPartImpl::selectionStart):
        (KWQKHTMLPartImpl::selectionEnd):
        * kwq/KWQKHTMLPartImpl.h:
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge DOMDocument]):
        (-[WebCoreBridge setSelectionFrom:startOffset:to:endOffset:]):
        (attributedString):
        (-[WebCoreBridge selectedAttributedString]):
        (-[WebCoreBridge attributedStringFrom:startOffset:to:endOffset:]):
        * kwq/WebCoreDOMDocument.mm:
        (-[WebCoreDOMDocumentType DOM::]):
        (-[WebCoreDOMDocumentType name]):
        (-[WebCoreDOMDocumentType entities]):
        (-[WebCoreDOMDocumentType notations]):
        (-[WebCoreDOMDocumentType publicId]):
        (-[WebCoreDOMDocumentType systemId]):
        (-[WebCoreDOMDocumentType internalSubset]):
        (-[WebCoreDOMImplementation DOM::]):
        (-[WebCoreDOMImplementation hasFeature::]):
        (-[WebCoreDOMImplementation createDocument:::]):
        (+[WebCoreDOMDocument documentWithImpl:DOM::]):
        (-[WebCoreDOMDocument DOM::]):
        (-[WebCoreDOMDocument doctype]):
        (-[WebCoreDOMDocument implementation]):
        (-[WebCoreDOMDocument documentElement]):
        (-[WebCoreDOMDocument createElement:]):
        (-[WebCoreDOMDocument createElementNS::]):
        (-[WebCoreDOMDocument createDocumentFragment]):
        (-[WebCoreDOMDocument createTextNode:]):
        (-[WebCoreDOMDocument createComment:]):
        (-[WebCoreDOMDocument createCDATASection:]):
        (-[WebCoreDOMDocument createProcessingInstruction::]):
        (-[WebCoreDOMDocument createAttribute:]):
        (-[WebCoreDOMDocument createAttributeNS::]):
        (-[WebCoreDOMDocument createEntityReference:]):
        (-[WebCoreDOMDocument getElementById:]):
        (-[WebCoreDOMDocument getElementsByTagName:]):
        (-[WebCoreDOMDocument getElementsByTagNameNS::]):
        (-[WebCoreDOMDocument importNode::]):
        * kwq/WebCoreDOMNode.mm:
        (-[WebCoreDOMNode initWithImpl:DOM::]):
        (-[WebCoreDOMNode firstChild]):
        (-[WebCoreDOMNode lastChild]):
        * kwq/WebCoreDOMPrivate.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge setSelectionFrom:startOffset:to:endOffset:]):
        (recursive_toHTML):
        (attributedString):

2002-10-11  David Hyatt  <hyatt@apple.com>

	Fix for 3058829, assertion caused by table cell with
	incorrect display type.  Implemented a quirk that forces
	<td>s of display: block to construct table cells as
	rendering objects. 
	
        * khtml/rendering/render_object.cpp:
        (RenderObject::createObject):

=== Alexander-27 ===

2002-10-10  Darin Adler  <darin@apple.com>

	- fixed 3047782 -- Alexander rejects some color strings that other browsers accept

        * khtml/misc/helper.cpp: (khtml::setNamedColor): Put some of the code from this
	level that tries to accomodate bad colors in #if !APPLE_CHANGES, since we do most
	of the smarts in KWQ.

        * kwq/KWQColor.mm:
        (hex2int): Tolerate non-hex digits, treating them as 0.
        (decodeColorFromHexColorString): Trim any number of leading # characters, and trailing
	" and ' characters. Handle strings of 4, 5, 7, 8, 10, and 11 hex digits, along with
	the existing 3, 6, 9, and 12.

2002-10-10  David Hyatt  <hyatt@apple.com>

	Fix a subtle bug with layers.  When a parent is sorted with its
	children the parent's zindex must be treated as 0, so that
	negative children draw behind the layer's content and positive
	children (or auto children) draw in front of the layer's content.

	This fix makes chrysler.com work again (and doubtless many other
	messed up DHTML sites).
	
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):
        (RenderLayer::RenderZTreeNode::constructLayerList):

2002-10-09  Richard Williamson  <rjw@apple.com>

        Implemented string conversion functions.
        
        * kwq/WebCoreDOMDocument.mm:
        (domStringToNSString):
        (NSStringToDOMString):

2002-10-09  Darin Adler  <darin@apple.com>

	- fixed 3069264 -- REGRESSION: windows created for links with
	target=blank start out hidden (window menu only)

        * kwq/WebCoreBridge.h: Removed openNewWindowWithURL:referrer:frameName: and
	added createWindowWithURL:referrer:frameName: and showWindow.

        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow): Call createWindowWithURL,
	and then showWindow after the window is set up. Also change the code that
	flips coordinates to always use the height of the first screen instead of
	using the height of the screen the window is on, which sounds right, but
	is wrong.

        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::bridgeForFrameName): Call createWindowWithURL and then
	showWindow in the case where we create a window.
        (KWQKHTMLPartImpl::urlSelected): Remove unused command-click code. The real
	command-click code is in the browser now.

2002-10-09  Darin Adler  <darin@apple.com>

	- fixed 3069749 -- crash in QString during third run of cvs-base

        * kwq/KWQString.mm:
        (checkNodeAllocationPages): Added function to use for debugging.
        (_allocateNode): Clear the next pointer after removing a page from the free
	node list so that the free node list doesn't point at part of the used node list.
        (freeHandle): Change the code around so that the code to add the node to the
	free list works even in the case where this was the top from the used list.
	The old code would half-remove the node from the used list and not add it to
	the free list at all.

2002-10-09  Darin Adler  <darin@apple.com>

        * WebCore.pbproj/project.pbxproj: Project Builder wanted to set encodings
	for new files. Maybe Richard is not using the new Project Builder on all
	his machines?

        * kwq/KWQString.mm: (_allocateNode): Fix typo in comment.

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::bridgeForFrameName): Tweak.

2002-10-09  David Hyatt  <hyatt@apple.com>

	This was an unintentional checkin. backing out.
	
        * khtml/xml/dom_elementimpl.cpp:
        (NamedAttrMapImpl::removeNamedItem):

2002-10-08  Richard Williamson   <rjw@apple.com>

        Added bridge method set the selection.
        
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge setSelectionFrom:startOffset:to:endOffset:]):

2002-10-08  Richard Williamson   <rjw@apple.com>

        Added bridge method to get the DOM document.
        
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge DOMDocument]):
        * kwq/WebCoreDOM.h:

2002-10-08  Richard Williamson   <rjw@apple.com>

        More DOM implementation.
        
        * khtml/dom/dom_text.h:
        * khtml/dom/dom_xml.h:
        * khtml/xml/dom_textimpl.h:
        * khtml/xml/dom_xmlimpl.h:
        * kwq/WebCoreDOM.h:
        * kwq/WebCoreDOMNode.mm:
        (DOM::CharacterDataImpl::createInstance):
        (DOM::TextImpl::createInstance):
        (DOM::ProcessingInstructionImpl::createInstance):
        (-[WebCoreDOMCharacterData data]):
        (-[WebCoreDOMCharacterData setData:]):
        (-[WebCoreDOMCharacterData length]):
        (-[WebCoreDOMCharacterData substringData::]):
        (-[WebCoreDOMCharacterData appendData:]):
        (-[WebCoreDOMCharacterData insertData::]):
        (-[WebCoreDOMCharacterData deleteData::]):
        (-[WebCoreDOMText splitText:]):
        (+[WebCoreDOMCDATASection CDATASectionWithImpl:DOM::]):
        (-[WebCoreDOMProcessingInstruction data]):
        (-[WebCoreDOMProcessingInstruction setData:]):
        * kwq/WebCoreDOMPrivate.h:
        * kwq/WebDOMElement.h:

2002-10-08  Richard Williamson   <rjw@apple.com>

        Implemented WebCoreDOMElement.
        Fixed extra deref of impl in subclasses
        of WebCoreDOMNode.
        
        * khtml/dom/dom_element.h:
        * khtml/dom/dom_node.h:
        * khtml/xml/dom_elementimpl.h:
        * khtml/xml/dom_nodeimpl.h:
        * kwq/WebCoreDOMDocument.mm:
        (-[WebCoreDOMDocument initWithImpl:DOM::]):
        * kwq/WebCoreDOMNode.mm:
        (DOM::NodeListImpl::createInstance):
        (DOM::NamedNodeMapImpl::createInstance):
        (DOM::AttrImpl::createInstance):
        (DOM::ElementImpl::createInstance):
        (-[WebCoreDOMNodeList length]):
        (-[WebCoreDOMNodeList item:]):
        (-[WebCoreDOMAttr initWithImpl:DOM::]):
        (+[WebCoreDOMDocumentFragment documentFragmentWithImpl:DOM::]):
        (-[WebCoreDOMElement tagName]):
        (-[WebCoreDOMElement setAttribute::]):
        (-[WebCoreDOMElement removeAttribute:]):
        (-[WebCoreDOMElement getAttributeNode:]):
        (-[WebCoreDOMElement removeAttributeNode:]):
        (-[WebCoreDOMElement getElementsByTagName:]):
        (-[WebCoreDOMElement getAttributeNS::]):
        (-[WebCoreDOMElement setAttributeNS:::]):
        * kwq/WebDOMDocument.h:
        * kwq/WebDOMElement.h:

2002-10-08  Richard Williamson   <rjw@apple.com>

        First cut at ObjC stubs for DOM API.  Finished the
        main classes.  Need to finish
        WebDOMElement, WebDOMElement, WebDOMElement, 
        WebDOMCDATASection, WebDOMText, WebDOMComment,
        WebDOMCharacterData and 
        
        * WebCore.pbproj/project.pbxproj:
        * khtml/dom/dom_doc.h:
        * khtml/dom/dom_element.h:
        * khtml/dom/dom_node.h:
        * khtml/xml/dom_docimpl.h:
        * khtml/xml/dom_elementimpl.h:
        * khtml/xml/dom_nodeimpl.h:
        * kwq/WebCoreDOM.h: Added.
        * kwq/WebCoreDOMDocument.mm: Added.
        (DOM::DOMImplementationImpl::createInstance):
        (DOM::DocumentTypeImpl::createInstance):
        (DOM::DocumentImpl::createInstance):
        (domStringToNSString):
        (NSStringToDOMString):
        (+[WebCoreDOMDocumentType documentTypeWithImpl:DOM::]):
        (-[WebCoreDOMDocumentType initWithImpl:DOM::]):
        (-[WebCoreDOMDocumentType dealloc]):
        (-[WebCoreDOMDocumentType DOM::]):
        (-[WebCoreDOMDocumentType name]):
        (-[WebCoreDOMDocumentType entities]):
        (-[WebCoreDOMDocumentType notations]):
        (-[WebCoreDOMDocumentType publicId]):
        (-[WebCoreDOMDocumentType systemId]):
        (-[WebCoreDOMDocumentType internalSubset]):
        (+[WebCoreDOMImplementation implementionatWithImpl:DOM::]):
        (-[WebCoreDOMImplementation initWithImpl:DOM::]):
        (-[WebCoreDOMImplementation dealloc]):
        (-[WebCoreDOMImplementation DOM::]):
        (-[WebCoreDOMImplementation hasFeature::]):
        (-[WebCoreDOMImplementation createDocument:::]):
        (+[WebCoreDOMDocument documentWithImpl:DOM::]):
        (-[WebCoreDOMDocument initWithImpl:DOM::]):
        (-[WebCoreDOMDocument dealloc]):
        (-[WebCoreDOMDocument DOM::]):
        (-[WebCoreDOMDocument doctype]):
        (-[WebCoreDOMDocument implementation]):
        (-[WebCoreDOMDocument documentElement]):
        (-[WebCoreDOMDocument createElement:]):
        (-[WebCoreDOMDocument createElementNS::]):
        (-[WebCoreDOMDocument createDocumentFragment]):
        (-[WebCoreDOMDocument createTextNode:]):
        (-[WebCoreDOMDocument createComment:]):
        (-[WebCoreDOMDocument createCDATASection:]):
        (-[WebCoreDOMDocument createProcessingInstruction::]):
        (-[WebCoreDOMDocument createAttribute:]):
        (-[WebCoreDOMDocument createAttributeNS::]):
        (-[WebCoreDOMDocument createEntityReference:]):
        (-[WebCoreDOMDocument getElementById:]):
        (-[WebCoreDOMDocument getElementsByTagName:]):
        (-[WebCoreDOMDocument getElementsByTagNameNS::]):
        (-[WebCoreDOMDocument importNode::]):
        * kwq/WebCoreDOMNode.mm: Added.
        (DOM::NamedNodeMapImpl::createInstance):
        (DOM::AttrImpl::createInstance):
        (+[WebCoreDOMNode nodeWithImpl:DOM::]):
        (-[WebCoreDOMNode initWithImpl:DOM::]):
        (-[WebCoreDOMNode DOM::]):
        (-[WebCoreDOMNode dealloc]):
        (-[WebCoreDOMNode nodeName]):
        (-[WebCoreDOMNode nodeValue]):
        (-[WebCoreDOMNode setNodeValue:]):
        (-[WebCoreDOMNode nodeType]):
        (-[WebCoreDOMNode parentNode]):
        (-[WebCoreDOMNode firstChild]):
        (-[WebCoreDOMNode lastChild]):
        (-[WebCoreDOMNode previousSibling]):
        (-[WebCoreDOMNode nextSibling]):
        (-[WebCoreDOMNode ownerDocument]):
        (-[WebCoreDOMNode insert:before:]):
        (-[WebCoreDOMNode replace:child:]):
        (-[WebCoreDOMNode removeChild:]):
        (-[WebCoreDOMNode hasChildNodes]):
        (-[WebCoreDOMNode cloneNode:]):
        (-[WebCoreDOMNode normalize]):
        (-[WebCoreDOMNode isSupported::]):
        (-[WebCoreDOMNode namespaceURI]):
        (-[WebCoreDOMNode prefix]):
        (-[WebCoreDOMNode setPrefix:]):
        (-[WebCoreDOMNode localName]):
        (+[WebCoreDOMNodeList nodeListWithImpl:DOM::]):
        (-[WebCoreDOMNodeList initWithImpl:DOM::]):
        (-[WebCoreDOMNodeList DOM::]):
        (-[WebCoreDOMNodeList dealloc]):
        (+[WebCoreDOMNamedNodeMap namedNodeMapWithImpl:DOM::]):
        (-[WebCoreDOMNamedNodeMap initWithImpl:DOM::]):
        (-[WebCoreDOMNamedNodeMap DOM::]):
        (-[WebCoreDOMNamedNodeMap dealloc]):
        (-[WebCoreDOMNamedNodeMap length]):
        (-[WebCoreDOMNamedNodeMap getNamedItem:]):
        (-[WebCoreDOMNamedNodeMap setNamedItem:]):
        (+[WebCoreDOMAttr attrWithImpl:DOM::]):
        (-[WebCoreDOMAttr initWithImpl:DOM::]):
        (-[WebCoreDOMAttr DOM::]):
        (-[WebCoreDOMAttr dealloc]):
        (-[WebCoreDOMAttr name]):
        (-[WebCoreDOMAttr specified]):
        (-[WebCoreDOMAttr value]):
        (-[WebCoreDOMAttr ownerElement]):
        (+[WebCoreDOMCDATASection CDATASectionWithImpl:DOM::]):
        (-[WebCoreDOMCDATASection initWithImpl:DOM::]):
        (-[WebCoreDOMCDATASection DOM::]):
        (-[WebCoreDOMCDATASection dealloc]):
        * kwq/WebCoreDOMPrivate.h: Added.
        * kwq/WebDOMDocument.h: Added.
        * kwq/WebDOMElement.h: Added.
        * kwq/WebDOMNode.h: Added.

2002-10-09  David Hyatt  <hyatt@apple.com>

	Fix a bug in my event handling code for layers.   This makes
	the links on ESPN.com work again (bug 3051636).  Yay!
	
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):
        * khtml/xml/dom_elementimpl.cpp:
        (NamedAttrMapImpl::removeNamedItem):
        * kwq/qt/qrect.h:

2002-10-07  Darin Adler  <darin@apple.com>

	- fixed 3037353 -- align="middle" elements not horizontally centered

        * khtml/html/html_blockimpl.cpp: (HTMLDivElementImpl::parseAttribute):
        * khtml/html/html_tableimpl.cpp: (HTMLTablePartElementImpl::parseAttribute):
	Handle "middle" same as center in these two places.

2002-10-07  Darin Adler  <darin@apple.com>

	WebCore part of implementation of multipart forms posting.

        * kwq/WebCoreBridge.h: Add a contentType parameter to the bridge's
	[postWithURL:referrer:data:] method.

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::submitForm):
	Extract the content type from the args, and pass it along to the bridge.

2002-10-07  Darin Adler  <darin@apple.com>

	- fixed 3011025 -- Page up/down is not working when text area has focus

        * kwq/KWQTextArea.mm:
        (-[KWQTextArea needsPanelToBecomeKey]): Return YES so we are considered a
	valid key view even when in normal tabbing mode. This fixes a problem with
	tabbing backwards into a text area.
        (-[KWQTextAreaTextView scrollPageUp:]): Added. Passes a scrollPageUp:
	selector along the responder chain if we are already scrolled to the top.
        (-[KWQTextAreaTextView scrollPageDown:]): Ditto.

        * kwq/KWQNSTextField.mm: Remove unnecessary overrides of textDidEndEditing.
	Turns out the real fix was to override display to do nothing as a workaround
	for bug 2753974.

2002-10-07  Richard Williamson   <rjw@apple.com>

        Added response to WebCore's CachedObject.  This allows us to correctly
        emulate the WebResourceLoadDelegate API when 're'loading an item
        from the WebCore cache.  
        
        * khtml/misc/loader.cpp:
        (CachedObject::~CachedObject):
        (CachedObject::setResponse):
        (Loader::receivedResponse):
        * khtml/misc/loader.h:
        * kwq/KWQLoaderImpl.h:
        * kwq/KWQLoaderImpl.mm:
        (-[WebCoreResourceLoader receivedResponse:]):
        (KWQCheckCacheObjectStatus):
        (KWQRetainResponse):
        (KWQReleaseResponse):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreResourceLoader.h:

2002-10-06  Darin Adler  <darin@apple.com>

	- fixed 3046737 -- infinite loop in font name matching code on some pages

        * kwq/KWQString.mm: (QString::replace): Removed the incorrect early exit if
	the passed in string was the empty string.

2002-10-04  Darin Adler  <darin@apple.com>

        * kwq/KWQKURL.mm: (KURL::parse): Fix code that adds "//" to file URLs.
	The code was including the extra slashes as part of the path, which they are not.
	Verified with the tests in the Tests directory.

2002-10-03  Darin Adler  <darin@apple.com>

	- fixed 3065730 -- Crash loading "My T-Mobile" page (in khtml::Decoder::decode)

        * khtml/misc/decoder.cpp: (Decoder::decode): Fixed a mistake that would cause
	the loop to run off the end of the buffer, introduced back on 2002-08-30.

2002-10-03  Darin Adler  <darin@apple.com>

	Add API to execute JavaScript.

        * kwq/WebCoreBridge.h: Add method.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge executeJavaScriptFromString:]): Call through to
	KHTML. But only if the document is not nil. We need to figure out
	what to do in the case where the document is nil.

=== Alexander-26 ===

2002-10-02  Darin Adler  <darin@apple.com>

	Moved "overURL" handling out of WebCore into WebKit and Alex.
	Also separated the two levels of the "element dictionary" so they
	don't rely on having the same keys.

        * khtml/khtml_part.h: Revert the APPLE_CHANGES to overURL.
        * khtml/khtml_part.cpp:
        (KHTMLPart::overURL): Removed the APPLE_CHANGES and just ifdef'd out
	the whole thing for our version.
        (KHTMLPart::khtmlMouseMoveEvent): Get rid of the APPLE_CHANGES and
	don't do any of the status bar setup.

        * kwq/KWQKHTMLPartImpl.h: Remove overURL.
        * kwq/KWQKHTMLPartImpl.mm: Ditto.

        * kwq/WebCoreBridge.h: Change keys so they don't match the WebKit ones so
	we don't accidentally rely on that. Add WebCoreElementLinkTarget.

        * kwq/WebCoreBridge.mm: (-[WebCoreBridge elementAtPoint:]): Add code to
	set up WebCoreElementLinkTarget.

2002-10-01  Darin Adler  <darin@apple.com>

	- fixed 3055076 -- window.scroll does a window.scrollby, not a window.scrollto

        * khtml/ecma/kjs_window.cpp: (WindowFunc::tryCall): Moved a case so that the
	scroll code would scroll to, not by.

2002-10-01  David Hyatt  <hyatt@apple.com>

	Fix the case sensitivity problem with attribute names 
	in HTML.  They are now lower-cased when being queried
	from the DOM. Bug 3058145.
	
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::attrName):

2002-10-01  David Hyatt  <hyatt@apple.com>

	Make sure to keep the fix checked in for 1.18.  That fix is
	good.
	
        * khtml/rendering/render_table.cpp:
        (RenderTable::addColInfo):

2002-10-01  David Hyatt  <hyatt@apple.com>

	Backing out change to render_table.cpp.  The original logic
	(in version 1.16) is correct.
	
        * khtml/rendering/render_table.cpp:
        (RenderTable::addColInfo):

2002-09-30  Darin Adler  <darin@apple.com>

        * kwq/qt/qobject.h: Add the destroyed signal.
        * kwq/KWQObject.mm:
        (QObject::connect): Remove names of parentDestroyed and slotWidgetDestructed
	from the list of "slots OK to fail to connect without complaining".
        (QObject::QObject): Initialize the destroyed signal.

        * kwq/qt/qguardedptr.h:
        * kwq/KWQGuardedPtr.mm:
        * kwq/KWQSignal.h:
        * kwq/KWQSlot.h:
	Rearrange includes so qobject.h can include KWQSignal.h.

        * kwq/KWQSignal.mm: Tweak.

        * kwq/KWQSlot.mm: Added support for the parentDestroyed slot in KJS::WindowQObject
	and the slotWidgetDestructed slot in khtml::RenderWidget.

2002-09-28  Darin Adler  <darin@apple.com>

	Turn -Werror back on. There must have been some miscommunication
	about the fat build; this was supposed to have been on.

        * WebCore.pbproj/project.pbxproj: Add -Werror back.

        * kwq/WebCoreHistory.h: Add missing method to fix warning.
        * kwq/KWQKHistoryProvider.mm: Tweak.

2002-09-28  Darin Adler  <darin@apple.com>

	Give the next fat build a better chance of working with the
	new gcc without turning -Werror off.

        * khtml/css/cssparser.cpp: Use a macro to disable inlining.
        * khtml/html/htmltokenizer.cpp: Ditto.
        * khtml/misc/htmlhashes.cpp: Ditto.

2002-09-28  Darin Adler  <darin@apple.com>

	- fixed 3022441 -- scroll bar is missing in window created with window.open

        * khtml/ecma/kjs_window.cpp: (WindowFunc::tryCall): The checks for extra
	parameters to window.open were using isNull, which checks for a null ValueImp
	pointer, not an "Undefined".

2002-09-28  Darin Adler  <darin@apple.com>

	- fixed 2886111 -- changing font or size preference causes open
	windows to redraw incorrectly

        * khtml/rendering/render_table.cpp: (RenderTable::addColInfo):
	Fix logic about when a recalc of the minWidth and maxWidth is needed.

	Fixed bug where changing the text size multiplier would cause the
	window to redraw twice -- once with the text size changed, and then
	later with the layout changed.

        * khtml/khtmlview.h: Added unscheduleRelayout.
        * khtml/khtmlview.cpp: (KHTMLView::unscheduleRelayout): Added.

        * kwq/KWQKHTMLPartImpl.h: Added forceLayout.
        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::forceLayout): Call
	both layout and unscheduleRelayout.

        * kwq/WebCoreBridge.h: Add setNeedsLayout.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge forceLayout]): Call KWQKHTMLPartImpl::forceLayout.
        (-[WebCoreBridge setTextSizeMultiplier:]): Call forceLayout.

2002-09-27  Darin Adler  <darin@apple.com>

        * khtml/rendering/render_table.cpp: (RenderTable::addColInfo):
	Fixed a > that should have been a < that prevented tables from
	changing sizes when table minimum widths changed.

2002-09-27  Darin Adler  <darin@apple.com>

	- fixed 2937198 -- Checkboxes and radiobuttons don't align with title control in forms

        * kwq/qt/qcheckbox.h: Add baselinePosition override.
        * kwq/KWQCheckBox.mm: Tweak the size constants.
        (QCheckBox::baselinePosition): Implement this. Line up baseline two pixels
	above the bottom, not at the bottom.

        * kwq/qt/qradiobutton.h: Add baselinePosition override.
        * kwq/KWQRadioButton.mm: Tweak the size constants.
        (QRadioButton::baselinePosition): Implement this. Line up baseline two pixels
	above the bottom, not at the bottom.

2002-09-27  Chris Blumenberg  <cblu@apple.com>

	WebPlugin clean up.

        * kwq/KWQKConfigBase.mm:
        (KConfig::readEntry):
        * kwq/WebCoreViewFactory.h:

2002-09-27  Richard Williamson   <rjw@apple.com>

        Fixed 3059237:  Visited links do not appear in a different color on yahoo.com
        Fixed 3051288:  visited links are not colored in local files
        Fixed 3060158:  REGRESSION: iframes added to session history
        Always use the canonical originally requested URL as the URL entered in history.
        
        * khtml/khtml_part.cpp:
        (KHTMLPart::begin):
        * kwq/KWQKHTMLPartImpl.h:
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::requestedURLString):
        * kwq/KWQKHistoryProvider.mm:
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreHistory.h:

2002-09-28  David Hyatt  <hyatt@apple.com>

	Fix for 3058119, doctype of HTML docs should be null.
	
        * khtml/dom/dom_doc.cpp:

2002-09-28  David Hyatt  <hyatt@apple.com>

	DOM compliance. Fix for 3058100, hasFeature of HTML returns
	false. Oops.
	
        * khtml/xml/dom_docimpl.cpp:
        (DOMImplementationImpl::hasFeature):

2002-09-27  Darin Adler  <darin@apple.com>

	- fixed 3060487 -- error connecting member slot to signal (KWQObject)

        * kwq/KWQObject.mm: (QObject::connect): Add slotShowDocument to the list of slots that
	we don't care about hooking up.

2002-09-26  Darin Adler  <darin@apple.com>

	- fixed 2953256 -- JavaScript window.moveTo() and window.moveBy() methods do not work

        * kwq/KWQWindowWidget.mm: (KWQWindowWidget::frameGeometry): Fix calculation.
	It was returning the bottom left coordinate instead of the top left.

2002-09-26  Darin Adler  <darin@apple.com>

	- fixed 3060459 -- REGRESSION: crash leaving page that sets cookie in JavaScript
	unload handler

        * khtml/khtml_part.cpp: (KHTMLPart::begin): Call updatePolicyBaseURL to set
	the "policy base URL" on the documents so the cookie can be based on the URL
	of the main document.

        * khtml/dom/html_document.h: Add setPolicyBaseURL.
        * khtml/dom/html_document.cpp: (HTMLDocument::setPolicyBaseURL): Call the impl.

        * khtml/html/html_documentimpl.h: Add policyBaseURL, setPolicyBaseURL.
        * khtml/html/html_documentimpl.cpp: (HTMLDocumentImpl::setCookie): Pass the
	base URL that's stored here instead of getting at the part through the view,
	since the view will be 0 during the unload event.

        * kwq/KWQKHTMLPartImpl.h: Add updatePolicyBaseURL and setPolicyBaseURL.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::updatePolicyBaseURL): Set the base URL based on the URL
	if this is the topmost part, based on the parent's policy base URL if this
	is not the topmost part.
        (KWQKHTMLPartImpl::setPolicyBaseURL): Change the policy base URL for this
	part and all the subparts.

2002-09-26  Darin Adler  <darin@apple.com>

        * kwq/WebCoreBridge.h: Use NSString for encoding name, not CFStringEncoding.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge addData:withOverrideEncoding:]): Ditto.

2002-09-26  Chris Blumenberg  <cblu@apple.com>

	Added WebCoreElementImageLocationKey to the element dictionary.

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementAtPoint:]):

=== Alexander-25 ===

2002-09-25  David Hyatt  <hyatt@apple.com>

	Implement scrollX and scrollY on the window object.  This
	gets brainjar closer to reality. :)
	
        * khtml/ecma/kjs_window.cpp:
        (Window::get):
        * khtml/ecma/kjs_window.h:

2002-09-25  Darin Adler  <darin@apple.com>

	Fix error with the color "indigo".

        * kwq/KWQColor.mm: (getNamedColors): There were some spaces in our
	color table so we wouldn't handle indianred or indigo.

2002-09-25  Maciej Stachowiak  <mjs@apple.com>

	- fixed 2854536 - New cookie policy: "accept cookies only from the
	same domain as the main page"
	
        * khtml/html/html_documentimpl.cpp:
        (HTMLDocumentImpl::setCookie):
        * kwq/KWQKCookieJar.h:
        * kwq/KWQKCookieJar.mm:
        (KWQKCookieJar::setCookie):
        * kwq/WebCoreCookieAdapter.h:
        * kwq/WebCoreCookieAdapter.m:
        (-[WebCoreCookieAdapter setCookies:forURL:policyBaseURL:]):

2002-09-24  Darin Adler  <darin@apple.com>

	- fixed 3057928 -- lstat private/etc/localtime repeatedly reported
	by fs_usage when mouse is moved

        * WebCore-tests.exp: Remove now-unneeded external entry points
	for QTime, QDate, QDateTime.

        * kwq/qt/qdatetime.h:
        * kwq/KWQDateTime.mm:
	Redid QDateTime using CoreFoundation instead of time/localtime.
	This avoids constantly hitting the disk when getting the current
	time to stuff into an event.

2002-09-24  David Hyatt  <hyatt@apple.com>

	Make sure we dispatch both a capturing and a bubbling event
	to target nodes. DOM lvl 2 event compliance.
	
        * ChangeLog:
        * khtml/xml/dom_nodeimpl.cpp:
        (NodeImpl::dispatchGenericEvent):

2002-09-24  Richard Williamson   <rjw@apple.com>

        Fixed 3055078.  Ensure file: URLs have // before path.
        
        * kwq/KWQKURL.mm:
        (KURL::parse):

2002-09-24  David Hyatt  <hyatt@apple.com>

	Better fix.  Clears the boolean when CLASS has no value.
	This will keep the style system from thinking you have
	a class when you don't.
	
        * khtml/html/html_elementimpl.cpp:
        (HTMLElementImpl::parseAttribute):

2002-09-24  David Hyatt  <hyatt@apple.com>

	Fix updating of the document's notion of the focused node
	to happen on mouse down rather than click.  This matches
	the behavior of all other browsers (IE, Gecko, etc.).

	This fixes the drawing of the outline on the brainjar.com
	DHTML menus.
	
        * khtml/khtmlview.cpp:
        (KHTMLView::dispatchMouseEvent):

2002-09-24  David Hyatt  <hyatt@apple.com>

	Make sure that changes to the CLASS attribute mark the
	element as changed (as if a CSS property were added or
	removed).

	This makes the brainjar.com rollovers work much better.
	
        * khtml/html/html_elementimpl.cpp:
        (HTMLElementImpl::parseAttribute):

2002-09-24  Chris Blumenberg  <cblu@apple.com>

	Renamed element info keys to WebElement* instead of WebContextMenuElement*

        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementAtPoint:]):

2002-09-24  Darin Adler  <darin@apple.com>

	- fixed 3056579 -- various crashes at http://www.auspost.com.au/

	Apparently the strings at this site were just the right length to expose a bug
	in our QString implementation, one that I probably introduced when fixing 3032072.
	One nice thing about this is that getting this correct could also result in a
	little bit of a speedup, as the internal buffer is used more.

        * kwq/KWQString.mm:
        (QStringData::makeAscii): Set _maxAscii to QS_INTERNAL_BUFFER_CHARS when using
	the internal buffer instead of leaving it uninitialized.
        (QStringData::makeUnicode): Same for _maxUnicode.

2002-09-24  Darin Adler  <darin@apple.com>

	Remove the focus border hack, which was no longer doing us any good.

        * kwq/KWQNSTextField.h: Don't define FOCUS_BORDER_SIZE.
        * kwq/KWQNSTextField.mm: Remove KWQTextFieldCell.
        (-[KWQNSTextField updateSecureFieldFrame]): Don't inset by FOCUS_BORDER_SIZE.
        * kwq/qt/qlineedit.h: Don't override frameGeometry and setFrameGeometry any more.
        * kwq/KWQLineEdit.mm: (QLineEdit::sizeForCharacterWidth): Don't subtract
	the focus border size.

2002-09-24  Darin Adler  <darin@apple.com>

        * kwq/mac-encodings.txt: Remove constant for Japanese auto-detect.

2002-09-24  Darin Adler  <darin@apple.com>

        * kwq/KWQFileButton.mm: (KWQFileButton::paint): Fix typo.

2002-09-24  Darin Adler  <darin@apple.com>

	Some improvements to the file button, including displaying the file without the
	extension if it's set that way by the user, and using the system font rather
	than hard-coding "Lucida Grande".

        * kwq/KWQFileButton.h: Add _label field.
        * kwq/KWQFileButton.mm:
        (KWQFileButton::KWQFileButton): Set up label.
        (KWQFileButton::~KWQFileButton): Release label.
        (KWQFileButton::setFilename): Use NSFileManager componentsToDisplayForPath to
	figure out the appropriate label.
        (KWQFileButton::paint): Clip to passed-in rect, get font using systemFontOfSize,
	and use NSString drawing rather than our own.

2002-09-23  David Hyatt  <hyatt@apple.com>

	Found the problem with the CSS W3C page.
	
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::recalcStyleSelector):

2002-09-23  Darin Adler  <darin@apple.com>

	WebCore part of fixes for proper layering when drawing subframes.

        * kwq/KWQWidget.mm: (QWidget::paint): Use the parent view in the "WebCoreFrameView"
	case so we update the scroll view too, not just the HTML part. Also use the passed in
	rectangle instead of always using the view bounds.

        * kwq/KWQScrollView.mm: (QScrollView::updateContents): Call setNeedsDisplayInRect
	instead of displayRect.

        * kwq/KWQPainter.mm:
        (QPainter::drawRect): Use NSRectFill and NSFrameRect instead of NSBezierPath.
        (QPainter::fillRect): Ditto.

2002-09-23  David Hyatt  <hyatt@apple.com>

	Don't let alternate stylesheets delay render tree construction.
	
        * khtml/html/html_headimpl.cpp:
        (HTMLLinkElementImpl::HTMLLinkElementImpl):
        (HTMLLinkElementImpl::process):
        (HTMLLinkElementImpl::setStyleSheet):
        (HTMLLinkElementImpl::sheetLoaded):
        * khtml/html/html_headimpl.h:

\2002-09-23  David Hyatt  <hyatt@apple.com>

	Make overflow:auto and scroll map to hidden until we figure
	out something better.
	
        * khtml/css/cssstyleselector.cpp:
 
2002-09-23  Darin Adler  <darin@apple.com>

	More refinement of the AppKit hackery.

        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::printObject): Pass in the painter and rect.

        * kwq/qt/qwidget.h: Take a painter and rect parameter.
        * kwq/KWQWidget.mm: (QWidget::paint): Use painter; not working yet to use rect.

        * kwq/KWQFileButton.h: Change paint to take painter and rect.
        * kwq/KWQFileButton.mm: (KWQFileButton::paint): Use painter.

        * kwq/qt/qpainter.h: Added paintingDisabled() function.
        * kwq/KWQPainter.mm: (QPainter::paintingDisabled): Added.

2002-09-22  Darin Adler  <darin@apple.com>

	Change code that moves NSViews out of the way to run inside drawRect
	after a layout change rather than running at layout time. This makes
	sure that views are in the right place when propagating dirty rects.

        * kwq/KWQKHTMLPartImpl.h: Add paint method and _needsToSetWidgetsAside flag.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::KWQKHTMLPartImpl): Set _needsToSetWidgetsAside to false.
        (KWQKHTMLPartImpl::layout): Set _needsToSetWidgetsAside to true. Don't call
	moveWidgetsAside any more.
        (KWQKHTMLPartImpl::paint): Moved the code here from the bridge, but also call
	moveWidgetsAside if _needsToSetWidgetsAside flag is set.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge drawRect:withPainter:]): Call KWQKHTMLPartImpl::paint, which
	is where I moved this code.

2002-09-21  Darin Adler  <darin@apple.com>

	- fixed 3057265 -- REGRESSION: Crash loading http://www.undetectables.co.uk/

        * khtml/khtml_part.cpp: (KHTMLPart::processObjectRequest):
	Remove special case for javascript and about:blank that was leading to a crash.

2002-09-21  Darin Adler  <darin@apple.com>

	WebCore part of the new approach to AppKit drawing control.
	Works better than the previous try. Once we fix anomalies with focus rectangles
	and a minor problems with subframes this should work perfectly.

        * kwq/qt/qwidget.h: The paint() method isn't virtual any more. Also remove flushDrawing().
        * kwq/KWQWidget.mm: (QWidget::enableFlushDrawing): Do a flushWindowIfNeeded instead
	of requiring a separate flushDrawing() call to do a flushWindow.
        (QWidget::paint): Added. Calls displayRectIgnoringOpacity.

        * kwq/qt/qbutton.h: Remove paint() override.
        * kwq/KWQButton.mm: (QButton::QButton): No need for a subclass any more, so
	drop KWQNSButton. Also remove paint().

        * kwq/qt/qcombobox.h: Remove paint() override.
        * kwq/KWQComboBox.mm: (QComboBox::QComboBox): No need for a subclass any more, so
	drop KWQNSPopUpButton. Also remove paint() method.

        * kwq/qt/qlineedit.h: Remove paint() override.
        * kwq/KWQLineEdit.mm: Remove paint().

        * kwq/KWQFileButton.mm: (KWQFileButton::clicked): Fix typo. Was calling paint
	instead of clicked on the base class.

        * kwq/KWQNSTextField.h: Remove paint method.
        * kwq/KWQNSTextField.mm:
        (-[KWQNSTextField display]): Add a display method that does nothing to work around
	bug 2753974.
        (-[KWQSecureTextField display]): Ditto.

	* khtml/rendering/render_frames.cpp: (RenderFrameSet::userResize): Remove call to flushDrawing.

2002-09-20  Richard Williamson   <rjw@apple.com>

        Don't modify selection if no appropriate DOM::Node under
        mouse.
        
        * khtml/khtml_part.cpp:
        (KHTMLPart::khtmlMouseMoveEvent):

2002-09-20  Richard Williamson   <rjw@apple.com>

        Assume triple click for selection if click count >= 3,
        not == 3, as in OS X.
        
        * khtml/khtml_part.cpp:
        (KHTMLPart::khtmlMousePressEvent):

2002-09-20  Richard Williamson   <rjw@apple.com>

        Fixed crasher in findTextSlave.
        * khtml/rendering/render_text.cpp:
        (RenderText::findTextSlave):

        Added error checks.
        * khtml/khtml_part.cpp:
        (startAndEndLineNodesIncludingNode):

2002-09-20  Richard Williamson   <rjw@apple.com>

        Made double and triple click selection behave like
        like other selection in OS X.  That is, selection happens
        on mouse down, not mouse up, and can be extended by
        further dragging.  Triple click followed by dragging extends
        the selection a line at a time.
        
        * khtml/khtml_events.cpp:
        * khtml/khtml_events.h:
        * khtml/khtml_part.cpp:
        (KHTMLPart::customEvent):
        (firstSlaveAt):
        (lastSlaveAt):
        (startAndEndLineNodesIncludingNode):
        (KHTMLPart::khtmlMousePressEvent):
        (KHTMLPart::khtmlMouseDoubleClickEvent):
        (KHTMLPart::khtmlMouseMoveEvent):
        * khtml/khtml_part.h:
        * khtml/khtmlpart_p.h:
        * khtml/khtmlview.cpp:
        * khtml/khtmlview.h:
        * khtml/xml/dom_elementimpl.cpp:
        (ElementImpl::setAttribute):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge mouseUp:]):

2002-09-20  Darin Adler  <darin@apple.com>

        * kwq/KWQFileButton.h: Add an icon.
        * kwq/KWQFileButton.mm:
        (KWQFileButton::KWQFileButton): Nil out icon.
        (KWQFileButton::~KWQFileButton): Release icon.
        (KWQFileButton::setFilename): Get icon with [NSWorkspace iconForFile:].
        (KWQFileButton::clicked): Set prompt string to "Choose", and start directory to "~".
        (KWQFileButton::sizeHint): Pad more for icon width.
        (KWQFileButton::frameGeometry): Ditto.
        (KWQFileButton::setFrameGeometry): Ditto.
        (KWQFileButton::paint): Draw icon. Draw "no file selected" if no filename.

        * kwq/KWQKFileItem.mm: Our "nonimplementation" is good enough. Stop complaining.
        * kwq/KWQKnetaccess.mm: Ditto. Also just extract path when asked to download.

2002-09-20  Darin Adler  <darin@apple.com>

	Some first steps toward implementing input=file.

        * khtml/rendering/render_form.cpp:
        (RenderFileButton::RenderFileButton): Create a KWQFileButton as the widget.
        (RenderFileButton::calcMinMaxWidth): Use sizeHint().
        (RenderFileButton::updateFromElement): Call setFilename().
        (RenderFileButton::select): Don't try to selectAll() on m_edit.

        * kwq/KWQFileButton.h: Added.
        * kwq/KWQFileButton.mm: Added.
        * kwq/qt/qhbox.h: Emptied.
        * kwq/KWQHBox.mm: Removed.
        * WebCore.pbproj/project.pbxproj: Removed KWQHBox.mm. Added KWQFileButton.

2002-09-20  Darin Adler  <darin@apple.com>

	- fixed 3056605 -- REGRESSION: blank page at http://www.2ch.net/2ch.html

        * kwq/mac-encodings.txt: When people say ShiftJIS, they really mean
	DOSJapanese. So do what they mean, not what they say.

2002-09-20  Darin Adler  <darin@apple.com>

	- fixed 3055339 -- repro crash in RenderPartObject::updateWidget()

        * khtml/khtml_part.cpp: (KHTMLPart::processObjectRequest):
	Only create a new part if we have no old part.

        * kwq/KWQtextstream.mm: Remove some of the "not implemented" logging.
	Once we have logged that the stream is not created correctly, there's no need
	to continue logging each time something is written out to the non-stream.

2002-09-19  Richard Williamson   <rjw@apple.com>

        Implemented double and triple click selection.
        
        * khtml/khtml_events.h:
        * khtml/khtml_part.cpp:
        (KHTMLPart::customEvent):
        (KHTMLPart::khtmlMouseDoubleClickEvent):
        (firstSlaveAt):
        (lastSlaveAt):
        (KHTMLPart::khtmlMouseTripleClickEvent):
        * khtml/khtml_part.h:
        * khtml/rendering/render_text.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge mouseUp:]):

2002-09-19  Darin Adler  <darin@apple.com>

	- fixed 3045651 -- null-dereference in DOM::CharacterDataImpl constructor
	setting up text area element

        * khtml/xml/dom_textimpl.cpp: (CharacterDataImpl::CharacterDataImpl):
	Set str to an empty DOMStringImpl instead of to 0. This was easier than
	going around finding all the places that don't like a str of 0.

        * WebCore.pbproj/project.pbxproj: Let PB sort things as it likes.

=== Alexander-24 ===

2002-09-18  Darin Adler  <darin@apple.com>

	- fixed 3037974 -- successful Find does not deselect text field

        * khtml/khtml_part.cpp: (KHTMLPart::checkCompleted):
	Turn off the code that restores the cursor position because we don't
	use the KHTML saveState/restoreState. But we should.

        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::setSelection): Call setFocusNode(0), because on the
	Macintosh, selection and focus are mutually exclusive.
        (DocumentImpl::close): Remove no-longer-needed APPLE_CHANGES.
        (DocumentImpl::setFocusNode): Set focus to the KHTMLView when focus
	is being removed from a particular node. Clear the selection when
	focus is set on a particular node because on the Macintosh, selection
	and focus are mutually exclusive.

        * kwq/KWQKHTMLPartImpl.h: Add set/clearDocumentFocus functions that we can use
	to keep document's idea of focused node in sync. with AppKit's.
        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::setDocumentFocus): Added.
	(KWQKHTMLPartImpl::clearDocumentFocus): Added.

        * kwq/KWQNSTextField.mm:
        (-[KWQNSTextField becomeFirstResponder]): Call setDocumentFocus.
        (-[KWQSecureTextField becomeFirstResponder]): Call setDocumentFocus.

        * kwq/qt/qwidget.h: Removed endEditing().
        * kwq/KWQWidget.mm: (QWidget::clearFocus): Call clearDocumentFocus.
	(QWidget::endEditing): Removed.

        * khtml/rendering/render_form.h:
        * khtml/rendering/render_form.cpp:
        (RenderImageButton::RenderImageButton): Remove the KWQInvisibleButton
	hack, which is no longer needed.
        * kwq/KWQInvisibleButton.h: Removed.
        * kwq/KWQInvisibleButton.mm: Removed.
        * WebCore.pbproj/project.pbxproj: Removed KWQInvisibleButton.

2002-09-18  Darin Adler  <darin@apple.com>

	- fixed 3027470 -- hitting tab when the google.com text field is selected
	(all bars hidden) makes border flash

        * kwq/KWQNSTextField.mm:
        (-[KWQNSTextField textDidEndEditing:]): Added. Don't call super when the next
	valid key view is nil.
        (-[KWQSecureTextField textDidEndEditing:]): Ditto. Too bad we can't share code
	here. Maybe I'll figure out a way later.

2002-09-17  Darin Adler  <darin@apple.com>

	- fixed 3025022 -- Crash in KWQKHTMLPartImpl::redirectionTimerStartedOrStopped()

        * kwq/WebCoreBridge.mm: (-[WebCoreBridge dealloc]): Set the bridge on the part to
	nil just in case someone else is holding a reference, so we won't try to dispatch
	methods to an already-deallocated bridge.

	- fixed 3028476 -- illegal instruction crash in KWQTimerCallback timerFired

        * khtml/ecma/kjs_window.cpp: (WindowQObject::parentDestroyed):
	Remove APPLE_CHANGES to avoid calling killTimers(); we can call it
	now that we have a working implementation.
        * khtml/khtmlview.cpp:
        (KHTMLView::~KHTMLView): Remove APPLE_CHANGES that kills timers.
	All timers are killed by ~QObject now, just as in Qt.
        (KHTMLView::clear): Remove APPLE_CHANGES to avoid calling killTimers();
	we can call it now that we have a working implementation.

        * kwq/KWQObject.mm:
        (QObject::~QObject): Call killTimers().
        (QObject::startTimer): Keep a dictionary keyed by QObject, with a dictionary
	of timers for each, rather than one global dictionary. This makes it efficient
	to kill all the timers for an object.
        (QObject::killTimer): Update for new level of dictionary.
        (QObject::killTimers): Kill all the timers in this object's timer dictionary
	rather than all timers in the world.
        (QObject::inherits): Add an ERROR for the case where the class name is unknown.

2002-09-17  Darin Adler  <darin@apple.com>

	- fixed 3050818 -- Crash in relative-KURL constructor at site with _ in host name

        * kwq/KWQKURL.mm: Change _ so that it's allowed in host names.
        (KURL::KURL): If base URL is invalid, make result invalid too.

2002-09-17  Richard Williamson   <rjw@apple.com>

        * khtml/khtmlview.cpp:
        (KHTMLView::viewportMouseTripleClickEvent):
        Added implementation.  Same as viewportMouseReleaseEvent
        except dispatches additional MouseTripleClickEvent event.
        
        (KHTMLView::viewportMouseDoubleClickEvent):
        Send extra release event.  This emulates Qt
        behavior.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge mouseUp:]):
        Don't send extra release event here, instead send
        it in viewportMouseDoubleClickEvent and also in
        viewportMouseTripleClickEvent so DOM doesn't get
        confused.
        
        * kwq/KWQColor.mm:
        (QColor::hsv):
        Fixed divide by 0 problem.
        
2002-09-17  Darin Adler  <darin@apple.com>

	- fixed 2936933 -- Pages that claim to be UTF-8 but contain invalid
	sequences do not render at all

	Misc. speed improvements. Total 2.6% speedup for cvs-base.

	Improvements for signals.

        * kwq/KWQChar.mm:
        (QChar::isSpace): Add fast case for ASCII.
        (QChar::lower): Add fast case for ASCII.
        (QChar::upper): Add fast case for ASCII.

        * kwq/qt/qcolor.h: Just store RGB values, not NSColor objects.
        * kwq/KWQColor.mm:
        (QColor::QColor): No need to set color to nil.
        (QColor::name): Use QString::sprintf instead of NSString.
        (QColor::setNamedColor): Use KWQInvalidColor instead of nil.
        (QColor::getNSColor): Make an autoreleased NSColor.

        * kwq/KWQKHTMLPartImpl.mm:
        (moveWidgetsAside): Use isWidget() instead of dynamic_cast.

        * kwq/KWQSignal.h: use a QValueList instead of a fixed-size array.
        * kwq/KWQSignal.mm:
        (KWQSignal::connect): Append to list.
        (KWQSignal::disconnect): Remove from list.
        (KWQSignal::call): Use the QValueList.

        * kwq/KWQSlot.mm:
        (KWQSlot::call): Use static_cast instead of dynamic_cast where possible.

        * kwq/qt/qstring.h: Add return value to forceUnicode.
        * kwq/KWQString.mm:
        (QString::fromStringWithEncoding): Implemented using the Text Encoding
	Converter instead of CFString.
        (compareIgnoringCaseForASCIIOnly): New function. Faster find.
        (QString::find): Separate case-sensitive from case-insensitive and speed
	up both of them.
        (QString::stripWhiteSpace): Use the new forceUnicode for simplicity.
        (QString::simplifyWhiteSpace): Ditto.
        (QString::insert): Ditto.
        (QString::remove): Ditto.
        (QString::forceUnicode): Return the unicode pointer.
        (QString::fill): Use the new forceUnicode for simplicity.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge mouseUp:]): Fix two bugs. First, don't treat a slow
	click as a double click. Second, deliver a mouse release event even for
	a double click, as Qt does.

2002-09-17  Richard Williamson   <rjw@apple.com>

        * khtml/css/cssstyleselector.cpp:
        Fixed bug in KHTML that incorrectly modified '//' in fragment part of URL.
        
        * kwq/KWQKHistoryProvider.mm:
        Use string based API to add entry.  May eventually remove NSURL from
        history entirely.
        
        * kwq/KWQKURL.mm:
        (KURL::canonicalURL):
        Simply return the urlString.

        (KURL::parse):
        Added "/" to http and https empty path URLs.
        
        * kwq/KWQString.mm:
        (QString::mid):
        Optimize ascii case.
        
        * kwq/WebCoreHistory.h:
        * kwq/WebCoreHistory.m:
        (-[WebCoreHistory addEntryForURLString:]):
        Use string based API to add entry.
        
        * kwq/kdecore/kurl.h:
        Defined methods to access canonical components,
        currently conditionally excluded.
        
2002-09-16  David Hyatt  <hyatt@apple.com>

	Fix the stylesheet loading regression on rubyfruit.
	
        * khtml/html/html_headimpl.cpp:
        (HTMLStyleElementImpl::HTMLStyleElementImpl):
        (HTMLStyleElementImpl::childrenChanged):
        (HTMLStyleElementImpl::isLoading):
        * khtml/html/html_headimpl.h:

2002-09-13  David Hyatt  <hyatt@apple.com>

	Landing code that makes textfields, buttons, checkboxes, radio
	buttons, and dropdown lists all draw correctly with respect to
	z-index.  They all employ the same simple hack (just never paint
	unless KHTML tells them to).

	Unpatched widgets include the password field, the listbox, and the
	textarea.  

	The only issue with regards to painting with the widgets I've
	patched is the textfield... its editor floats to the top when the
	field is being edited.

	Event handling will also be incorrect and will need to be patched
	separately.
	
        * khtml/rendering/render_body.cpp:
        (RenderBody::printBoxDecorations):
        * khtml/rendering/render_replaced.cpp:
        (RenderWidget::printObject):
        * kwq/KWQButton.mm:
        (QButton::QButton):
        (QButton::paint):
        (-[KWQNSButton drawRect:]):
        (-[KWQNSButton paint]):
        * kwq/KWQComboBox.mm:
        (-[KWQNSPopUpButton drawRect:]):
        (-[KWQNSPopUpButton paint]):
        (QComboBox::QComboBox):
        (QComboBox::insertItem):
        (QComboBox::paint):
        * kwq/KWQLineEdit.mm:
        (QLineEdit::paint):
        * kwq/KWQNSTextField.h:
        * kwq/KWQNSTextField.mm:
        (-[KWQNSTextField paint]):
        * kwq/qt/qbutton.h:
        * kwq/qt/qcombobox.h:
        * kwq/qt/qlineedit.h:
        * kwq/qt/qwidget.h:

2002-09-13  Richard Williamson (Home)  <rjw@apple.com>

        Fixed navigation to link on mouse up after drag.
        
        * khtml/khtmlview.cpp:
        (KHTMLView::viewportMousePressEvent):
        (KHTMLView::viewportMouseDoubleClickEvent):
        Change khtml's definition of double click to be based on
        mouse up of second click, not mouse down. 
        
        (KHTMLView::viewportMouseReleaseEvent):

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge mouseUp:]):
        (-[WebCoreBridge mouseDown:]):
        Changed double click to be on mouse up with click count of two.

2002-09-13  Darin Adler  <darin@apple.com>

	Fix crash in slot code.

        * kwq/KWQSignal.mm: (KWQSignal::call): Copy the slots before
	calling through in case we are destroyed by the called function.

2002-09-13  Darin Adler  <darin@apple.com>

	Here's the *real* mistake that killed plugins. I accidentally
	stopped creating objects at all! Duh. Fixed now.

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::createPart):
	Make a part for a plugin if we need one. Not a KHTMLPart, but
	a KWQPluginPart.

2002-09-13  Darin Adler  <darin@apple.com>

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::createPart):
	Fix plugin-related crashes by making sure each part has a unique
	frame name. There may be something fundamentally wrong with how this
	is working now.

2002-09-13  Richard Williamson (Home)  <rjw@apple.com>

        Made justified text work correctly in khtml for rendering
        and selection.  Optimized selection point calculation by
        only doing characters measurements once.
        
        * khtml/rendering/font.cpp:
        (Font::floatCharacterWidths):
        * khtml/rendering/font.h:
        * khtml/rendering/render_text.cpp:
        (TextSlave::checkSelectionPoint):
        (RenderText::position):
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):
        (QFontMetrics::floatWidth):
        (QFontMetrics::floatCharacterWidths):
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        * kwq/WebCoreTextRenderer.h:
        * kwq/qt/qfontmetrics.h:

2002-09-13  Darin Adler  <darin@apple.com>

	Quiet error messages related to the slot/signal changes.

        * khtml/khtml_part.cpp:
        (KHTMLPart::startAutoScroll): Ifdef this out.
        (KHTMLPart::stopAutoScroll): Ditto.

        * kwq/KWQObject.mm:
        (QObject::connect): Add two more expected members to the list for
	setStatusBarText and slotViewCleared.

        * kwq/KWQSignal.h: Allow 4 slots per signal.
	I don't want to make it a variable number, but we can if we have to.
        * kwq/KWQSignal.mm:
        (KWQSignal::connect): Support multiple slots.
        (KWQSignal::disconnect): Support multiple slots.
        (KWQSignal::call): Support multiple slots.

2002-09-13  Darin Adler  <darin@apple.com>

	Fix assertion that happens on any page that has a non-HTML frame.

	We were sending signals for objects in m_objects that are only supposed
	to be sent for frames in m_frames. The fix is to use actual slot/signal
	connections instead of our hard-coded logic.

        * kwq/KWQKHTMLPartImpl.h: Add signals for started and completed.
        * kwq/KWQKHTMLPartImpl.mm:
        (KHTMLPart::completed): Emit completed signal.
        (KHTMLPart::started): Emit started signal.
        (KWQKHTMLPartImpl::KWQKHTMLPartImpl): Create signals.

        * kwq/KWQObject.mm:
        (QObject::connect): Write out an error message if we see any signal connections
	to signals that aren't implemented, with a hardwired exception list for ones we
	either aren't ever going to do or just haven't gotten around to yet.

        * kwq/KWQSignal.h: Add support for signals that take bool and KIO::Job *.
        * kwq/KWQSignal.mm:
        (KWQSignal::connect): Put in an actual ERROR call for the case where this fails.
        (KWQSignal::disconnect): Put in an actual ERROR call for the case where it fails.
        (KWQSignal::call): Add overloads for bool and KIO::Job *.

        * kwq/KWQSlot.h: Add support for slots that take bool and KIO::Job *.
        * kwq/KWQSlot.mm:
        (KWQSlot::KWQSlot): Add four new members.
        (KWQSlot::call): Add overloads for bool and KIO::Job * and support for the new
	members.

2002-09-12  Darin Adler  <darin@apple.com>

        * kwq/KWQAssertions.h: Update assertions from from the copy in WebFoundation.
        * WebCorePrefix.h: Remove NSURLPathUtilities.h include.

	Use even more of the KHTML code so we get referrers in one more place.

        * kwq/WebCoreBridge.h: Add referrer to createChildFrameNamed.

        * khtml/khtml_part.h: Less APPLE_CHANGES, no substantive change.
        * khtml/khtml_part.cpp:
        (KHTMLPart::requestFrame): Use more of this, less APPLE_CHANGES.
        (KHTMLPart::requestObject): Ditto.
        (KHTMLPart::processObjectRequest): Ditto.

        * khtml/rendering/render_frames.h: Less APPLE_CHANGES.
        * khtml/rendering/render_frames.cpp: Less APPLE_CHANGES.

        * kwq/kparts/browserextension.h: Add lockHistory/setLockHistory and
	openURLNotify.

        * kwq/khtml/khtml_ext.h: Add openURLNotify.
        * kwq/KWQKHTMLPartImpl.h: Add openURLNotify.
        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::openURLNotify): Implement.

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::createPart):
	Changed name from requestFrame. Do less work.

        * kwq/qt/qtimer.h: Add singleShot.
        * kwq/KWQTimer.mm:
        (+[KWQSingleShotTimerTarget targetWithQObject:member:]): Added.
	Used to implement singleShot.
        (-[KWQSingleShotTimerTarget dealloc]): Ditto.
        (-[KWQSingleShotTimerTarget timerFired:]): Ditto.
        (QTimer::singleShot): Added.

        * kwq/qt/qmap.h: Add contains.

        * kwq/qt/qvaluelist.h: Add iterator return value for append and prepend.
        * kwq/KWQValueListImpl.h: Add iterator return value for appendNode
	and prependNode.
        * kwq/KWQValueListImpl.mm:
        (KWQValueListImpl::appendNode): Add iterator.
        (KWQValueListImpl::prependNode): Add iterator.

        * kwq/kparts/part.h: Add openURL.

2002-09-12  Richard Williamson  <rjw@apple.com>

        Rewrite of khtml selection drawing code.  Now does
        a delta between old and new selection and only
        draw those objects that have changed.  Selection
        drawing is now MUCH faster.
        
        * khtml/rendering/render_root.cpp:
        (enclosingPositionedRect):
        (RenderRoot::setSelection):
        (RenderRoot::clearSelection):
        * khtml/rendering/render_root.h:
        
        Added additional absolute position property to render node
        stuff for debug render tree view.
        
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge copyRenderNode:copier:]):

2002-09-12  David Hyatt  <hyatt@apple.com>

	KHTML was butchering the laws of background propagation from
	the <body> to the <html>.  This fixes the logical flaws and
	makes some of the geekiest CSS on the planet render correctly. ;)
	
        * khtml/rendering/render_body.cpp:
        (RenderBody::printBoxDecorations):
        * khtml/rendering/render_html.cpp:
        (RenderHtml::printBoxDecorations):

2002-09-12  David Hyatt  <hyatt@apple.com>

	Make fixed positioned elements work when you scroll.  We were
	just missing the implementation of a QScrollView method.
	
        * kwq/KWQScrollView.mm:
        (QScrollView::setStaticBackground):

2002-09-12  David Hyatt  <hyatt@apple.com>

	Fix a bug in KHTML that leads it to claim cached @imported stylesheets
	are not loaded (when in fact they are).

	This fixes the W3C CSS page.
	
        * khtml/css/css_ruleimpl.cpp:
        (CSSImportRuleImpl::init):

2002-09-12  Chris Blumenberg  <cblu@apple.com>

	Fixed livepage crash. It is naughty to divide by 0 so we now check before doing that.

        * khtml/rendering/render_box.cpp:
        (RenderBox::printBackground):

2002-09-12  David Hyatt  <hyatt@apple.com>

	Fix crash on trekweb.com.  My simplified FOUC code was a little
	bit too simple. ;)
	
        * khtml/html/html_headimpl.cpp:
        (HTMLLinkElementImpl::setStyleSheet):
        (HTMLStyleElementImpl::childrenChanged):

2002-09-12  David Hyatt  <hyatt@apple.com>

	Fix the Warcraft 3 page on blizzard.com so that the relative
	positioned blocks inside centered tables inside enclosing tables
	with percentage widths work correctly.

	This fix also causes the textfields on mrskin.com to show up
	again.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::RenderBox):
        (RenderBox::setPos):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):
        * khtml/rendering/render_object.h:

2002-09-11  Maciej Stachowiak  <mjs@apple.com>

	Don't show the window here any more, now that WebBrowser will set
	it up to be shown properly itself.
	
        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow):

2002-09-11  David Hyatt  <hyatt@apple.com>

	Fix horizontal scrolling.  The HTML render object lies.  It lies, 
	I tell you.
	
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):

2002-09-11  David Hyatt  <hyatt@apple.com>

	Fix clipping to work with layers.  This fixes the marquee
	(once again) on livepage.apple.com.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::getClipRect):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild):
        (RenderContainer::removeChildNode):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::setStyle):
        (RenderFlow::printObject):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::enclosingPositionedAncestor):
        (RenderLayer::convertToLayerCoords):
        (RenderLayer::paint):
        (RenderLayer::constructZTree):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::print):

2002-09-11  Darin Adler  <darin@apple.com>

        * kwq/KWQAssertions.h: Updated copy of the assertions macros (made by script).

2002-09-11  Darin Adler  <darin@apple.com>

	- fixed 3047552 -- crash using CFNotification calls on an NSNotification

        * kwq/KWQWindowWidget.mm:
        (KWQWindowWidget::KWQWindowWidget): Create a KWQWindowWidgetDeleter, and
	hook it up to the notification.
        (KWQWindowWidget::~KWQWindowWidget): Disconnect the KWQWindowWidgetDeleter
	and release it.
        (-[KWQWindowWidgetDeleter initWithWindowWidget:]): Store a pointer.
        (-[KWQWindowWidgetDeleter deleteWindowWidget]): Do a delete.

2002-09-11  Darin Adler  <darin@apple.com>

	- fixed 3021137 -- changing font prefs doesn't redraw frames
	other than the main frame

        * kwq/WebCoreSettings.m: Renamed to WebCoreSettings.mm.
        * kwq/WebCoreSettings.mm: Renamed from WebCoreSettings.m so I could
	use C++.
        (-[WebCoreSettings _updateAllViews]): Iterate over all KWQKHTMLPartImpl
	instances, calling setNeedsReapplyStyles on each one.
        * WebCore.pbproj/project.pbxproj: Updated for name change.

        * kwq/KWQKHTMLPartImpl.h: Add instances() and mutableInstances().
	Get rid of frameExists(), findFrame(), and frames().
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::KWQKHTMLPartImpl): Add to instance list.
        (KWQKHTMLPartImpl::~KWQKHTMLPartImpl): Remove from instance list.
        (KWQKHTMLPartImpl::requestFrame): Update to not use frameExists().
        (KWQKHTMLPartImpl::overURL): Update to not use frameExists, and improve
	handling of various cases.
        (KWQKHTMLPartImpl::mutableInstances): Create and return instance list.

        * kwq/WebCoreBridge.h: Add setNeedsReapplyStyles; already implemented
	in WebKit.

        * khtml/khtml_part.cpp:
        (KHTMLPart::findFrame): Remove APPLE_CHANGES.
        (KHTMLPart::frameExists): Remove APPLE_CHANGES.
        (KHTMLPart::frames): Remove APPLE_CHANGES.

2002-09-10  Darin Adler  <darin@apple.com>

	WebCore part of support for the "Referer" header.

        * khtml/khtml_part.cpp:
        (KHTMLPart::urlSelected): Use much more of this function.
        (KHTMLPart::submitForm): Use much more of this function.

        * kwq/KWQKHTMLPartBrowserExtension.mm:
        (KHTMLPartBrowserExtension::createNewWindow): Parse the
	referrer out of the URLArgs and pass it along.

        * kwq/KWQKHTMLPartImpl.h: Change parameters to urlSelected
	and submitForm to allow KHTML to do more of the work. Add
	referrer helper function.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::bridgeForFrameName): Pass referrer of nil
	when opening a blank window.
        (KWQKHTMLPartImpl::referrer): Extract referrer from metadata.
        (KWQKHTMLPartImpl::openURLRequest): Pass referrer from args
	through the bridge.
        (KWQKHTMLPartImpl::urlSelected): Remove code that duplicates
	what's in KHTMLPart. Also pass referrer from args through the
	bridge as above.
        (KWQKHTMLPartImpl::submitForm): Ditto.

        * kwq/kdeui/kmessagebox.h: Add information member function.
        * kwq/KWQKMessageBox.mm: (KMessageBox::information): Implement.

        * kwq/kdecore/kurl.h: Add encode_string member function.
        * kwq/KWQKURL.mm:
        (KURL::KURL): Fix buffer overflow bug, and add an assert so we
	will notice these overflows even when using the static buffer.
        (KURL::parse): Added a similar assert, even though I didn't fix
	any overflow bug here.
        (KURL::encode_string): Implemented this, but didn't test it.

        * kwq/KWQLoaderImpl.mm: (KWQServeRequest): Pass referrer through
	the bridge.

        * kwq/WebCoreBridge.h: Add referrer parameters to loadURL, postWithURL,
	openNewWindowWithURL, and startLoadingResource.

        * kwq/kparts/browserextension.h: Implement setDoPost, setContentType,
	const version of metaData().

        * kwq/qt/qstring.h: Implement fromLatin1(const char *, int).

        * WebCore-tests.exp: Not sure why, but I needed to remove isMalformed,
	and the tests seem to still work with it removed.

2002-09-11  David Hyatt  <hyatt@apple.com>

	This patch fixes a slew of bugs.  It is an implementation
	of the IE extensions offsetLeft, offsetTop, and offsetParent.
	Konqueror actually had implementations for these properties
	that were totally wrong, leading any DHTML that would use
	these properties (like the DHTML on brainjar.com or livepage.apple.com)
	to misposition child elements.

	With these properties now implemented, the menus on brainjar.com
	position correctly, and the marquee on livepage.apple.com once
	again shows up (and now you can see how I've regressed clipping
	by not shoving it into the layer system as well).

	Next up will be fixing the clipping bug on livepage.apple.com.
	
        * khtml/ecma/kjs_dom.cpp:
        (DOMNode::getValueProperty):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::offsetHeight):
        (RenderFlow::offsetLeft):
        (RenderFlow::offsetTop):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::offsetLeft):
        (RenderObject::offsetTop):
        (RenderObject::offsetParent):
        * khtml/rendering/render_object.h:

2002-09-10  David Hyatt  <hyatt@apple.com>

	Get more elements on mrskin painting as well as the menus
	on brainjar.com.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::layout):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):
        * khtml/rendering/render_object.cpp:
        (RenderObject::setLayouted):
        * khtml/rendering/render_object.h:

2002-09-10  David Hyatt  <hyatt@apple.com>

	Fix the CSS clip property.
	
        * khtml/css/cssparser.cpp:
        (StyleBaseImpl::parseValue):
        * khtml/css/cssstyleselector.cpp:
        * khtml/ecma/kjs_css.cpp:
        (DOMCSSStyleDeclaration::tryPut):
        * khtml/rendering/render_box.cpp:
        (RenderBox::calcClip):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::printObject):
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::print):
        * khtml/rendering/render_style.cpp:
        (StyleVisualData::StyleVisualData):
        (RenderStyle::diff):
        * khtml/rendering/render_style.h:

2002-09-10  Richard Williamson  <rjw@apple.com>

        Fixed broken DOM handling of click count.  DOM click 
        events can be tested with Labyrinth/Test/html/mousetest.html.
        Preparation work for double and triple click selection.
        
        * khtml/khtml_events.cpp:
        * khtml/khtml_events.h:
        * khtml/khtml_part.cpp:
        (KHTMLPart::khtmlMouseTripleClickEvent):
        * khtml/khtml_part.h:
        * khtml/khtmlview.cpp:
        (KHTMLView::viewportMousePressEvent):
        (KHTMLView::viewportMouseTripleClickEvent):
        (KHTMLView::viewportMouseDoubleClickEvent):
        (KHTMLView::viewportMouseReleaseEvent):
        * khtml/khtmlview.h:
        * kwq/KWQEvent.mm:
        (QMouseEvent::QMouseEvent):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge mouseUp:]):
        (-[WebCoreBridge mouseDown:]):
        * kwq/qt/qevent.h:

2002-09-10  David Hyatt  <hyatt@apple.com>

	Fix FOUC to behave correctly.  I was smoking crack when I
	implemented this the first time (mainly because KHTML had
	a badly named API that didn't mean even remotely what
	I thought it should).
	
        * khtml/html/html_headimpl.cpp:
        (HTMLLinkElementImpl::process):
        (HTMLLinkElementImpl::setStyleSheet):
        (HTMLLinkElementImpl::sheetLoaded):
        (HTMLStyleElementImpl::childrenChanged):
        (HTMLStyleElementImpl::sheetLoaded):

2002-09-10  Maciej Stachowiak  <mjs@apple.com>

	WebCore part of fix for:

	2952837 - Slide shows on homepage.mac.com don't show pictures, captions
	2942073 - Deferring [BrowserDocument goToInitialURL] can cause problems
	3021360 - second window pops up on 'Search' at chrysler.com
	3030485 - Unexpected new window created with no scroll bars at sony.com

	* kwq/KWQKHTMLPartBrowserExtension.mm:
	(KHTMLPartBrowserExtension::createNewWindow): Reuse existing
	frame if possible. Pass frame name when opening a new window.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::bridgeForFrameName): Don't warn when opening a
	new window. Check non-descendant frames too.
        (KWQKHTMLPartImpl::urlSelected): Pass frame name when opening window.
        * kwq/WebCoreBridge.h: Add frameName argument to openNewWindowWithURL:.

2002-09-10  Darin Adler  <darin@apple.com>

	Add back the APPLE_CHANGES for a few frame cases. We need to do some real testing
	before we remove our alternate versions of these (but I still hope we do remove them).

        * khtml/khtml_part.cpp:
        (KHTMLPart::findFrame): Back to the old way.
        (KHTMLPart::frameExists): Ditto.
        (KHTMLPart::frames): Ditto.

2002-09-10  Darin Adler  <darin@apple.com>

	- fixed 2942809 -- remove all direct access to "WebKit" defaults from WebCore

        * kwq/WebCoreSettings.h: Add willLoadImagesAutomatically and userStyleSheetLocation.
        * kwq/WebCoreSettings.m:
        (-[WebCoreSettings _updateAllViews]): Added. Placeholder for a function that will
	cause all views to update styles and layout.
        (-[WebCoreSettings setStandardFontFamily:]): Call _updateAllViews if a change happened.
        (-[WebCoreSettings setFixedFontFamily:]): Ditto.
        (-[WebCoreSettings setSerifFontFamily:]): Ditto.
        (-[WebCoreSettings setSansSerifFontFamily:]): Ditto.
        (-[WebCoreSettings setCursiveFontFamily:]): Ditto.
        (-[WebCoreSettings setFantasyFontFamily:]): Ditto.
        (-[WebCoreSettings setMinimumFontSize:]): Ditto.
        (-[WebCoreSettings setDefaultFontSize:]): Ditto.
        (-[WebCoreSettings setDefaultFixedFontSize:]): Ditto.
        (-[WebCoreSettings setWillLoadImagesAutomatically:]): Added.
        (-[WebCoreSettings willLoadImagesAutomatically]): Added.
        (-[WebCoreSettings setUserStyleSheetLocation:]): Added. Call _updateAllViews if a change happened.
        (-[WebCoreSettings userStyleSheetLocation]): Added.

        * WebCore.exp: Add WebCoreSettings to the exported class list.

        * kwq/KWQKHTMLSettings.mm: Get settings from WebCoreSettings rather than going
	directly at WebKit user defaults.
        * kwq/KWQKConfigBase.mm:
        (KConfig::readNumEntry): Check key.
        (KConfig::readUnsignedNumEntry): Use WebCoreSettings to get the value of the
	"JavaScript can open windows automatically" setting, rather than going directly
	at a WebKit user default.
        (KConfig::readColorEntry): Remove log message. This is implemented well enough.

	- fixed 3015877 -- either wean WebCore from _web_URLFromString, or make it public API in WebFoundation

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::redirectionTimerStartedOrStopped):
	Use KURL to make an NSURL rather than using [NSURL _web_URLWithString:].
        * kwq/KWQKJavaAppletWidget.mm: (KJavaAppletWidget::setBaseURL): Ditto.
        * kwq/WebCoreBridge.mm: (-[WebCoreBridge completeURLForDOMString:]): Ditto.

	After fixing the above bugs, I noticed that I could remove the WebFoundation dependency.

        * WebCore.pbproj/project.pbxproj: Remove WebFoundation framework.

        * kwq/WebCoreBridge.h: Replace reportError with reportBadURL.
        * kwq/KWQLoaderImpl.mm: (KWQServeRequest): Use reportBadURL instead of reportError.
	This was the last bit of direct dependency on WebFoundation.

	Do some preparation work for implementing "referrer".

        * khtml/khtml_part.cpp: Remove lots of APPLE_CHANGES and compile more
	original code. This in preparation for using the "referrer" code from KHTML.
        * khtml/khtmlview.h: Ditto.
        * khtml/misc/loader.cpp: Ditto.

        * kwq/kdecore/kurl.h: Add things needed by code formerly inside APPLE_CHANGES.
        * kwq/KWQKURL.mm: (KURL::hasRef): Ditto.
        (urlcmp): Implement in a simple-minded way. Needed by some code formerly inside
	APPLE_CHANGES. We can make a more full-featured version when and if we need it.
        * kwq/kio/global.h: Ditto.
        * kwq/kio/job.h: Ditto.
        * kwq/kio/jobclasses.h: Ditto.
        * kwq/KWQKjobclasses.mm: Ditto.
        * kwq/kparts/browserextension.h:
        * kwq/kparts/part.h: Ditto.
        * kwq/qt/qstringlist.h: Ditto.
        * kwq/KWQStringList.mm: (QStringList::pop_front): Ditto.
        * kwq/qt/qvaluelist.h: Ditto.
        * kwq/KWQValueListImpl.h: Ditto.
        * kwq/KWQValueListImpl.mm: (KWQValueListImpl::isEqual): Ditto.

	Other changes.

        * kwq/KWQApplication.mm:
        (QApplication::setOverrideCursor): Don't report an error for this, it's OK
	to do nothing.
        (QApplication::restoreOverrideCursor): Ditto.

2002-09-09  Richard Williamson  <rjw@apple.com>

        Implemented disable images automatically (2896319).

        * kwq/KWQKHTMLSettings.mm:
        (KHTMLSettings::autoLoadImages):

2002-09-09  Darin Adler  <darin@apple.com>

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::nextKeyView):
	Remove stray printf.

2002-09-09  David Hyatt  <hyatt@apple.com>

	Switching over to the layer system for the handling of mouse
	events.
	
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::nodeAtPoint):
        * khtml/rendering/render_image.cpp:
        (RenderImage::nodeAtPoint):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::paint):
        (RenderLayer::nodeAtPoint):
        (RenderLayer::constructZTree):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.cpp:
        (RenderObject::nodeAtPoint):
        * khtml/xml/dom_docimpl.cpp:
        (DocumentImpl::prepareMouseEvent):
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge drawRect:withPainter:]):
        (-[WebCoreBridge elementAtPoint:]):
        * kwq/qt/qrect.h:

2002-09-09  Darin Adler  <darin@apple.com>

        * khtml/rendering/render_layer.h: Add a call to delete to fix a storage leak.

2002-09-09  Darin Adler  <darin@apple.com>

        * khtml/misc/helper.cpp: (khtml::setNamedColor): Add a missing return I spotted.

        * kwq/KWQApplication.mm:
        * kwq/KWQChar.mm:
        * kwq/KWQCompletion.mm:
        * kwq/KWQCursor.mm:
        * kwq/KWQEvent.mm:
        * kwq/KWQFontInfo.mm:
        * kwq/KWQFontMetrics.mm:
        * kwq/KWQInputDialog.mm:
        * kwq/KWQKConfigBase.mm:
        * kwq/KWQKFileDialog.mm:
        * kwq/KWQKFileItem.mm:
        * kwq/KWQKGlobalSettings.mm:
        * kwq/KWQKHTMLSettings.mm:
        * kwq/KWQKIconLoader.mm:
        * kwq/KWQKMimeType.mm:
        * kwq/KWQKSimpleConfig.mm:
        * kwq/KWQKjobclasses.mm:
        * kwq/KWQKnetaccess.mm:
        * kwq/KWQLineEdit.mm:
        * kwq/KWQScrollView.mm:
        * kwq/KWQString.mm:
        * kwq/KWQWidget.mm:
        * kwq/KWQbrowserinterface.mm:
        * kwq/KWQtextstream.mm:
        * kwq/KWQxml.mm:
	Change various LOG(NotYetImplemented) to ERROR, FATAL, or removed them entirely.
	This will help us with the task of getting every last one either "not implemented
	on purpose" or implemented. I'm not sure the NotYetImplemented log channel is
	useful, because it's chock full of continuous "direction not implemented" messages.

        * kwq/KWQLogging.h:
        * kwq/KWQLogging.m:
	Removed the NeverImplemented logging channel. The distinction is no longer worth
	keeping around. We use NotYetImplemented instead.

2002-09-08  Darin Adler  <darin@apple.com>

	Switch over to new assertion/logging scheme.

        * kwq/KWQAssertions.h: Added.
        * kwq/KWQAssertions.m: Added.
        * kwq/KWQLogging.h: Added.
        * kwq/KWQLogging.m: Added.
        * kwq/kwqdebug.h: Removed.
        * kwq/kwqdebug.mm: Removed.
        * WebCore.pbproj/project.pbxproj: Update to reflect above changes.

        * kwq/KWQApplication.mm:
        * kwq/KWQChar.mm:
        * kwq/KWQColor.mm:
        * kwq/KWQComboBox.mm:
        * kwq/KWQCompletion.mm:
        * kwq/KWQCursor.mm:
        * kwq/KWQDrawUtil.mm:
        * kwq/KWQEvent.mm:
        * kwq/KWQFontInfo.mm:
        * kwq/KWQFontMetrics.mm:
        * kwq/KWQFrame.mm:
        * kwq/KWQHBox.mm:
        * kwq/KWQInputDialog.mm:
        * kwq/KWQInvisibleButton.mm:
        * kwq/KWQKConfigBase.mm:
        * kwq/KWQKFileDialog.mm:
        * kwq/KWQKFileItem.mm:
        * kwq/KWQKGlobalSettings.mm:
        * kwq/KWQKHTMLPartImpl.mm:
        * kwq/KWQKHTMLSettings.mm:
        * kwq/KWQKIconLoader.mm:
        * kwq/KWQKJob.mm:
        * kwq/KWQKLocale.mm:
        * kwq/KWQKMimeType.mm:
        * kwq/KWQKPartsEvent.mm:
        * kwq/KWQKSimpleConfig.mm:
        * kwq/KWQKURL.mm:
        * kwq/KWQKWin.mm:
        * kwq/KWQKWinModule.mm:
        * kwq/KWQKjobclasses.mm:
        * kwq/KWQKnetaccess.mm:
        * kwq/KWQLabel.mm:
        * kwq/KWQLineEdit.mm:
        * kwq/KWQListBox.mm:
        * kwq/KWQListImpl.mm:
        * kwq/KWQLoaderImpl.mm:
        * kwq/KWQObject.mm:
        * kwq/KWQPaintDeviceMetrics.mm:
        * kwq/KWQPainter.mm:
        * kwq/KWQPixmap.mm:
        * kwq/KWQRegion.mm:
        * kwq/KWQScrollView.mm:
        * kwq/KWQSlot.mm:
        * kwq/KWQString.mm:
        * kwq/KWQTimer.mm:
        * kwq/KWQWidget.mm:
        * kwq/KWQbrowserinterface.mm:
        * kwq/KWQtextcodec.mm:
        * kwq/KWQtextstream.mm:
        * kwq/KWQxml.mm:
        * kwq/WebCoreBridge.mm:
        * kwq/WebCoreCookieAdapter.m:
        * kwq/WebCoreHistory.m:
        * kwq/WebCoreImageRendererFactory.m:
        * kwq/WebCoreTextRendererFactory.m:
        * kwq/WebCoreViewFactory.m:
	Update to use new assertions and logging macros.
	In some cases, just removed unneeded includes.

2002-09-08  David Hyatt  <hyatt@apple.com>

	Landing the new layer system and turning it on for painting of
	all types of positioned blocks (and for painting the root
	and HTML layers as well).

	Event handling is not yet using the new layer system, so you
	may see oddities like DHTML menus now displaying correctly but
	events not working (since the event code may still be stacking
	incorrectly and think the DHTML is behind other content).
	
        * khtml/css/cssstyleselector.cpp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::setStyle):
        (RenderBox::calcHeight):
        (RenderBox::calcAbsoluteHorizontal):
        * khtml/rendering/render_container.cpp:
        (RenderContainer::addChild):
        (RenderContainer::removeChildNode):
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::setStyle):
        (RenderFlow::printObject):
        (RenderFlow::printSpecialObjects):
        (RenderFlow::layout):
        (RenderFlow::layoutSpecialObjects):
        (RenderFlow::layoutBlockChildren):
        (RenderFlow::insertSpecialObject):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_html.cpp:
        (RenderHtml::layout):
        * khtml/rendering/render_image.cpp:
        (RenderImage::printObject):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::updateLayerPosition):
        (RenderLayer::enclosingAncestor):
        (RenderLayer::addChild):
        (RenderLayer::convertToLayerCoords):
        (RenderLayer::paint):
        (RenderLayer::constructZTree):
        (RenderLayer::RenderZTreeNode::constructLayerList):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_replaced.cpp:
        (RenderReplaced::print):
        (RenderWidget::printObject):
        * khtml/rendering/render_root.cpp:
        (RenderRoot::calcHeight):
        (RenderRoot::layout):
        (RenderRoot::printObject):
        * khtml/rendering/render_root.h:
        * khtml/rendering/render_style.cpp:
        (StyleBoxData::StyleBoxData):
        (StyleBoxData::operator==):
        * khtml/rendering/render_style.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge drawRect:withPainter:]):
        * kwq/qt/qrect.h:

2002-09-06  Maciej Stachowiak  <mjs@apple.com>

        Fix another instance of the same problem:

	* kwq/KWQString.mm:
        (QString::detach):

2002-09-06  Maciej Stachowiak  <mjs@apple.com>

	Fix optimized build:
	
        * kwq/KWQString.mm:
        (QString::detachInternal): Uselessly Initialize newData to NULL
	since the compiler can't tell that FATAL won't return.

2002-09-06  Darin Adler  <darin@apple.com>

        * kwq/WebCoreResourceLoader.h:
	Define WebCoreResourceHandle protocol.

        * kwq/kio/jobclasses.h:
        * kwq/KWQKjobclasses.mm:
        * kwq/KWQLoaderImpl.mm: (KWQServeRequest):
        * kwq/WebCoreBridge.h:
	Use WebCoreResourceHandle instead of WebResourceHandle.

        * kwq/KWQString.mm: (QString::fill): Fix case where the new string
	is going to be empty, but the old string was not. Before, it leaked
	a handle.

        * kwq/character-sets.txt: Updated to 2002-06-14 version from 2001-08-23 version.
        * kwq/mac-encodings.txt: Updated encoding names to include ones gleaned from
	the I18N-Charset-1.17 Perl module.

        * kwq/KWQCharsets.mm: Formatting tweaks.

2002-09-06  Richard Williamson  <rjw@apple.com>

        Start using khtml's 'toAdd' parameter to justify text.
        
        * khtml/rendering/font.cpp:
        (Font::drawText):
        
        Normalize all calls to get width to minimize use of
        ObjC.  Will make it easier to use IMPL cache later.
        
        * kwq/KWQFontMetrics.mm:
        (QFontMetrics::width):
        (QFontMetrics::floatWidth):
        (QFontMetrics::floatCharacterWidth):
        
        Pass additional 'toAdd' parameter.
        
        * kwq/KWQPainter.mm:
        (QPainter::drawText):
        * kwq/qt/qpainter.h:
        
        Remove methods now that width calls are normalized to single
        method.
        * kwq/WebCoreTextRenderer.h:


=== Alexander-22 ===

2002-09-05  Richard Williamson  <rjw@apple.com>

        Add the first child text node of the element to the
        element dictionary.  This will be used as a link 'label'.
        
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge elementAtPoint:]):

2002-09-05  Richard Williamson  <rjw@apple.com>
    
        Removed debugging.
        
        * khtml/khtml_part.cpp:
        (KHTMLPart::closeURL):

2002-09-05  Richard Williamson  <rjw@apple.com>

        Always call KHTMLPart::closeURL when a new document is loaded.
        
        Added support for saving and restoring document state in
        the back/forward list.  Document state includes form data.
        
        * khtml/khtml_part.cpp:
        (KHTMLPart::openURL):
        (KHTMLPart::closeURL):
        (KHTMLPart::begin):
        * kwq/KWQKHTMLPartImpl.h:
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::saveDocumentState):
        (KWQKHTMLPartImpl::restoreDocumentState):
        * kwq/WebCoreBridge.h:
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge saveDocumentState]):
        (-[WebCoreBridge restoreDocumentState]):

2002-09-04  Darin Adler  <darin@apple.com>

        * WebCore.pbproj/project.pbxproj:
        * kwq/KWQObject.mm:
        * kwq/KWQPainter.mm:
        * kwq/KWQTimer.mm:
        * kwq/WebCoreCookieAdapter.h:
        * kwq/WebCoreImageRenderer.h:
        * kwq/WebCoreImageRendererFactory.h:
	Tweaks, no substantive changes.

2002-09-02  David Hyatt  <hyatt@apple.com>

	Tweak the damage rect testing to account for the fact that a child
	layer may fall entirely outside the bounds of its parent layer.
	
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::constructZTree):

2002-08-31  Darin Adler  <darin@apple.com>

	- fixed 3038336 -- repro crash in QTextDecoder trying to display UTF-16 file

        * kwq/mac-encodings.txt: Hook up the UTF-16 encoding to the name iso-10646-ucs-2.
	We have a long way to go to get this right. There are almost certainly going to
	be other bugs with 16-bit character pages.

        * kwq/KWQKHTMLSettings.mm: (KHTMLSettings::encoding): Just return "latin1",
	not "NSISOLatin1StringEncoding".

        * kwq/KWQString.mm: (QString::fromStringWithEncoding): Pass true for the
	"pay attention to BOM" flag.

        * khtml/rendering/render_object.cpp: Take out unneeded APPLE_CHANGES.

2002-08-30  Ken Kocienda  <kocienda@apple.com>

	Fixed a problem in this function where broken UTF-8 would cause a crash.

        * WebCore.pbproj/project.pbxproj:
        * kwq/KWQString.mm:
        (QString::fromStringWithEncoding)

2002-08-30  Richard Williamson  <rjw@apple.com>

        Removed debugging log.
        
        * kwq/KWQString.mm:
        (QString::fromStringWithEncoding):

2002-08-30  Richard Williamson  <rjw@apple.com>

        Made decoder more robust wrt nulls in content.  Changed use
        of QCString to null safe QString rather than modify
        content.
        
        * khtml/misc/decoder.cpp:
        (Decoder::decode):
        (Decoder::flush):
        * khtml/misc/decoder.h:
        * kwq/KWQString.mm:
        (QString::fromStringWithEncoding):

2002-08-30  Darin Adler  <darin@apple.com>

	- fixed 3027407 -- Console error refers to closed bug

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::bridgeForFrameName):
	Update bug number from 2959902 to 2942073.

	- fixed 3027532 -- can't tab into or out of textareas
	
        * kwq/KWQTextArea.h: Add setFont:.
        * kwq/KWQTextArea.mm:
        (-[KWQTextArea _createTextView]): Make a KWQTextAreaTextView.
        (-[KWQTextArea textDidChange:]): Send text changed messages when the text
	is changed, not when done editing. I did this for KWQNSTextField a while ago;
	it's tragic that AppKit leads us to have two separate classes for these nearly
	identical purposes.
        (-[KWQTextArea setFont:]): Call setFont on the text view.
        (-[KWQTextArea becomeFirstResponder]): Call makeFirstResponder on the text view.
        (-[KWQTextArea nextKeyView]): Do that voodoo, just like KWQNSTextField.
        (-[KWQTextArea previousKeyView]): Ditto.
        (-[KWQTextArea nextValidKeyView]): Ditto.
        (-[KWQTextArea previousValidKeyView]): Ditto.
        (-[KWQTextAreaTextView insertTab:]): Select the next key view. We don't get this
	automatically because this is not a field editor. But being a field editor leads
	to other unwanted behavior.
        (-[KWQTextAreaTextView insertBacktab:]): Ditto.
        (-[KWQTextAreaTextView becomeFirstResponder]): Select all on entry.
        (-[KWQTextAreaTextView shouldDrawInsertionPoint]): Don't draw insertion point
	when we are not the first responder.
        (-[KWQTextAreaTextView selectedTextAttributes]): Don't draw the selection when
	we are not the first responder.

        * kwq/qt/qtextedit.h:
        * kwq/KWQTextEdit.mm: (QTextEdit::setFont): Call -[KWQTextArea setFont:].
        (QTextEdit::focusPolicy): Always return TabFocus, because the top level widget
	is not an NSControl so QWidget::focusPolicy does not suffice.

        * kwq/qt/qwidget.h: Make focusPolicy virtual.

        * kwq/qt/qfont.h:
        * kwq/KWQFont.mm: (QFont::getNSFont): Add this helper function
	so we don't have to repeat this in multiple places.

        * kwq/KWQLineEdit.mm: (QLineEdit::setFont): Use QFont::getNSFont.

        * force-clean-timestamp: For you poor bastards who aren't using the new
	Project Builder yet.

2002-08-30  Darin Adler  <darin@apple.com>

        * WebCore.pbproj/project.pbxproj: Allowed the new Project Builder to put in
	encodings for each file.

2002-08-29  David Hyatt  <hyatt@apple.com>

	Begin connecting the layer system.  The root box and the <html>
	box now construct layers for themselves.  Those layers are
	connected in a layer tree properly and they correctly update
	their positions.

	Implemented all the code for layer construction and for keeping
	the layer tree in sync with the render object tree.  

	The goal is to get the layer tree fully constructed and correct
	(with lots of testing) before actually switching over to it for
	painting.

	This change requires a clean of WebCore.
	
        * force-clean-timestamp:
        * khtml/rendering/render_box.cpp:
        (RenderBox::RenderBox):
        (RenderBox::~RenderBox):
        (RenderBox::setPos):
        (RenderBox::positionChildLayers):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_container.cpp:
        (RenderContainer::~RenderContainer):
        (RenderContainer::addChild):
        (RenderContainer::removeChildNode):
        * khtml/rendering/render_container.h:
        * khtml/rendering/render_html.cpp:
        (RenderHtml::RenderHtml):
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::updateLayerPosition):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_object.h:
        * khtml/rendering/render_root.cpp:
        (RenderRoot::RenderRoot):

=== Alexander-21 ===

2002-08-28  David Hyatt  <hyatt@apple.com>

	Implement the flattening algorithm that walks the layer 
	hierarchy and produces the correct layer list for back
	to front painting.  (Still under construction.  Not used yet.)
	
        * khtml/rendering/render_layer.cpp:
        (sortByZOrder):
        (RenderLayer::RenderZTreeNode::constructLayerList):
        * khtml/rendering/render_layer.h:

2002-08-28  Richard Williamson  <rjw@apple.com>

        More tweaks to ccs.
        Added underline to visited links.
        Made outline for active normal and visited links gray.
        
        * khtml/css/html4.css:

2002-08-28  Richard Williamson  <rjw@apple.com>

        Fixed outline of for active link style.
        
        * khtml/css/html4.css:
        * kwq/KWQPainter.mm:
        (QPainter::drawLine):

2002-08-28  David Hyatt  <hyatt@apple.com>

	Adding knowledge to the style system of auto z-indices.  The old
	code doesn't use this yet, but the new layering code will.

	Also wrote the ztree construction function (not used yet) and
	stubbed out the display list flattening routines.
	
        * khtml/rendering/render_layer.cpp:
        (RenderLayer::convertToLayerCoords):
        (RenderLayer::constructZTree):
        (RenderLayer::constructLayerList):
        * khtml/rendering/render_layer.h:
        * khtml/rendering/render_style.cpp:
        (StyleBoxData::StyleBoxData):
        * khtml/rendering/render_style.h:

2002-08-28  Darin Adler  <darin@apple.com>

	- fixed 2977587 -- JavaScript code that reads the values of text areas
	misses the last line if no trailing CR

        * kwq/KWQTextArea.mm: (-[KWQTextArea paragraphs]):

2002-08-28  David Hyatt  <hyatt@apple.com>

	Putting design notes and API details for the layering system
	into the header file.
	
        * khtml/rendering/render_layer.h:

2002-08-28  Darin Adler  <darin@apple.com>

        * kwq/mac-encodings.txt: Sort all the character set names alphabetically, and use all lower case.
        * kwq/make-charset-table.pl: Require lower-case sorted lists of character set names.

2002-08-28  Darin Adler  <darin@apple.com>

	- fixed 3032148 -- Button not disabled in page

        * kwq/KWQWidget.mm: (QWidget::setEnabled): Call setEnabled:
	on the NSView if it implements it.

2002-08-28  Darin Adler  <darin@apple.com>

	- fixed 3030212 -- Problems rendering pages that specify "x-mac-roman" character
	set (like our Danish help pages)

        * kwq/mac-encodings.txt: Added x-mac-roman as an alias for macintosh.

2002-08-27  Darin Adler  <darin@apple.com>

        * force-clean-timestamp: Dave's changes require a full build. I found out the
	hard way, by debugging for a while.

2002-08-27  Richard Williamson <rjw@apple.com>

        * kwq/WebCoreBridge.h:
        
        Fixed constants to conform to WebKit.  These need to be shared.

2002-08-27  David Hyatt  <hyatt@apple.com>

	Change relative positioned blocks so that they are treated as special objects and
	painted last along with absolutely positioned blocks and floaters.  Note that the
	entire special object system is fundamentally flawed, and it needs to be replaced
	with a real layering subsystem.

	This checkin at least gets relatively positioned divs painting correctly some of
	the time (in the cases where the containing blocks of absolute and relative positioned
	divs happen to be the same).  It does not, however, deal with the problem of ensuring
	correct stacking of positioned elements with different containing blocks.

	render_layer.h and .cpp include a new implementation (not used yet, just the beginnings)
	of a layering subsystem that I am going to be working on over the next few days
	that will eventually be responsible for handling event dispatching and painting and that
	will also understand how to deal with form controls and other objects that have Cocoa
	views.
	
        * WebCore.pbproj/project.pbxproj:
        * khtml/rendering/render_box.cpp:
        (RenderBox::RenderBox):
        * khtml/rendering/render_box.h:
        * khtml/rendering/render_flow.cpp:
        (RenderFlow::printObject):
        (RenderFlow::printSpecialObjects):
        (RenderFlow::layoutSpecialObjects):
        (RenderFlow::layoutBlockChildren):
        (RenderFlow::insertSpecialObject):
        * khtml/rendering/render_flow.h:
        * khtml/rendering/render_layer.cpp: Added.
        (RenderLayer::RenderLayer):
        (RenderLayer::~RenderLayer):
        (RenderLayer::addChild):
        (RenderLayer::removeChild):
        * khtml/rendering/render_layer.h: Added.

2002-08-27  Darin Adler  <darin@apple.com>

	- fixed 3031952 -- null-dereference in dispatchToUInt32 closing window

        * khtml/ecma/kjs_window.cpp: (History::getValueProperty):
	Use Undefined(), not Value() for an error result. Value() is pure evil.

2002-08-27  Darin Adler  <darin@apple.com>

	- fixed 3021018 -- Crash selecting from popup just after choosing radio button

        * kwq/KWQComboBox.mm:
        (QComboBox::QComboBox): Pass the widget in when creating the cell.
        (-[KWQPopUpButtonCell initWithWidget:]): Store a widget pointer.
        (-[KWQPopUpButtonCell trackMouse:inRect:ofView:untilMouseUp:]): Get to the bridge
	and tell it to defer loading while we track the mouse.

        * kwq/KWQKHTMLPartImpl.h: Add bridgeForWidget.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::nextKeyViewForWidget): Use nodeForWidget and partForNode.
        (KWQKHTMLPartImpl::bridgeForWidget): Added. Use nodeForWidget and partForNode.
        (KWQKHTMLPartImpl::partForNode): Move code here from nextKeyViewForWidget.
        (KWQKHTMLPartImpl::nodeForWidget): Move code here from nextKeyViewForWidget.

        * kwq/WebCoreBridge.h: Add defersLoading and setDefersLoading. Both are already
	in WebKit.

2002-08-26  David Hyatt  <hyatt@apple.com>

	Fix for 3026006.  Ensure that TABLES inside <div>s with align="right"
	are properly positioned.  <div align="right"> was completely
	unimplemented.  This patch implements it for the common cases
	(nested divs, tables within divs, and paragraphs).
	
        * khtml/css/html4.css:

2002-08-26  Darin Adler  <darin@apple.com>

        * khtml/rendering/render_list.cpp:
	Make file match the original KDE more closely (no substantive change).

2002-08-26  Richard Williamson  <rjw@apple.com>

        * WebCore.exp:

        Added WebCoreHistory
        
        * WebCore.pbproj/project.pbxproj:

        Added WebCoreHistory
        
        * kwq/KWQKHistoryProvider.mm:
        Use WebCoreHistory to determine visited link.
        
        * kwq/WebCoreHistory.h: Added.
        * kwq/WebCoreHistory.m: Added.
        
        Stage 1.  Use WebKit's WebHistory.  Writing
        of history and initialization still handled
        by Alex until stage 2.
        
        (+[WebCoreHistory setSharedHistory:]):
        (+[WebCoreHistory sharedHistory]):
        (-[WebCoreHistory containsURL:]):

        * kwq/KWQString.mm:
        (QString::compare):

        Optimization, use strcmp when both src and dst have valid ascii.
        

2002-08-26  David Hyatt  <hyatt@apple.com>

	- Patch drawText to understand right-aligned drawing.  
	- Fixed <ul> bullets so that they position properly.
	- Fixed bugs with horizontal and vertical positioning of
	  <ol> bullets.
	
        * khtml/rendering/render_list.cpp:
        (RenderListMarker::printObject):
        * kwq/KWQPainter.mm:
        (QPainter::drawText):

2002-08-24  Darin Adler  <darin@apple.com>

	- fixed 3032072 -- Crash on reload in DOM::DocumentImpl::~DocumentImpl [unified]()

	This was a tough one to debug.
	Turned out to be a subtle bug in our new QConstString implementation.

        * kwq/KWQString.mm:
        (QStringData::makeAscii): Don't invalidate the Unicode buffer unless the ASCII
	buffer is taking over the internal buffer from the Unicode. In other cases, it's
	important not to invalidate the Unicode because it can result in the Unicode being
	freed and re-created when unicode() is called, which is disastrous in the QConstString
	case because we can't free the Unicode.
        (QStringData::makeUnicode): Make the corresponding change for ASCII too. In this
	case, it's just an optimization, not a bug fix.
        (QString::insert), (QString::remove), (QString::fill), (QString::operator+=):
	Mark the other string invalid whenever we modify either the ASCII or the Unicode
	string. This was handled correctly for some operations before, but not all, and it
	now matters because makeAscii and makeUnicode will now allow this state.

	Fixed a separate QString problem; I think I may have introduced this one.

        * kwq/KWQString.mm:
        (QString::getNSString): Since by ASCII, we actually mean ISO Latin 1, we can't use
	[NSString stringWithCString:]. Use CFStringCreateWithCString instead, pass
	CFStringCreateWithCString as the encoding, and use autorelease. We shouldn't really
	use the term ASCII in this class for the 8-bit-per-character buffer. Something more
	like Latin1 would be a more accurate way to refer to it. Maybe I'll do that renaming
	after talking to Richard about it on Monday.

	Fixed a small storage leak.

        * khtml/css/css_valueimpl.cpp: (CSSPrimitiveValueImpl::cleanup): Added braces to
	fix obviously-incorrect if/else grouping.

2002-08-23  Darin Adler  <darin@apple.com>

	Got the kurl-test in the Tests directory working again.

        * kwq/KWQKURL.mm: (KURL::KURL): Fixed problem where relative path resolution code
	for "../" could eat up the host name too, treating it as part of the path.

2002-08-23  Darin Adler  <darin@apple.com>

	- fixed 3032058 -- Links on local developer doc pages all broken (all local files?)

        * kwq/KWQKURL.mm: (KURL::getNSURL): Re-added a workaround for CFURL bug 2908969.
	We have to hack to make NSURL take "file:/" URLs.

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::nextKeyViewInFrame): Add a nil check.
	I ran into this because my frame failed to load.

2002-08-23  Maciej Stachowiak  <mjs@apple.com>

	A few more KURL changes that reduce it down to background noise
	level.

	For me this gave another 1-2% improvement on cvs-base.

        * kwq/kdecore/kurl.h:
        * kwq/KWQKURL.mm:
        (KURL::KURL): In the relative constructor, do all work in a char
	array for the relative path case, and leave it up to ::parse to
	create a QString.
        (KURL::parse): Do all work in a char array, only creating a
	QString at the end if needed. Also, take an optional pointer to
	the QString that the char * was created from, and if the final
	processed URL is the same as the original, assign the original
	instead of creating a new QString.
        (KURL::setProtocol): Adjust for prase() interface change.
        (KURL::setHost): Likewise.
        (KURL::setPort): Likewise.
        (KURL::setRef): Likewise.
        (KURL::setQuery): Likewise.
        (KURL::setPath): Likewise.
        (appendEscapingBadChars): Instead of taking and returning
	a QString like the old escapeBadChars, copy from and write into
	existing C string buffers.

2002-08-22  Darin Adler  <darin@apple.com>

        * force-clean-timestamp: Without this, I crash on startup.

2002-08-22  Maciej Stachowiak  <mjs@apple.com>

	Brand new KURL implementation which avoids CFURL, CFString, and
	all that other allocation-happy goodness and instead does as much
	work as possible with raw ASCII buffers.

	For me this gave a ~5% performance improvement on cvs-base.
	
        * kwq/KWQKURL.mm:
        (KURL::KURL):
        (KURL::hasPath):
        (KURL::protocol):
        (KURL::host):
        (KURL::port):
        (KURL::pass):
        (KURL::user):
        (KURL::ref):
        (KURL::query):
        (KURL::path):
        (KURL::setProtocol):
        (KURL::setHost):
        (KURL::setPort):
        (KURL::setRef):
        (KURL::setQuery):
        (KURL::setPath):
        (KURL::prettyURL):
        (KURL::decode_string):
        (escapeBadChars):
        (KURL::parse):
        (KURL::getNSURL):
        * kwq/kdecore/kurl.h:
        * khtml/khtml_part.cpp:
        (KHTMLPart::end): Don't call KURL::clearCaches() any more.

2002-08-22  Darin Adler  <darin@apple.com>

        * kwq/KWQButton.mm: (QButton::~QButton): Disconnect the view
	from the widget by doing setTarget:nil.
        * kwq/KWQComboBox.mm: (QComboBox::~QComboBox): Ditto.

2002-08-22  David Hyatt  <hyatt@apple.com>

	Add vertical margins for checkboxes and radios.  A later rule
	in the file was overriding my earlier attempt to set up these margins.
	
        * khtml/css/html4.css:

2002-08-22  Richard Williamson  <rjw@apple.com>

        New faster char * append (actually insert) for mjs.
        
        * kwq/KWQString.mm:
        (QString::insert):
        * kwq/qt/qstring.h:

2002-08-22  Darin Adler  <darin@apple.com>

	Some small QString improvements.

        * kwq/qt/qstring.h: Add printf attribute to sprintf member function.
        * kwq/KWQString.mm:
	Remove extra \n characters from QSTRING_FAILURE calls. Change some
	fprintf to QSTRING_FAILURE. Change some QSTRING_FAILURE to KWQ_ASSERT.
        (QStringData::makeAscii): Fix bug where it would update _maxAscii
	with a new size even when it didn't allocate a new buffer.
        (QStringData::makeUnicode): Fix bug where it would update _maxUnicode
	with a new size even when it didn't allocate a new buffer.
        (QString::utf8): Fix bug where it assumed the UTF-8 form of a string
	has the same length as the Unicode version. Also save one allocation
	by doing it right into the QCString.
        (QString::local8Bit): Just call utf8().
        (QString::setNum): Have all these call our sprintf.
        (QString::sprintf): Format once to get the length. Then do the second
	format right into the string buffer. This way we don't have to do
	any allocation at all, nor use CFString.

=== Alexander-20 ===

2002-08-22  Darin Adler  <darin@apple.com>

	Fixed a one-click crasher that Ken and Don told me about.

        * kwq/KWQObject.mm: (QObject::QObject): Initialize m_eventFilterObject.

2002-08-21  Darin Adler  <darin@apple.com>

	- fixed 3021908 -- text areas should be plain text only

        * kwq/KWQTextArea.mm:
        (-[KWQTextArea _createTextView]): setRichText:NO
        (-[KWQTextArea dealloc]): Release the text view so we don't leak.

2002-08-21  Darin Adler  <darin@apple.com>

        * kwq/KWQNSViewExtras.m: (-[NSClipView _KWQ_scrollRectToVisible:inView:]):
	Use bounds, not visibleRect. Seems to work better.

2002-08-21  John Sullivan  <sullivan@apple.com>

	- commented out (with FIXME 2935687) the code that was advertising in
	the status bar that shift-command would open a link behind the
	current window, since it doesn't.

        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::overURL):

2002-08-21  Darin Adler  <darin@apple.com>

	Fix for two problems with password fields.

	   1) Return wasn't working.
 	   2) They were wrapping instead of scrolling.

        * kwq/KWQNSTextField.mm: 
        (-[KWQNSTextField setUpTextField:]): Shared initialization, needed by both
	the text field and the secure field. This includes the two things we needed
	for the password text field; wiring up action properly and setScrollable:YES.
        (-[KWQNSTextField initWithFrame:]): Use setUpTextField.
	(-[KWQNSTextField setPasswordMode:]): Use setUpTextField.

2002-08-21  David Hyatt  <hyatt@apple.com>

	Fix for 3015372, tables and blocks nested inside other tables
	don't center.  This fixes a lot of sites, from the forum
	sites to the www.ve3d.com voodooextreme site.
	
        * khtml/html/html_tableimpl.cpp:
        (HTMLTablePartElementImpl::parseAttribute):

2002-08-21  Darin Adler  <darin@apple.com>

	- fixed 3027927 -- selected text fields do not cause the web view to scroll to reveal them

        * kwq/KWQNSTextField.mm:
        (-[KWQNSTextField becomeFirstResponder]): Call [self _KWQ_scrollFrameToVisible].
        (-[KWQSecureTextField becomeFirstResponder]): Call [self _KWQ_scrollFrameToVisible].

        * kwq/KWQNSViewExtras.h: Added. New scrolling functions.
        * kwq/KWQNSViewExtras.m: Added. New scrolling functions.
        * WebCore.pbproj/project.pbxproj: Added KWQNSViewExtras.

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::nextKeyViewInFrame):
	Make sure superview and position is set up properly before we try to tab to something.
        * kwq/KWQWidget.mm: (QWidget::setFocus):
	Make sure superview and position is set up properly before we try to focus something.

	Unrelated change.

        * kwq/KWQInvisibleButton.h:
        * kwq/KWQInvisibleButton.mm:
	Add KWQ prefix to the name of the private Objective C class to avoid potential conflicts.

2002-08-21  Darin Adler  <darin@apple.com>

	Implemented baseline alignment for form elements. We decided that this was better
	than what we're currently doing. But it will look even better when the font of the
	text field matches the font of the surrounding text, so we should consider that.

	I also nudged the text down one pixel in popup menus, to match buttons. I think we
	probably should suggest that this be done in Aqua by default (buttons and popup menus
	already match in the normal size; this is the small size).

        * khtml/rendering/render_form.h: Remove some APPLE_CHANGES.
        * khtml/rendering/render_form.cpp:
        (RenderFormElement::baselinePosition): Use the widget's concept of the baseline
	position (the new QWidget::baselinePosition function).
        (RenderButton::baselinePosition): Just call the inherited version.
        (RenderSubmitButton::baselinePosition): Remove our ifdef because we want what the
	original code said, which was just calling the inherited version.
	(RenderLineEdit::baselinePosition): Removed our added method since we want to just
	call the inherited version.
        (RenderSelect::baselinePosition): Just call the inherited version for the pop up
	menu case. For the list box, just left the old code alone until someone can take
	a look at it.

        * kwq/qt/qwidget.h: Added new virtual baselinePosition function.
        * kwq/KWQWidget.mm: (QWidget::baselinePosition): Default for baseline is the bottom.

        * kwq/qt/qlineedit.h:
        * kwq/KWQLineEdit.mm:
        (QLineEdit::baselinePosition): Compute the baseline based on how NSTextField does it.
	Compared to the other widgets this was easy, because the cell's drawingRectForBounds
	gives you the place where the top of the line is. It does use defaultLineHeightForFont,
	which is not used by other widgets, but that's no real problem.

        * kwq/qt/qbutton.h:
        * kwq/KWQButton.mm: Moved all the code that's push-button specific into QPushButton.

        * kwq/qt/qpushbutton.h:
        * kwq/KWQPushButton.mm:
        (QPushButton::QPushButton): Set the bezel style of the button.
        (QPushButton::sizeHint): Moved here from QButton.
        (QPushButton::frameGeometry): Moved here from QButton.
        (QPushButton::setFrameGeometry): Moved here from QButton.
        (QPushButton::baselinePosition): Compute the baseline based on how NSButton does it.
	The rule for the style of button we use is "centered vertically in the available space,
	offset by kThemePushButtonSmallTextOffset", so I had to hardcode the value of
	kThemePushButtonSmallTextOffset; I called it VERTICAL_FUDGE_FACTOR (2).

        * kwq/qt/qcombobox.h:
        * kwq/KWQComboBox.mm:
        (-[KWQPopUpButtonCell drawInteriorWithFrame:inView:]): Custom cell class that nudges
	the text down one pixel.
        (QComboBox::QComboBox): Attach the custom cell class.
        (QComboBox::baselinePosition): Compute the baseline based on how NSPopUpButton does it.
	The rule for the style of pop-up button we use is "CELLOFFSET pixels down from the top",
	so I had to hardcode the value of CELLOFFSET; I called it VERTICAL_FUDGE_FACTOR (2).

        * force-clean-timestamp: Yes, again.

2002-08-20  Darin Adler  <darin@apple.com>

	- fix 3028936 -- fields are not submitting the correct data if they are selected
	when you submit

        * kwq/KWQNSTextField.mm: (-[KWQNSTextField controlTextDidChange:]):
	Call widget->textChanged and set edited to true here. The old code had two problems.
	First, it only sent textChanged from controlTextDidEndEditing. Second, it overrode
	textDidChange without calling super, preventing controlTextDidChange from being
	sent to the delegate.

2002-08-20  David Hyatt  <hyatt@apple.com>

	Fix background positioning so that it works with table cells.
	This fixes the tabs on www.msn.com.
	
        * khtml/rendering/render_box.cpp:
        (RenderBox::printBackground):
        * khtml/rendering/render_table.h:

2002-08-20  Darin Adler  <darin@apple.com>

	WebCore part of support for tabbing into and out of the toolbar.

        * kwq/KWQKHTMLPartImpl.h: Renamed static nextKeyView to nextKeyViewForWidget.
	Added nextKeyViewInFrameHierarchy.
        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::nextKeyViewInFrameHierarchy): New name for the old nextKeyView.
        (KWQKHTMLPartImpl::nextKeyView): Added. Does all the logic for handling views outside
	the frame hierarchy that used to be only in the static nextKeyView.
        (KWQKHTMLPartImpl::nextKeyViewForWidget): New name for the static nextKeyView, which
	now just does the widget-specific bits. Removed null check in here that's no longer needed.

        * kwq/KWQNSTextField.mm: Update to call nextKeyViewForWidget.

        * kwq/WebCoreBridge.h: Added nextKeyViewInsideWebViews, previousKeyViewInsideWebViews,
	nextKeyViewOutsideWebViews, and previousKeyViewOutsideWebViews.

        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge nextKeyViewInsideWebViews]): Call nextKeyViewInFrameHierarchy.
        (-[WebCoreBridge previousKeyViewInsideWebViews]): Call nextKeyViewInFrameHierarchy.

	Introduced QString to sprong. See <http://www.goat.demon.co.uk/sprong.html>.
	A few other tweaks to QString API; wean it from mutable strings.

        * kwq/qt/qstring.h:
        * kwq/KWQString.mm: Sprongify it.
        (QString::setBufferFromCFString): Add a fixed-size buffer to avoid malloc.
        (QString::getCFString): Replace getCFMutableString with this.
        (QString::getNSString): Use NSString directly.

        * kwq/KWQDictImpl.mm:
        * kwq/KWQKURL.mm:
        * kwq/KWQStringList.mm:
        * kwq/KWQtextcodec.mm:
        * kwq/WebCoreBridge.mm:
	Use getCFString, not getCFMutableString.

2002-08-19  Darin Adler  <darin@apple.com>

        * force-clean-timestamp: Richard's changes require a clean build.

2002-08-19  Richard Williamson  <rjw@apple.com>

        QString rewrite.  Much faster now.
        QString has an inline rep, QStringData, which
        has an inline character buffer.  reps are
        referenced indirectly via a handle.  inline
        reps are detached when necessary.  Typical
        stack based usage requires no allocations
        for small string.  Attempts are made to avoid
        costly conversions between ascii and unicode.
        Extensive diagnostics can be enable by
        defining QSTRING_DEBUG_ALLOCATIONS and calling
        _printQStringAllocationStatistics().
        
        There appear to be a few small lingering leaks
        that I need to track down.
        
        * WebCore-tests.exp:
        
        Added symbols for qstring-test.cpp.
        
        * khtml/css/cssstyleselector.cpp:
        
        Removed old string optimization hack.
        
        * kwq/KWQString.mm:
        
        Rewrite.
        (_isOnStack):
        (countInstance):
        (allocatedBuffers):
        (ALLOC_CHAR):
        (REALLOC_CHAR):
        (DELETE_CHAR):
        (ALLOC_QCHAR):
        (REALLOC_QCHAR):
        (DELETE_QCHAR):
        (_printQStringAllocationStatistics):
        (ucstrcmp):
        (ucstrncmp):
        (ucstrnicmp):
        (ok_in_base):
        (QStringData::QStringData):
        (QStringData::initialize):
        (QStringData::operator new):
        (QStringData::operator delete):
        (QString::makeSharedNullHandle):
        (QString::makeSharedNull):
        (QStringData::~QStringData):
        (QStringData::ascii):
        (QStringData::increaseAsciiSize):
        (QStringData::unicode):
        (QStringData::increaseUnicodeSize):
        (QStringData::makeAscii):
        (QStringData::makeUnicode):
        (QString::setBufferFromCFString):
        (QString::fromStringWithEncoding):
        (QString::fromCFMutableString):
        (QString::fromCFString):
        (QString::fromNSString):
        (QString::getCFMutableString):
        (QString::getNSString):
        (QString::~QString):
        (QString::QString):
        (QString::operator=):
        (QString::at):
        (QString::unicode):
        (QString::compare):
        (QString::startsWith):
        (QString::endsWith):
        (QString::latin1):
        (QString::isNull):
        (QString::find):
        (QString::findRev):
        (QString::contains):
        (QString::toShort):
        (QString::toUShort):
        (QString::toInt):
        (QString::toUInt):
        (QString::toLong):
        (QString::toULong):
        (QString::toDouble):
        (QString::findArg):
        (QString::arg):
        (QString::left):
        (QString::right):
        (QString::mid):
        (QString::copy):
        (QString::lower):
        (QString::stripWhiteSpace):
        (QString::simplifyWhiteSpace):
        (QString::deref):
        (QString::setUnicode):
        (QString::setLatin1):
        (QString::sprintf):
        (QString::append):
        (QString::insert):
        (QString::detachInternal):
        (QString::detach):
        (QString::remove):
        (QString::replace):
        (QString::forceUnicode):
        (QString::setLength):
        (QString::truncate):
        (QString::fill):
        (QString::operator+=):
        (QString::convertToQCString):
        (operator==):
        (QConstString::QConstString):
        (QConstString::~QConstString):
        (_initializeHandleNodeBlock):
        (_allocatePageNode):
        (_initializeHandleNodes):
        (_allocateNode):
        (allocateHandle):
        (freeHandle):
        
        * kwq/qt/qstring.h:
        Rewrite
        
2002-08-19  Maciej Stachowiak  <mjs@apple.com>

        * Makefile.am: Added new mechanism to clean only the objects that
	depend on JavaScript.
	* force-js-clean-timestamp: Touched since I changed JSC just now.
        * .cvsignore: Ignore previous-js-clean-timestamp.
	
2002-08-19  Darin Adler  <darin@apple.com>

	Fixed tab cycle on slashdot.org and elsewhere by being stricter about what is
	included in the tab cycle.

        * kwq/KWQWidget.mm: (QWidget::focusPolicy): Use the same rule as AppKit.

2002-08-19  David Hyatt  <hyatt@apple.com>

	Tweak baselines to look a little better for form controls.
	This will be redone by Darin to really baseline align... this
	is just temporary.

	Also adding 3px margins to <input> and <textarea> and <select>.
	
        * khtml/css/html4.css:
        * khtml/rendering/render_form.cpp:
        (RenderButton::baselinePosition):
        (RenderSelect::baselinePosition):

2002-08-19  Darin Adler  <darin@apple.com>

	- fixed 3027791 -- Crash when pressing "tab" after going to http://slashdot.org/

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::nextKeyViewInFrame): Add null check.

2002-08-19  Darin Adler  <darin@apple.com>

	Put in more robust version of the next/previous key view checking
	that matches what I did in WebHTMLView.

        * kwq/KWQNSTextField.h: Add inNextValidKeyView instance variable.
        * kwq/KWQNSTextField.mm:
        (-[KWQNSTextField dealloc]): No need to nil out widget.
        (-[KWQNSTextField nextKeyView]): Only do the computation when called from nextValidKeyView.
        (-[KWQNSTextField previousKeyView]): Only do the computation when called from previousValidKeyView.
        (-[KWQNSTextField nextValidKeyView]): Set boolean.
        (-[KWQNSTextField previousValidKeyView]): Set boolean.
        (-[KWQSecureTextField nextKeyView]): Only do the computation when called from nextValidKeyView.
        (-[KWQSecureTextField previousKeyView]): Only do the computation when called from nextValidKeyView.
        (-[KWQSecureTextField nextValidKeyView]): Set boolean.
        (-[KWQSecureTextField previousValidKeyView]): Set boolean.

	Unrelated change.

        * kwq/mac-encodings.txt: Add an encoding name of gb18030, since I saw mention of it in bug 3002016.

2002-08-19  Darin Adler  <darin@apple.com>

	Support so that WebKit can tab into a web view's fields.

        * kwq/KWQKHTMLPartImpl.h: Made another nextKeyView() version public.
        * kwq/WebCoreBridge.h: Add new methods, change parameters to one existing one.
        * kwq/WebCoreBridge.mm:
        (-[WebCoreBridge createKHTMLViewWithNSView:marginWidth:marginHeight:]):
	Remove width and height parameters. The passed-in view already has the correct
	width and height.
        (-[WebCoreBridge nextKeyView]): Call nextKeyView() with node == 0.
        (-[WebCoreBridge previousKeyView]): Call nextKeyView() with node == 0.

2002-08-19  Darin Adler  <darin@apple.com>

	First cut at implementation of "tab to change focus": Lots of loose ends, but it's
	going well.

        * kwq/KWQNSTextField.h: Change initWithWidget to initWithQLineEdit.
        * kwq/KWQNSTextField.mm:
        (-[KWQNSTextField initWithQLineEdit:]): Keep a QLineEdit pointer so we don't cast later.
        (-[KWQNSTextField dealloc]): Sets widget to 0 to make nextKeyView and previousKeyView
	return nil while deallocating.
        (-[KWQNSTextField setPasswordMode:]): Pass widget when creating secure text field so it
	can handle the next/previous links properly.
        (-[KWQNSTextField nextKeyView]): Added. Calls KWQKHTMLPartImpl::nextKeyView.
        (-[KWQNSTextField previousKeyView]): Added. Calls KWQKHTMLPartImpl::nextKeyView.
        (-[KWQTextFieldCell isOpaque]): Added. Returns NO; fixes focus rectangle updating.
        (-[KWQSecureTextField initWithQWidget:]): Added.
        (-[KWQSecureTextField dealloc]): Added. Sets widget to 0 to make nextKeyView and
	previousKeyView return nil while deallocating.
        (-[KWQSecureTextField nextKeyView]): Added. Calls KWQKHTMLPartImpl::nextKeyView.
        (-[KWQSecureTextField previousKeyView]): Added. Calls KWQKHTMLPartImpl::nextKeyView.

        * kwq/KWQKHTMLPartImpl.h: Add KWQSelectionDirection. Change name of getBridge() to
	bridge(), getDocument() to document(), getRenderer() to renderer(), getBridgeForFrameName()
	to bridgeForFrameName(). Also added nextKeyView family of member functions.

        * kwq/KWQKHTMLPartImpl.mm:
        (KWQKHTMLPartImpl::nextKeyViewInFrame): Added.
        (KWQKHTMLPartImpl::nextKeyView): Added.

        * kwq/qt/qwidget.h: Remove unneeded parameters from constructor. Also added a
	constructor that takes an NSView.
        * kwq/KWQWidget.mm:
        (QWidget::QWidget): Don't store focus policy (it was uninitialized before).
        (QWidget::focusPolicy): Return TabFocus for any widget that has a view with a first
	responder, NoFocus for any other.
        (QWidget::setFocusPolicy): Do nothing.
        (QWidget::setFocusProxy): Do nothing.

        * kwq/qt/qobject.h: Store the event filter object when installEventFilter is called.
	This is used to find the RenderWidget for a QWidget by the new tabbing code.
        * kwq/KWQObject.mm: Removed event-filter functions. Two are now inlines, one deleted.

	Other changes related to KWQKHTMLPartImpl improvements.

        * kwq/KWQKHTMLPartBrowserExtension.mm:
        * kwq/KWQKHTMLPartImpl.mm:
        * kwq/KWQLoaderImpl.mm:
        * kwq/WebCoreBridge.mm:
	Update for KWQKHTMLPartImpl member name changes.

	Various improvements for other widget implementations.

        * kwq/qt/qbutton.h:
        * kwq/KWQButton.mm: Stop using KWQNSButton. Instead just use a button adapter
	object, and a plain old NSButton.
        (QButton::QButton): Put all the NSButton setup in here.
        (QButton::~QButton): Release the adapter here.
        (QButton::clicked): Move this in here because it's virtual now so that QCheckBox
	can override it.
        (-[KWQButtonAdapter initWithQButton:]): Added.
        (-[KWQButtonAdapter action:]): Just call clicked().

        * kwq/qt/qpushbutton.h: Don't pass unused parent pointer to QButton constructor.
        * kwq/KWQPushButton.mm: (QPushButton::QPushButton): Don't pass unused parent pointer to
	QButton contructor.

        * kwq/qt/qcheckbox.h:
        * kwq/KWQCheckBox.mm: Just use NSButton, not KWQNSButton.
        (QCheckBox::clicked): Move the state-changed logic here; used to be in KWQNSButton.

        * kwq/KWQRadioButton.mm:
        (QRadioButton::QRadioButton): Don't pass unused parent pointer to
	QButton contructor.

        * kwq/qt/qcombobox.h:
        * kwq/KWQComboBox.mm:
        (QComboBox::QComboBox): Removed extra constructor. Make a plain NSPopUpButton,
	and use an adapter object, rather than having a KWQNSComboBox.
        (QComboBox::~QComboBox): Release the adapter.
        (QComboBox::insertItem): New implementation. No need to keep an items array around,
	because the menu does that just fine.
        (QComboBox::clear): Remove the items from the pop-up button directly.
        (-[KWQComboBoxAdapter initWithQComboBox:]): Added.
        (-[KWQComboBoxAdapter action:]): Just call activated().

        * kwq/kdeui/kcombobox.h: Empty this out and make it use only inlines.

        * khtml/rendering/render_form.cpp: (RenderSelect::updateFromElement):
	Remove the setSize()/doneLoading() optimization for QComboBox because the new
	simpler QComboBox implementation obviates the speed problem this was originally
	intended to fix.

        * kwq/qt/qlineedit.h:
        * kwq/KWQLineEdit.mm: (QLineEdit::QLineEdit): Call initWithQLineEdit instead of
	initWithWidget. Also don't take an unused parent pointer parameter.

        * kwq/kdeui/klineedit.h: Empty this out and make it use only inlines.

        * kwq/qt/qframe.h: Remove unused parent pointer from constructor.
        * kwq/KWQFrame.mm: Remove unneeded constructor.
        * kwq/KWQHBox.mm: (QHBox::QHBox): Don't pass unused parent pointer to QFrame.
        * kwq/KWQLabel.mm: (QLabel::QLabel): Don't pass unused parent pointer to QFrame.
        * kwq/qt/qscrollview.h: Make constructor inline.
        * kwq/KWQScrollView.mm: Remove unneeded constructor.
        * kwq/KWQWindowWidget.h: Remove unneeded constructor.

        * WebCore.pbproj/project.pbxproj: Remove KWQKComboBox.mm, KWQKLineEdit.mm,
	and KWQScrollBar.h.
        * kwq/KWQKComboBox.mm: Removed.
        * kwq/KWQKLineEdit.mm: Removed.
        * kwq/KWQScrollBar.h: Removed. Unused.

        * kwq/KWQTextArea.h: Change initWithWidget to initWithQTextEdit.
        * kwq/KWQTextArea.mm: (-[KWQTextArea initWithQTextEdit:]): Changed name.
        * kwq/KWQTextEdit.mm: (QTextEdit::QTextEdit): Call initWithQTextEdit instead of
	initWithWidget.

        * kwq/KWQView.h: Eliminated KWQNSButton, KWQNSComboBox, and KWQNSScrollView.
        * kwq/KWQView.mm: Ditto.

	Housekeeping.

        * force-clean-timestamp: Yes, again.

        * khtml/khtml_part.h: Rearrange APPLE_CHANGES a bit.

        * kwq/qt/qvaluelist.h: Added -- as well as ++ for the const iterator, and fixed some
	minor const issues. At one point I needed this for the focus changes, but not any more.

2002-08-16  Darin Adler  <darin@apple.com>

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::userAgent):
	Call bridge's userAgentForURL: method.
        * kwq/WebCoreBridge.h: Added userAgentForURL: to the protocol

2002-08-16  Darin Adler  <darin@apple.com>

	Step 2 in adding user agent API to WebKit and WebFoundation.
	In this step, I change WebCore so that it the KWQKHTMLPartImpl
	is responsible for fetching the user agent. Later it will
	get the user agent from WebKit via the bridge.

        * khtml/ecma/kjs_navigator.cpp: (Navigator::getValueProperty):
	Get the user agent from the part, not KProtocolManager.
        * khtml/ecma/kjs_proxy.cpp: (KJSProxyImpl::initScript):
	Get the user agent from the part, not KProtocolManager.

        * kwq/KWQKHTMLPartImpl.h: Add userAgent member function.
        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::userAgent): Added.

        * WebCore.pbproj/project.pbxproj: Removed KWQKProtocolManager.mm.
        * kwq/KWQKProtocolManager.mm: Removed.
        * kwq/kio/kprotocolmanager.h: Made empty.

2002-08-16  Maciej Stachowiak  <mjs@apple.com>

        * force-clean-timestamp: Need to rebuild for JavaScriptCore changes.

2002-08-16  Darin Adler  <darin@apple.com>

	- fixed 3023851 -- screen garbage created by scrolling text

	Our implementation of clipRegion didn't reflect the clip that was
	already set for the view, so we drew outside the view. To fix it,
	I eliminated the clipRegion call and changed clients to use a new
	addClip call instead that doesn't require getting the clip in the
	form of a region (which is not really possible with CoreGraphics).

        * khtml/rendering/render_box.cpp: (RenderBox::calcClip):
	Call addClip instead of clipRegion(), intersect(), setClipRegion().

        * kwq/qt/qpainter.h: Added addClip(), removed clipRegion(), setClipRegion().
        * kwq/KWQPainter.mm: (QPainter::addClip): Calls [NSBezierPath clipRect:].

        * kwq/qt/qregion.h: Went back to a single-path implementation, since
	we don't need intersect() any more. Also removed isNull() and setClip().
        * kwq/KWQRegion.mm:
        (QRegion::QRegion): New simpler versions.
        (QRegion::~QRegion): Release the path.
        (QRegion::operator=): Copy the other path.
        (QRegion::contains): Call [containsPoint:].
        (QRegion::translate): Call [transformUsingAffineTransform:].
        (QRegion::boundingRect): Call [bounds].

2002-08-16  Darin Adler  <darin@apple.com>

	- fixed 3026042 -- hide frames button at developer documentation doesn't work

	This regression was introduced by the anchor changes we made just after
	the Alexander-15 release.

        * kwq/KWQKHTMLPartImpl.mm: (KWQKHTMLPartImpl::urlSelected):
	Make decisions about special handling for links with anchors based
	on the target frame, not the current frame.

2002-08-16  Maciej Stachowiak  <mjs@apple.com>

        * force-clean-timestamp: rebuild for JavaScriptCore changes.

2002-08-16  David Hyatt  <hyatt@apple.com>

	Fix for the intuit.com and eweek.com <form><tr> bgcolor problem.
	Improve the error handling of the parser so that it doesn't
	lose attributes when errors like this occur in a page.
	
        * khtml/html/htmlparser.cpp:
        (KHTMLParser::~KHTMLParser):
        (KHTMLParser::reset):
        (KHTMLParser::parseToken):
        (KHTMLParser::insertNode):
        * khtml/html/htmlparser.h:

2002-08-15  Darin Adler  <darin@apple.com>

	- fixed 2983959 -- pages that try to use JavaScript to focus fail to do so

        * kwq/KWQWidget.mm: (QWidget::setFocus): Call makeFirstResponder.

2002-08-15  Darin Adler  <darin@apple.com>

	Give the same good loving to the check boxes and radio buttons.
	I'm not saying our rules for where to position them are great, but
	the rules are implemented cleanly and thus easier to tweak.

	Got rid of the old Action system altogether, using signals now.

        * khtml/rendering/render_form.h: Remove now-unneeded APPLE_CHANGES.
        * khtml/rendering/render_form.cpp:
        (RenderButton::baselinePosition): All the buttons now share a single
	version of this call, since none need any special baseline hacking at
	the moment.
        (RenderSubmitButton::baselinePosition): Just call the RenderButton version.

        * kwq/KWQCheckBox.mm:
        (QCheckBox::sizeHint): Use 12x12, not 22x22.
        (QCheckBox::frameGeometry): Adjust for margins.
        (QCheckBox::setFrameGeometry): Adjust for margins.
        * kwq/KWQRadioButton.mm:
        (QRadioButton::sizeHint): Use 12x12, not 22x22.
        (QRadioButton::frameGeometry): Adjust for margins.
        (QRadioButton::setFrameGeometry): Adjust for margins.

        * kwq/qt/qcombobox.h:
        * kwq/KWQComboBox.mm: (QComboBox::QComboBox): Set up the activated signal.
        * kwq/KWQView.mm: (-[KWQNSComboBox action:]): Emit the activated signal.

        * kwq/KWQListBox.h:
        * kwq/KWQListBox.mm:
        (-[KWQBrowserDelegate browserSingleClick:]): Send a selectionChanged signal
	and a clicked signal instead of a ACTION_LISTBOX_CLICKED.
        (QListBox::QListBox): Set up the clicked and selectionChanged signals.

        * kwq/qt/qobject.h: Remove Actions, ACTION_TEXT_AREA_END_EDITING,
	ACTION_LISTBOX_CLICKED, ACTION_COMBOBOX_CLICKED, emitAction, performAction,
	and target.
        * kwq/KWQObject.mm:
        (QObject::connect): Remove the target hack, no longer needed.
        (QObject::QObject): Remove target initialization.

        * kwq/KWQSlot.mm: (KWQSlot::KWQSlot), (KWQSlot::call):
	Added selected and selectionChanged slots.

        * kwq/KWQTextArea.mm:
        (-[KWQTextArea textDidEndEditing:]): Removed code to emit the
	ACTION_TEXT_AREA_END_EDITING action, which was no longer used.

        * force-clean-timestamp: Yes, again.

2002-08-15  Darin Adler  <darin@apple.com>

	- fixed 3017376 -- button height is too tall

	Reworked how widget sizing and positioning is done for a few of the most important
	widget types.

        * khtml/rendering/render_form.h: Remove more of the performAction hackery.
        * khtml/rendering/render_form.cpp:
        (RenderCheckBox::calcMinMaxWidth): Get size from widget.
        (RenderRadioButton::calcMinMaxWidth): Get size from widget.
        (RenderSubmitButton::RenderSubmitButton): Remove old unneeded APPLE_CHANGES.
        (RenderSubmitButton::baselinePosition): Put the bottom of the button on the
	baseline without any magic numbers.
        (RenderLineEdit::baselinePosition): Put the bottom of the text field two pixels
	below the baseline without any other magic numbers.
        (RenderLineEdit::calcMinMaxWidth): Get size from widget.
        (RenderSelect::baselinePosition): Put the bottom of the menu on the
	baseline without any magic numbers. List box case is untouched for now.

        * kwq/qt/qbutton.h:
        * kwq/KWQButton.mm:
        (QButton::QButton): Move most of the setup into KWQNSButton.
        (QButton::sizeHint): Use cellSize, account for margins.
        (QButton::frameGeometry): Adjust for margins.
        (QButton::setFrameGeometry): Adjust for margins.
        * kwq/qt/qcheckbox.h:
        * kwq/KWQCheckBox.mm:
        (QCheckBox::QCheckBox): QButton takes care of most of the setup now.
        (QCheckBox::sizeHint): Added.
        (QCheckBox::frameGeometry): Adjust for margins.
        (QCheckBox::setFrameGeometry): Adjust for margins.
        * kwq/qt/qcombobox.h:
        * kwq/KWQComboBox.mm:
        (QComboBox::init): KWQNSComboBox takes care of most of the setup now.
        (QComboBox::sizeHint): Adjust for margins.
        (QComboBox::frameGeometry): Adjust for margins.
        (QComboBox::setFrameGeometry): Adjust for margins.
        * kwq/qt/qlineedit.h:
        * kwq/KWQLineEdit.mm:
        (QLineEdit::sizeForCharacterWidth): Added.
        (QLineEdit::frameGeometry): Adjust for margins.
        (QLineEdit::setFrameGeometry): Adjust for margins.
        * kwq/qt/qradiobutton.h:
        * kwq/KWQRadioButton.mm:
        (QRadioButton::QRadioButton): QButton takes care of most of the setup now.
        (QRadioButton::sizeHint): Added.
        (QRadioButton::frameGeometry): Adjust for margins.
        (QRadioButton::setFrameGeometry): Adjust for margins.

        * kwq/qt/qwidget.h:
        * kwq/KWQWidget.mm:
        (QWidget::setFrameGeometry): New name for internalSetGeometry, now public.

	- fixed 3010695 -- Slashdot.org starts with password field focused, but shouldn't

	Added KWQSecureTextField to work around the bug.

        * kwq/KWQNSTextField.h: Made formatter and other details private.
        * kwq/KWQNSTextField.mm:
